/* Generated by re2c 1.1.1 on Tue Sep 21 05:16:12 2021 */
#line 1 "tokenizer.re"
#include <limits>

#include "tokenizer.h"
#include <lfortran/bigint.h>
#include "parser.tab.hh"

namespace LFortran
{

void lex_format(unsigned char *&cur, Location &loc,
        unsigned char *&start);

void Tokenizer::set_string(const std::string &str)
{
    // The input string must be NULL terminated, otherwise the tokenizer will
    // not detect the end of string. After C++11, the std::string is guaranteed
    // to end with \0, but we check this here just in case.
    LFORTRAN_ASSERT(str[str.size()] == '\0');
    cur = (unsigned char *)(&str[0]);
    cur_line = cur;
    line_num = 1;
}

template<int base>
bool adddgt(uint64_t &u, uint64_t d)
{
    if (u > (std::numeric_limits<uint64_t>::max() - d) / base) {
        return false;
    }
    u = u * base + d;
    return true;
}

bool lex_dec(const unsigned char *s, const unsigned char *e, uint64_t &u)
{
    for (u = 0; s < e; ++s) {
        if (!adddgt<10>(u, *s - 0x30u)) {
            return false;
        }
    }
    return true;
}

// Tokenizes integer of the kind 1234_ikind into `u` and `suffix`
// s ... the start of the integer
// e ... the character after the end
bool lex_int(const unsigned char *s, const unsigned char *e, uint64_t &u,
    Str &suffix)
{
    for (u = 0; s < e; ++s) {
        if (*s == '_') {
            s++;
            suffix.p = (char*) s;
            suffix.n = e-s;
            return true;
        } else if (!adddgt<10>(u, *s - 0x30u)) {
            return false;
        }
    }
    suffix.p = nullptr;
    suffix.n = 0;
    return true;
}

void lex_int_large(Allocator &al, const unsigned char *s,
    const unsigned char *e, BigInt::BigInt &u, Str &suffix)
{
    uint64_t ui;
    if (lex_int(s, e, ui, suffix)) {
        if (ui <= BigInt::MAX_SMALL_INT) {
            u.from_smallint(ui);
            return;
        }
    }
    const unsigned char *start = s;
    for (; s < e; ++s) {
        if (*s == '_') {
            s++;
            suffix.p = (char*) s;
            suffix.n = e-s;

            Str num;
            num.p = (char*)start;
            num.n = s-start-1;
            u.from_largeint(al, num);
            return;
        }
    }
    suffix.p = nullptr;
    suffix.n = 0;
    Str num;
    num.p = (char*)start;
    num.n = e-start;
    u.from_largeint(al, num);
}

uint64_t parse_int(const unsigned char *s)
{
    while (*s == ' ') s++;
    uint64_t u;
    for (u = 0; ; ++s) {
        if (*s >= '0' && *s <= '9') {
            if (!adddgt<10>(u, *s - 0x30u)) {
                return false;
            }
        } else {
            return u;
        }
    }
}

#define KW(x) token(yylval.string); RET(KW_##x);
#define RET(x) token_loc(loc); last_token=yytokentype::x; return yytokentype::x;

int Tokenizer::lex(Allocator &al, YYSTYPE &yylval, Location &loc)
{
    if (enddo_state == 1) {
        enddo_state = 2;
        KW(END_DO)
    } else if (enddo_state == 2) {
        enddo_insert_count--;
        if (enddo_insert_count > 0) {
            enddo_state = 1;
        } else {
            enddo_state = 0;
            token_loc(loc); line_num++; cur_line=cur;
            last_token = yytokentype::TK_NEWLINE;
        }
        return yytokentype::TK_NEWLINE;
    }
    for (;;) {
        tok = cur;

        /*
        Re2c has excellent documentation at:

        https://re2c.org/manual/manual_c.html

        The first paragraph there explains the basics:

        * If multiple rules match, the longest match takes precedence
        * If multiple rules match the same string, the earlier rule takes
          precedence
        * Default rule `*` should always be defined, it has the lowest priority
          regardless of its place and matches any code unit
        * We use the "Sentinel character" method for end of input:
            * The end of the input text is denoted with a null character \x00
            * Thus the null character cannot be part of the input otherwise
            * There is one rule to match \x00 to end the parser
            * No other rule is allowed to match \x00, otherwise the re2c block
              would parse past the end of the string and segfaults
            * A special case of the previous point are negated character
              ranges, such as [^"\x00], where one must include \x00 in it to
              ensure this rule does not match \x00 (all other rules simply do
              not mention \x00)
            * See the "Handling the end of input" section in the re2c
              documentation for more info

        The re2c block interacts with the rest of the code via just one pointer
        variable `cur`. On entering the re2c block, the `cur` variable must
        point to the first character of the token to be tokenized by the block.
        The re2c block below then executes on its own until a rule is matched:
        the action in {} is then executed. In that action `cur` points to the
        first character of the next token.

        Before the re2c block we save the current `cur` into `tok`, so that we
        can use `tok` and `cur` in the action in {} to extract the token that
        corresponds to the rule that got matched:

        * `tok` points to the first character of the token
        * `cur-1` points to the last character of the token
        * `cur` points to the first character of the next token
        * `cur-tok` is the length of the token

        In the action, we do one of:

        * call `continue` which executes another cycle in the for loop (which
          will parse the next token); we use this to skip a token
        * call `return` which returns from this function; we return a token
        * throw an exception (terminates the tokenizer)

        In the first two cases, `cur` points to first character of the next
        token, which becomes `tok` at the next iteration of the loop (either
        right away after `continue` or after the `lex` function is called again
        after `return`).

        See the manual for more details.
        */


        // These two variables are needed by the re2c block below internally,
        // initialization is not needed. One can think of them as local
        // variables of the re2c block.
        unsigned char *mar, *ctxmar;
        
#line 199 "tokenizer.cpp"
{
	unsigned char yych;
	unsigned int yyaccept = 0;
	static const unsigned char yybm[] = {
		/* table 1 .. 8: 0 */
		  0,   2,   2,   2,   2,   2,   2,   2, 
		  2,   3,   3,   3,   2,   3,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		  3,   2,   2,   2,   2,   2,   2,   0, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		242, 242, 210, 210, 210, 210, 210, 210, 
		146, 146,   2,   2,   2,   2,   2,   2, 
		  2, 150, 150, 150, 150, 150, 150,  22, 
		 22,  22,  22,  22,  22,  22,  22,  22, 
		 22,  22,  22,  22,  22,  22,  22,  22, 
		 22,  22,  22,   2,   2,   2,   2,  26, 
		  2, 150, 150, 150, 150, 150, 150,  22, 
		 22,  22,  22,  22,  22,  22,  22,  22, 
		 22,  22,  22,  22,  22,  22,  22,  22, 
		 22,  22,  22,   2,   2,   2,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		  2,   2,   2,   2,   2,   2,   2,   2, 
		/* table 9 .. 13: 256 */
		  0, 192, 192, 192, 192, 192, 192, 192, 
		192, 200, 128, 200, 192, 200, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		200, 192,  64, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		240, 240, 240, 240, 240, 240, 240, 240, 
		240, 240, 192, 192, 192, 192, 192, 192, 
		192, 224, 224, 224, 224, 224, 224, 224, 
		224, 224, 224, 224, 224, 224, 224, 224, 
		224, 224, 224, 224, 224, 224, 224, 224, 
		224, 224, 224, 192, 192, 192, 192, 192, 
		192, 224, 224, 224, 224, 224, 224, 224, 
		224, 224, 224, 224, 224, 224, 224, 224, 
		224, 224, 224, 224, 224, 224, 224, 224, 
		224, 224, 224, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
		192, 192, 192, 192, 192, 192, 192, 192, 
	};
	yych = *cur;
	if (yybm[256+yych] & 8) {
		goto yy6;
	}
	switch (yych) {
	case 0x00:	goto yy2;
	case '\t':
	case '\n':	goto yy9;
	case ' ':
	case '!':	goto yy11;
	case '"':	goto yy12;
	case '#':	goto yy13;
	case '%':	goto yy14;
	case '&':	goto yy16;
	case '\'':	goto yy17;
	case '(':	goto yy18;
	case ')':	goto yy20;
	case '*':	goto yy22;
	case '+':	goto yy24;
	case ',':	goto yy26;
	case '-':	goto yy28;
	case '.':	goto yy30;
	case '/':	goto yy31;
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':	goto yy33;
	case ':':	goto yy36;
	case ';':	goto yy38;
	case '<':	goto yy40;
	case '=':	goto yy42;
	case '>':	goto yy44;
	case 'A':
	case 'a':	goto yy46;
	case 'B':
	case 'b':	goto yy48;
	case 'C':
	case 'c':	goto yy49;
	case 'D':
	case 'd':	goto yy50;
	case 'E':
	case 'e':	goto yy51;
	case 'F':
	case 'f':	goto yy52;
	case 'G':
	case 'g':	goto yy53;
	case 'H':
	case 'J':
	case 'X':
	case 'Y':
	case '_':
	case 'h':
	case 'j':
	case 'x':
	case 'y':	goto yy54;
	case 'I':
	case 'i':	goto yy56;
	case 'K':
	case 'k':	goto yy57;
	case 'L':
	case 'l':	goto yy58;
	case 'M':
	case 'm':	goto yy59;
	case 'N':
	case 'n':	goto yy60;
	case 'O':
	case 'o':	goto yy61;
	case 'P':
	case 'p':	goto yy62;
	case 'Q':
	case 'q':	goto yy63;
	case 'R':
	case 'r':	goto yy64;
	case 'S':
	case 's':	goto yy65;
	case 'T':
	case 't':	goto yy66;
	case 'U':
	case 'u':	goto yy67;
	case 'V':
	case 'v':	goto yy68;
	case 'W':
	case 'w':	goto yy69;
	case 'Z':
	case 'z':	goto yy70;
	case '[':	goto yy71;
	case ']':	goto yy73;
	case '|':	goto yy75;
	default:	goto yy4;
	}
yy2:
	++cur;
#line 224 "tokenizer.re"
	{ RET(END_OF_FILE); }
#line 371 "tokenizer.cpp"
yy4:
	++cur;
yy5:
#line 219 "tokenizer.re"
	{ token_loc(loc);
                std::string t = token();
                throw LFortran::TokenizerError("token '" + t
                    + "' is not recognized", loc, t);
            }
#line 381 "tokenizer.cpp"
yy6:
	yych = *++cur;
	if (yybm[256+yych] & 8) {
		goto yy6;
	}
#line 225 "tokenizer.re"
	{ continue; }
#line 389 "tokenizer.cpp"
yy9:
	++cur;
#line 476 "tokenizer.re"
	{
                if (enddo_newline_process) {
                    enddo_newline_process = false;
                    enddo_state = 1;
                    return yytokentype::TK_NEWLINE;
                } else {
                    enddo_newline_process = false;
                    enddo_insert_count = 0;
                    token_loc(loc); line_num++; cur_line=cur;
                    last_token = yytokentype::TK_NEWLINE;
                    return yytokentype::TK_NEWLINE;
                }
            }
#line 406 "tokenizer.cpp"
yy11:
	yyaccept = 0;
	yych = *(mar = ++cur);
	if (yych <= 0x00) goto yy5;
	goto yy78;
yy12:
	yyaccept = 0;
	yych = *(mar = ++cur);
	if (yych <= 0x00) goto yy5;
	goto yy83;
yy13:
	yyaccept = 0;
	yych = *(mar = ++cur);
	if (yych <= 0x00) goto yy5;
	goto yy87;
yy14:
	++cur;
#line 509 "tokenizer.re"
	{ RET(TK_PERCENT) }
#line 426 "tokenizer.cpp"
yy16:
	yyaccept = 0;
	yych = *(mar = ++cur);
	if (yych <= '\f') {
		if (yych <= 0x08) goto yy5;
		if (yych <= '\v') goto yy91;
		goto yy5;
	} else {
		if (yych <= '\r') goto yy91;
		if (yych <= 0x1F) goto yy5;
		if (yych <= '!') goto yy91;
		goto yy5;
	}
yy17:
	yyaccept = 0;
	yych = *(mar = ++cur);
	if (yych <= 0x00) goto yy5;
	goto yy98;
yy18:
	yych = *++cur;
	if (yych == '/') {
		ctxmar = cur;
		goto yy101;
	}
#line 491 "tokenizer.re"
	{ RET(TK_LPAREN) }
#line 453 "tokenizer.cpp"
yy20:
	++cur;
#line 499 "tokenizer.re"
	{ RET(TK_RPAREN) }
#line 458 "tokenizer.cpp"
yy22:
	yych = *++cur;
	if (yych == '*') goto yy102;
#line 511 "tokenizer.re"
	{ RET(TK_STAR) }
#line 464 "tokenizer.cpp"
yy24:
	++cur;
#line 503 "tokenizer.re"
	{ RET(TK_PLUS) }
#line 469 "tokenizer.cpp"
yy26:
	++cur;
#line 510 "tokenizer.re"
	{ RET(TK_COMMA) }
#line 474 "tokenizer.cpp"
yy28:
	++cur;
#line 504 "tokenizer.re"
	{ RET(TK_MINUS) }
#line 479 "tokenizer.cpp"
yy30:
	yyaccept = 0;
	yych = *(mar = ++cur);
	switch (yych) {
	case '.':	goto yy104;
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':	goto yy106;
	case 'A':
	case 'a':	goto yy109;
	case 'B':
	case 'C':
	case 'D':
	case 'H':
	case 'I':
	case 'J':
	case 'K':
	case 'M':
	case 'P':
	case 'Q':
	case 'R':
	case 'S':
	case 'U':
	case 'V':
	case 'W':
	case 'X':
	case 'Y':
	case 'Z':
	case 'b':
	case 'c':
	case 'd':
	case 'h':
	case 'i':
	case 'j':
	case 'k':
	case 'm':
	case 'p':
	case 'q':
	case 'r':
	case 's':
	case 'u':
	case 'v':
	case 'w':
	case 'x':
	case 'y':
	case 'z':	goto yy110;
	case 'E':
	case 'e':	goto yy112;
	case 'F':
	case 'f':	goto yy113;
	case 'G':
	case 'g':	goto yy114;
	case 'L':
	case 'l':	goto yy115;
	case 'N':
	case 'n':	goto yy116;
	case 'O':
	case 'o':	goto yy117;
	case 'T':
	case 't':	goto yy118;
	default:	goto yy5;
	}
yy31:
	yych = *++cur;
	if (yych <= '.') {
		if (yych == ')') goto yy119;
	} else {
		if (yych <= '/') goto yy121;
		if (yych == '=') goto yy123;
	}
#line 508 "tokenizer.re"
	{ RET(TK_SLASH) }
#line 559 "tokenizer.cpp"
yy33:
	yyaccept = 1;
	yych = *(mar = ++cur);
	if (yybm[256+yych] & 16) {
		goto yy33;
	}
	if (yych <= ' ') {
		if (yych <= '\v') {
			if (yych == '\t') {
				ctxmar = cur;
				goto yy125;
			}
			if (yych >= '\v') {
				ctxmar = cur;
				goto yy125;
			}
		} else {
			if (yych == '\r') {
				ctxmar = cur;
				goto yy125;
			}
			if (yych >= ' ') {
				ctxmar = cur;
				goto yy125;
			}
		}
	} else {
		if (yych <= 'E') {
			if (yych == '.') {
				ctxmar = cur;
				goto yy127;
			}
			if (yych >= 'D') goto yy128;
		} else {
			if (yych <= '_') {
				if (yych >= '_') goto yy129;
			} else {
				if (yych <= 'c') goto yy35;
				if (yych <= 'e') goto yy128;
			}
		}
	}
yy35:
#line 583 "tokenizer.re"
	{
                lex_int_large(al, tok, cur,
                    yylval.int_suffix.int_n,
                    yylval.int_suffix.int_kind);
                RET(TK_INTEGER)
            }
#line 610 "tokenizer.cpp"
yy36:
	yych = *++cur;
	if (yych == ':') goto yy130;
#line 506 "tokenizer.re"
	{ RET(TK_COLON) }
#line 616 "tokenizer.cpp"
yy38:
	++cur;
#line 507 "tokenizer.re"
	{ RET(TK_SEMICOLON) }
#line 621 "tokenizer.cpp"
yy40:
	yych = *++cur;
	if (yych == '=') goto yy132;
yy41:
#line 524 "tokenizer.re"
	{ RET(TK_LT) }
#line 628 "tokenizer.cpp"
yy42:
	yych = *++cur;
	if (yych <= '<') goto yy43;
	if (yych <= '=') goto yy134;
	if (yych <= '>') goto yy136;
yy43:
#line 505 "tokenizer.re"
	{ RET(TK_EQUAL) }
#line 637 "tokenizer.cpp"
yy44:
	yych = *++cur;
	if (yych == '=') goto yy138;
yy45:
#line 526 "tokenizer.re"
	{ RET(TK_GT) }
#line 644 "tokenizer.cpp"
yy46:
	yych = *++cur;
	if (yych <= 'S') {
		if (yych <= 'K') {
			if (yych == 'B') goto yy140;
			goto yy55;
		} else {
			if (yych <= 'L') goto yy141;
			if (yych <= 'R') goto yy55;
			goto yy142;
		}
	} else {
		if (yych <= 'k') {
			if (yych == 'b') goto yy140;
			goto yy55;
		} else {
			if (yych <= 'l') goto yy141;
			if (yych == 's') goto yy142;
			goto yy55;
		}
	}
yy47:
#line 625 "tokenizer.re"
	{ token(yylval.string); RET(TK_NAME) }
#line 669 "tokenizer.cpp"
yy48:
	yyaccept = 2;
	yych = *(mar = ++cur);
	if (yych <= 'I') {
		if (yych <= '\'') {
			if (yych == '"') goto yy145;
			if (yych <= '&') goto yy55;
			goto yy146;
		} else {
			if (yych == 'A') goto yy147;
			if (yych <= 'H') goto yy55;
			goto yy148;
		}
	} else {
		if (yych <= 'a') {
			if (yych == 'L') goto yy149;
			if (yych <= '`') goto yy55;
			goto yy147;
		} else {
			if (yych <= 'i') {
				if (yych <= 'h') goto yy55;
				goto yy148;
			} else {
				if (yych == 'l') goto yy149;
				goto yy55;
			}
		}
	}
yy49:
	yych = *++cur;
	switch (yych) {
	case 'A':
	case 'a':	goto yy150;
	case 'H':
	case 'h':	goto yy151;
	case 'L':
	case 'l':	goto yy152;
	case 'O':
	case 'o':	goto yy153;
	case 'R':
	case 'r':	goto yy154;
	case 'Y':
	case 'y':	goto yy155;
	default:	goto yy55;
	}
yy50:
	yych = *++cur;
	if (yych <= 'O') {
		if (yych <= 'E') {
			if (yych == 'A') goto yy156;
			if (yych <= 'D') goto yy55;
			goto yy157;
		} else {
			if (yych == 'I') goto yy158;
			if (yych <= 'N') goto yy55;
			goto yy159;
		}
	} else {
		if (yych <= 'e') {
			if (yych == 'a') goto yy156;
			if (yych <= 'd') goto yy55;
			goto yy157;
		} else {
			if (yych <= 'i') {
				if (yych <= 'h') goto yy55;
				goto yy158;
			} else {
				if (yych == 'o') goto yy159;
				goto yy55;
			}
		}
	}
yy51:
	yych = *++cur;
	switch (yych) {
	case 'L':
	case 'l':	goto yy161;
	case 'N':
	case 'n':	goto yy162;
	case 'Q':
	case 'q':	goto yy163;
	case 'R':
	case 'r':	goto yy164;
	case 'V':
	case 'v':	goto yy165;
	case 'X':
	case 'x':	goto yy166;
	default:	goto yy55;
	}
yy52:
	yych = *++cur;
	switch (yych) {
	case 'I':
	case 'i':	goto yy167;
	case 'L':
	case 'l':	goto yy168;
	case 'O':
	case 'o':	goto yy169;
	case 'U':
	case 'u':	goto yy170;
	default:	goto yy55;
	}
yy53:
	yych = *++cur;
	if (yych <= 'O') {
		if (yych == 'E') goto yy171;
		if (yych <= 'N') goto yy55;
		goto yy172;
	} else {
		if (yych <= 'e') {
			if (yych <= 'd') goto yy55;
			goto yy171;
		} else {
			if (yych == 'o') goto yy172;
			goto yy55;
		}
	}
yy54:
	yych = *++cur;
yy55:
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
	goto yy47;
yy56:
	yych = *++cur;
	if (yych <= 'S') {
		if (yych <= 'L') {
			if (yych == 'F') goto yy174;
			goto yy55;
		} else {
			if (yych <= 'M') goto yy176;
			if (yych <= 'N') goto yy177;
			if (yych <= 'R') goto yy55;
			goto yy179;
		}
	} else {
		if (yych <= 'm') {
			if (yych == 'f') goto yy174;
			if (yych <= 'l') goto yy55;
			goto yy176;
		} else {
			if (yych <= 'n') goto yy177;
			if (yych == 's') goto yy179;
			goto yy55;
		}
	}
yy57:
	yych = *++cur;
	if (yych == 'I') goto yy181;
	if (yych == 'i') goto yy181;
	goto yy55;
yy58:
	yych = *++cur;
	if (yych <= 'O') {
		if (yych == 'E') goto yy182;
		if (yych <= 'N') goto yy55;
		goto yy183;
	} else {
		if (yych <= 'e') {
			if (yych <= 'd') goto yy55;
			goto yy182;
		} else {
			if (yych == 'o') goto yy183;
			goto yy55;
		}
	}
yy59:
	yych = *++cur;
	if (yych <= 'O') {
		if (yych == 'E') goto yy184;
		if (yych <= 'N') goto yy55;
		goto yy185;
	} else {
		if (yych <= 'e') {
			if (yych <= 'd') goto yy55;
			goto yy184;
		} else {
			if (yych == 'o') goto yy185;
			goto yy55;
		}
	}
yy60:
	yych = *++cur;
	if (yych <= 'U') {
		if (yych <= 'E') {
			if (yych == 'A') goto yy186;
			if (yych <= 'D') goto yy55;
			goto yy187;
		} else {
			if (yych == 'O') goto yy188;
			if (yych <= 'T') goto yy55;
			goto yy189;
		}
	} else {
		if (yych <= 'e') {
			if (yych == 'a') goto yy186;
			if (yych <= 'd') goto yy55;
			goto yy187;
		} else {
			if (yych <= 'o') {
				if (yych <= 'n') goto yy55;
				goto yy188;
			} else {
				if (yych == 'u') goto yy189;
				goto yy55;
			}
		}
	}
yy61:
	yyaccept = 2;
	yych = *(mar = ++cur);
	if (yych <= 'P') {
		if (yych <= '\'') {
			if (yych == '"') goto yy190;
			if (yych <= '&') goto yy55;
			goto yy191;
		} else {
			if (yych == 'N') goto yy192;
			if (yych <= 'O') goto yy55;
			goto yy193;
		}
	} else {
		if (yych <= 'n') {
			if (yych == 'U') goto yy194;
			if (yych <= 'm') goto yy55;
			goto yy192;
		} else {
			if (yych <= 'p') {
				if (yych <= 'o') goto yy55;
				goto yy193;
			} else {
				if (yych == 'u') goto yy194;
				goto yy55;
			}
		}
	}
yy62:
	yych = *++cur;
	if (yych <= 'U') {
		if (yych <= 'O') {
			if (yych == 'A') goto yy195;
			if (yych <= 'N') goto yy55;
			goto yy196;
		} else {
			if (yych == 'R') goto yy197;
			if (yych <= 'T') goto yy55;
			goto yy198;
		}
	} else {
		if (yych <= 'o') {
			if (yych == 'a') goto yy195;
			if (yych <= 'n') goto yy55;
			goto yy196;
		} else {
			if (yych <= 'r') {
				if (yych <= 'q') goto yy55;
				goto yy197;
			} else {
				if (yych == 'u') goto yy198;
				goto yy55;
			}
		}
	}
yy63:
	yych = *++cur;
	if (yych == 'U') goto yy199;
	if (yych == 'u') goto yy199;
	goto yy55;
yy64:
	yych = *++cur;
	if (yych <= 'E') {
		if (yych == 'A') goto yy200;
		if (yych <= 'D') goto yy55;
		goto yy201;
	} else {
		if (yych <= 'a') {
			if (yych <= '`') goto yy55;
			goto yy200;
		} else {
			if (yych == 'e') goto yy201;
			goto yy55;
		}
	}
yy65:
	yych = *++cur;
	switch (yych) {
	case 'A':
	case 'a':	goto yy202;
	case 'E':
	case 'e':	goto yy203;
	case 'H':
	case 'h':	goto yy204;
	case 'O':
	case 'o':	goto yy205;
	case 'T':
	case 't':	goto yy206;
	case 'U':
	case 'u':	goto yy207;
	case 'Y':
	case 'y':	goto yy208;
	default:	goto yy55;
	}
yy66:
	yych = *++cur;
	switch (yych) {
	case 'A':
	case 'a':	goto yy209;
	case 'E':
	case 'e':	goto yy210;
	case 'H':
	case 'h':	goto yy211;
	case 'O':
	case 'o':	goto yy212;
	case 'Y':
	case 'y':	goto yy214;
	default:	goto yy55;
	}
yy67:
	yych = *++cur;
	if (yych <= 'S') {
		if (yych == 'N') goto yy215;
		if (yych <= 'R') goto yy55;
		goto yy216;
	} else {
		if (yych <= 'n') {
			if (yych <= 'm') goto yy55;
			goto yy215;
		} else {
			if (yych == 's') goto yy216;
			goto yy55;
		}
	}
yy68:
	yych = *++cur;
	if (yych <= 'O') {
		if (yych == 'A') goto yy217;
		if (yych <= 'N') goto yy55;
		goto yy218;
	} else {
		if (yych <= 'a') {
			if (yych <= '`') goto yy55;
			goto yy217;
		} else {
			if (yych == 'o') goto yy218;
			goto yy55;
		}
	}
yy69:
	yych = *++cur;
	if (yych <= 'R') {
		if (yych <= 'G') {
			if (yych == 'A') goto yy219;
			goto yy55;
		} else {
			if (yych <= 'H') goto yy220;
			if (yych <= 'Q') goto yy55;
			goto yy221;
		}
	} else {
		if (yych <= 'g') {
			if (yych == 'a') goto yy219;
			goto yy55;
		} else {
			if (yych <= 'h') goto yy220;
			if (yych == 'r') goto yy221;
			goto yy55;
		}
	}
yy70:
	yyaccept = 2;
	yych = *(mar = ++cur);
	if (yych == '"') goto yy222;
	if (yych == '\'') goto yy223;
	goto yy55;
yy71:
	++cur;
yy72:
#line 500 "tokenizer.re"
	{ RET(TK_LBRACKET) }
#line 1051 "tokenizer.cpp"
yy73:
	++cur;
#line 501 "tokenizer.re"
	{ RET(TK_RBRACKET) }
#line 1056 "tokenizer.cpp"
yy75:
	++cur;
#line 512 "tokenizer.re"
	{ RET(TK_VBAR) }
#line 1061 "tokenizer.cpp"
yy77:
	yych = *++cur;
yy78:
	if (yybm[256+yych] & 64) {
		goto yy77;
	}
	if (yych >= 0x01) goto yy80;
yy79:
	cur = mar;
	if (yyaccept <= 8) {
		if (yyaccept <= 4) {
			if (yyaccept <= 2) {
				if (yyaccept <= 1) {
					if (yyaccept == 0) {
						goto yy5;
					} else {
						goto yy35;
					}
				} else {
					goto yy47;
				}
			} else {
				if (yyaccept == 3) {
					goto yy85;
				} else {
					goto yy94;
				}
			}
		} else {
			if (yyaccept <= 6) {
				if (yyaccept == 5) {
					goto yy100;
				} else {
					goto yy72;
				}
			} else {
				if (yyaccept == 7) {
					goto yy108;
				} else {
					goto yy160;
				}
			}
		}
	} else {
		if (yyaccept <= 13) {
			if (yyaccept <= 11) {
				if (yyaccept <= 10) {
					if (yyaccept == 9) {
						goto yy178;
					} else {
						goto yy292;
					}
				} else {
					goto yy742;
				}
			} else {
				if (yyaccept == 12) {
					goto yy889;
				} else {
					goto yy965;
				}
			}
		} else {
			if (yyaccept <= 15) {
				if (yyaccept == 14) {
					goto yy1064;
				} else {
					goto yy1150;
				}
			} else {
				if (yyaccept == 16) {
					goto yy1268;
				} else {
					goto yy1270;
				}
			}
		}
	}
yy80:
	++cur;
#line 601 "tokenizer.re"
	{
                line_num++; cur_line=cur;
                token(yylval.string);
                yylval.string.n--;
                token_loc(loc);
                if (last_token == yytokentype::TK_NEWLINE) {
                    return yytokentype::TK_COMMENT;
                } else {
                    last_token=yytokentype::TK_NEWLINE;
                    return yytokentype::TK_EOLCOMMENT;
                }
            }
#line 1155 "tokenizer.cpp"
yy82:
	yych = *++cur;
yy83:
	if (yybm[256+yych] & 128) {
		goto yy82;
	}
	if (yych <= 0x00) goto yy79;
	yyaccept = 3;
	yych = *(mar = ++cur);
	if (yych == '"') goto yy82;
yy85:
#line 621 "tokenizer.re"
	{ token_str(yylval.string); RET(TK_STRING) }
#line 1169 "tokenizer.cpp"
yy86:
	yych = *++cur;
yy87:
	if (yych <= 0x00) goto yy79;
	if (yych != '\n') goto yy86;
	++cur;
#line 615 "tokenizer.re"
	{ line_num++; cur_line=cur; continue; }
#line 1178 "tokenizer.cpp"
yy90:
	yych = *++cur;
yy91:
	if (yych <= '\f') {
		if (yych <= '\t') {
			if (yych <= 0x08) goto yy79;
			goto yy90;
		} else {
			if (yych <= '\n') goto yy92;
			if (yych <= '\v') goto yy90;
			goto yy79;
		}
	} else {
		if (yych <= 0x1F) {
			if (yych <= '\r') goto yy90;
			goto yy79;
		} else {
			if (yych <= ' ') goto yy90;
			if (yych <= '!') goto yy95;
			goto yy79;
		}
	}
yy92:
	yyaccept = 4;
	yych = *(mar = ++cur);
	if (yybm[0+yych] & 1) {
		goto yy92;
	}
	if (yych <= 0x1F) goto yy94;
	if (yych <= '!') goto yy95;
	if (yych == '&') goto yy224;
yy94:
#line 597 "tokenizer.re"
	{
                line_num++; cur_line=cur; continue;
            }
#line 1215 "tokenizer.cpp"
yy95:
	yych = *++cur;
	if (yych <= 0x00) goto yy79;
	if (yych == '\n') goto yy92;
	goto yy95;
yy97:
	yych = *++cur;
yy98:
	if (yybm[0+yych] & 2) {
		goto yy97;
	}
	if (yych <= 0x00) goto yy79;
	yyaccept = 5;
	yych = *(mar = ++cur);
	if (yych == '\'') goto yy97;
yy100:
#line 622 "tokenizer.re"
	{ token_str(yylval.string); RET(TK_STRING) }
#line 1234 "tokenizer.cpp"
yy101:
	yyaccept = 6;
	yych = *(mar = ++cur);
	if (yych <= 0x1F) {
		if (yych <= '\n') {
			if (yych == '\t') goto yy225;
			goto yy72;
		} else {
			if (yych == '\f') goto yy72;
			if (yych <= '\r') goto yy225;
			goto yy72;
		}
	} else {
		if (yych <= '.') {
			if (yych <= ' ') goto yy225;
			if (yych == ')') goto yy227;
			goto yy72;
		} else {
			if (yych <= '/') goto yy229;
			if (yych == '=') goto yy230;
			goto yy72;
		}
	}
yy102:
	++cur;
#line 517 "tokenizer.re"
	{ RET(TK_POW) }
#line 1262 "tokenizer.cpp"
yy104:
	++cur;
#line 515 "tokenizer.re"
	{ RET(TK_DBL_DOT) }
#line 1267 "tokenizer.cpp"
yy106:
	yyaccept = 7;
	yych = *(mar = ++cur);
yy107:
	if (yych <= 'E') {
		if (yych <= '/') goto yy108;
		if (yych <= '9') goto yy106;
		if (yych >= 'D') goto yy128;
	} else {
		if (yych <= '_') {
			if (yych >= '_') goto yy232;
		} else {
			if (yych <= 'c') goto yy108;
			if (yych <= 'e') goto yy128;
		}
	}
yy108:
#line 554 "tokenizer.re"
	{ token(yylval.string); RET(TK_REAL) }
#line 1287 "tokenizer.cpp"
yy109:
	yych = *++cur;
	if (yych == 'N') goto yy235;
	if (yych == 'n') goto yy235;
	goto yy111;
yy110:
	yych = *++cur;
yy111:
	if (yybm[0+yych] & 4) {
		goto yy110;
	}
	if (yych == '.') goto yy233;
	goto yy79;
yy112:
	yych = *++cur;
	if (yych == 'Q') goto yy236;
	if (yych == 'q') goto yy236;
	goto yy111;
yy113:
	yych = *++cur;
	if (yych == 'A') goto yy237;
	if (yych == 'a') goto yy237;
	goto yy111;
yy114:
	yych = *++cur;
	if (yych <= 'T') {
		if (yych == 'E') goto yy238;
		if (yych <= 'S') goto yy111;
		goto yy239;
	} else {
		if (yych <= 'e') {
			if (yych <= 'd') goto yy111;
			goto yy238;
		} else {
			if (yych == 't') goto yy239;
			goto yy111;
		}
	}
yy115:
	yych = *++cur;
	if (yych <= 'T') {
		if (yych == 'E') goto yy240;
		if (yych <= 'S') goto yy111;
		goto yy241;
	} else {
		if (yych <= 'e') {
			if (yych <= 'd') goto yy111;
			goto yy240;
		} else {
			if (yych == 't') goto yy241;
			goto yy111;
		}
	}
yy116:
	yych = *++cur;
	if (yych <= 'O') {
		if (yych == 'E') goto yy242;
		if (yych <= 'N') goto yy111;
		goto yy243;
	} else {
		if (yych <= 'e') {
			if (yych <= 'd') goto yy111;
			goto yy242;
		} else {
			if (yych == 'o') goto yy243;
			goto yy111;
		}
	}
yy117:
	yych = *++cur;
	if (yych == 'R') goto yy244;
	if (yych == 'r') goto yy244;
	goto yy111;
yy118:
	yych = *++cur;
	if (yych == 'R') goto yy245;
	if (yych == 'r') goto yy245;
	goto yy111;
yy119:
	++cur;
#line 502 "tokenizer.re"
	{ RET(TK_RBRACKET_OLD) }
#line 1370 "tokenizer.cpp"
yy121:
	++cur;
#line 518 "tokenizer.re"
	{ RET(TK_CONCAT) }
#line 1375 "tokenizer.cpp"
yy123:
	++cur;
#line 523 "tokenizer.re"
	{ RET(TK_NE) }
#line 1380 "tokenizer.cpp"
yy125:
	yych = *++cur;
	if (yych <= 0x1F) {
		if (yych <= '\n') {
			if (yych == '\t') goto yy125;
			goto yy79;
		} else {
			if (yych == '\f') goto yy79;
			if (yych <= '\r') goto yy125;
			goto yy79;
		}
	} else {
		if (yych <= '^') {
			if (yych <= ' ') goto yy125;
			if (yych <= '@') goto yy79;
			if (yych <= 'Z') goto yy246;
			goto yy79;
		} else {
			if (yych == '`') goto yy79;
			if (yych <= 'z') goto yy246;
			goto yy79;
		}
	}
yy127:
	yyaccept = 7;
	yych = *(mar = ++cur);
	if (yych <= 'Z') {
		if (yych <= '@') goto yy107;
		if (yych <= 'C') goto yy249;
		if (yych <= 'E') goto yy251;
		goto yy249;
	} else {
		if (yych <= 'c') {
			if (yych <= '`') goto yy107;
			goto yy249;
		} else {
			if (yych <= 'e') goto yy251;
			if (yych <= 'z') goto yy249;
			goto yy107;
		}
	}
yy128:
	yych = *++cur;
	if (yych <= ',') {
		if (yych == '+') goto yy252;
		goto yy79;
	} else {
		if (yych <= '-') goto yy252;
		if (yych <= '/') goto yy79;
		if (yych <= '9') goto yy253;
		goto yy79;
	}
yy129:
	yych = *++cur;
	if (yych <= '9') {
		if (yych <= '&') {
			if (yych == '"') goto yy82;
			goto yy79;
		} else {
			if (yych <= '\'') goto yy97;
			if (yych <= '/') goto yy79;
			goto yy255;
		}
	} else {
		if (yych <= '^') {
			if (yych <= '@') goto yy79;
			if (yych <= 'Z') goto yy257;
			goto yy79;
		} else {
			if (yych == '`') goto yy79;
			if (yych <= 'z') goto yy257;
			goto yy79;
		}
	}
yy130:
	++cur;
#line 516 "tokenizer.re"
	{ RET(TK_DBL_COLON) }
#line 1459 "tokenizer.cpp"
yy132:
	++cur;
#line 525 "tokenizer.re"
	{ RET(TK_LE) }
#line 1464 "tokenizer.cpp"
yy134:
	++cur;
#line 522 "tokenizer.re"
	{ RET(TK_EQ) }
#line 1469 "tokenizer.cpp"
yy136:
	++cur;
#line 519 "tokenizer.re"
	{ RET(TK_ARROW) }
#line 1474 "tokenizer.cpp"
yy138:
	++cur;
#line 527 "tokenizer.re"
	{ RET(TK_GE) }
#line 1479 "tokenizer.cpp"
yy140:
	yych = *++cur;
	if (yych == 'S') goto yy259;
	if (yych == 's') goto yy259;
	goto yy55;
yy141:
	yych = *++cur;
	if (yych == 'L') goto yy260;
	if (yych == 'l') goto yy260;
	goto yy55;
yy142:
	yych = *++cur;
	if (yych <= 'Y') {
		if (yych == 'S') goto yy262;
		if (yych <= 'X') goto yy55;
		goto yy263;
	} else {
		if (yych <= 's') {
			if (yych <= 'r') goto yy55;
			goto yy262;
		} else {
			if (yych == 'y') goto yy263;
			goto yy55;
		}
	}
yy143:
	yyaccept = 2;
	yych = *(mar = ++cur);
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych <= '&') {
		if (yych == '"') goto yy82;
		goto yy47;
	} else {
		if (yych <= '\'') goto yy97;
		if (yych == '_') goto yy143;
		goto yy47;
	}
yy145:
	yych = *++cur;
	if (yybm[0+yych] & 32) {
		goto yy264;
	}
	goto yy79;
yy146:
	yych = *++cur;
	if (yych <= '/') goto yy79;
	if (yych <= '1') goto yy266;
	goto yy79;
yy147:
	yych = *++cur;
	if (yych == 'C') goto yy268;
	if (yych == 'c') goto yy268;
	goto yy55;
yy148:
	yych = *++cur;
	if (yych == 'N') goto yy269;
	if (yych == 'n') goto yy269;
	goto yy55;
yy149:
	yych = *++cur;
	if (yych == 'O') goto yy270;
	if (yych == 'o') goto yy270;
	goto yy55;
yy150:
	yych = *++cur;
	if (yych <= 'S') {
		if (yych == 'L') goto yy271;
		if (yych <= 'R') goto yy55;
		goto yy272;
	} else {
		if (yych <= 'l') {
			if (yych <= 'k') goto yy55;
			goto yy271;
		} else {
			if (yych == 's') goto yy272;
			goto yy55;
		}
	}
yy151:
	yych = *++cur;
	if (yych == 'A') goto yy273;
	if (yych == 'a') goto yy273;
	goto yy55;
yy152:
	yych = *++cur;
	if (yych <= 'O') {
		if (yych == 'A') goto yy274;
		if (yych <= 'N') goto yy55;
		goto yy275;
	} else {
		if (yych <= 'a') {
			if (yych <= '`') goto yy55;
			goto yy274;
		} else {
			if (yych == 'o') goto yy275;
			goto yy55;
		}
	}
yy153:
	yych = *++cur;
	if (yych <= 'N') {
		if (yych <= 'D') {
			if (yych <= 'C') goto yy55;
			goto yy276;
		} else {
			if (yych <= 'L') goto yy55;
			if (yych <= 'M') goto yy277;
			goto yy278;
		}
	} else {
		if (yych <= 'l') {
			if (yych == 'd') goto yy276;
			goto yy55;
		} else {
			if (yych <= 'm') goto yy277;
			if (yych <= 'n') goto yy278;
			goto yy55;
		}
	}
yy154:
	yych = *++cur;
	if (yych == 'I') goto yy279;
	if (yych == 'i') goto yy279;
	goto yy55;
yy155:
	yych = *++cur;
	if (yych == 'C') goto yy280;
	if (yych == 'c') goto yy280;
	goto yy55;
yy156:
	yych = *++cur;
	if (yych == 'T') goto yy281;
	if (yych == 't') goto yy281;
	goto yy55;
yy157:
	yych = *++cur;
	if (yych <= 'F') {
		if (yych == 'A') goto yy282;
		if (yych <= 'E') goto yy55;
		goto yy283;
	} else {
		if (yych <= 'a') {
			if (yych <= '`') goto yy55;
			goto yy282;
		} else {
			if (yych == 'f') goto yy283;
			goto yy55;
		}
	}
yy158:
	yych = *++cur;
	if (yych == 'M') goto yy284;
	if (yych == 'm') goto yy284;
	goto yy55;
yy159:
	yyaccept = 8;
	yych = *(mar = ++cur);
	if (yybm[0+yych] & 8) {
		goto yy143;
	}
	if (yych <= '@') {
		if (yych <= '\f') {
			if (yych <= '\t') {
				if (yych >= '\t') {
					ctxmar = cur;
					goto yy285;
				}
			} else {
				if (yych == '\v') {
					ctxmar = cur;
					goto yy285;
				}
			}
		} else {
			if (yych <= ' ') {
				if (yych <= '\r') {
					ctxmar = cur;
					goto yy285;
				}
				if (yych >= ' ') {
					ctxmar = cur;
					goto yy285;
				}
			} else {
				if (yych <= '/') goto yy160;
				if (yych <= '9') goto yy54;
			}
		}
	} else {
		if (yych <= '`') {
			if (yych <= 'V') {
				if (yych == 'U') goto yy287;
				goto yy54;
			} else {
				if (yych <= 'W') goto yy288;
				if (yych <= 'Z') goto yy54;
			}
		} else {
			if (yych <= 'v') {
				if (yych == 'u') goto yy287;
				goto yy54;
			} else {
				if (yych <= 'w') goto yy288;
				if (yych <= 'z') goto yy54;
			}
		}
	}
yy160:
#line 267 "tokenizer.re"
	{ KW(DO) }
#line 1692 "tokenizer.cpp"
yy161:
	yych = *++cur;
	if (yych <= 'S') {
		if (yych == 'E') goto yy289;
		if (yych <= 'R') goto yy55;
		goto yy290;
	} else {
		if (yych <= 'e') {
			if (yych <= 'd') goto yy55;
			goto yy289;
		} else {
			if (yych == 's') goto yy290;
			goto yy55;
		}
	}
yy162:
	yych = *++cur;
	if (yych <= 'U') {
		if (yych <= 'D') {
			if (yych <= 'C') goto yy55;
			goto yy291;
		} else {
			if (yych <= 'S') goto yy55;
			if (yych <= 'T') goto yy293;
			goto yy294;
		}
	} else {
		if (yych <= 's') {
			if (yych == 'd') goto yy291;
			goto yy55;
		} else {
			if (yych <= 't') goto yy293;
			if (yych <= 'u') goto yy294;
			goto yy55;
		}
	}
yy163:
	yych = *++cur;
	if (yych == 'U') goto yy295;
	if (yych == 'u') goto yy295;
	goto yy55;
yy164:
	yych = *++cur;
	if (yych == 'R') goto yy296;
	if (yych == 'r') goto yy296;
	goto yy55;
yy165:
	yych = *++cur;
	if (yych == 'E') goto yy297;
	if (yych == 'e') goto yy297;
	goto yy55;
yy166:
	yych = *++cur;
	if (yych <= 'T') {
		if (yych == 'I') goto yy298;
		if (yych <= 'S') goto yy55;
		goto yy299;
	} else {
		if (yych <= 'i') {
			if (yych <= 'h') goto yy55;
			goto yy298;
		} else {
			if (yych == 't') goto yy299;
			goto yy55;
		}
	}
yy167:
	yych = *++cur;
	if (yych <= 'N') {
		if (yych == 'L') goto yy300;
		if (yych <= 'M') goto yy55;
		goto yy301;
	} else {
		if (yych <= 'l') {
			if (yych <= 'k') goto yy55;
			goto yy300;
		} else {
			if (yych == 'n') goto yy301;
			goto yy55;
		}
	}
yy168:
	yych = *++cur;
	if (yych == 'U') goto yy302;
	if (yych == 'u') goto yy302;
	goto yy55;
yy169:
	yych = *++cur;
	if (yych == 'R') goto yy303;
	if (yych == 'r') goto yy303;
	goto yy55;
yy170:
	yych = *++cur;
	if (yych == 'N') goto yy304;
	if (yych == 'n') goto yy304;
	goto yy55;
yy171:
	yych = *++cur;
	if (yych == 'N') goto yy305;
	if (yych == 'n') goto yy305;
	goto yy55;
yy172:
	yych = *++cur;
	if (yybm[0+yych] & 8) {
		goto yy143;
	}
	if (yych <= 'T') {
		if (yych <= '9') {
			if (yych >= '0') goto yy54;
		} else {
			if (yych <= '@') goto yy173;
			if (yych <= 'S') goto yy54;
			goto yy306;
		}
	} else {
		if (yych <= 's') {
			if (yych <= 'Z') goto yy54;
			if (yych >= 'a') goto yy54;
		} else {
			if (yych <= 't') goto yy306;
			if (yych <= 'z') goto yy54;
		}
	}
yy173:
#line 383 "tokenizer.re"
	{ KW(GO) }
#line 1819 "tokenizer.cpp"
yy174:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 385 "tokenizer.re"
	{ KW(IF) }
#line 1828 "tokenizer.cpp"
yy176:
	yych = *++cur;
	if (yych <= 'P') {
		if (yych == 'A') goto yy307;
		if (yych <= 'O') goto yy55;
		goto yy308;
	} else {
		if (yych <= 'a') {
			if (yych <= '`') goto yy55;
			goto yy307;
		} else {
			if (yych == 'p') goto yy308;
			goto yy55;
		}
	}
yy177:
	yyaccept = 9;
	yych = *(mar = ++cur);
	if (yybm[0+yych] & 8) {
		goto yy143;
	}
	if (yych <= 'O') {
		if (yych <= 0x1F) {
			if (yych <= '\n') {
				if (yych == '\t') goto yy309;
			} else {
				if (yych == '\f') goto yy178;
				if (yych <= '\r') goto yy309;
			}
		} else {
			if (yych <= '@') {
				if (yych <= ' ') goto yy309;
				if (yych <= '/') goto yy178;
				if (yych <= '9') goto yy54;
			} else {
				if (yych == 'C') goto yy311;
				if (yych <= 'N') goto yy54;
				goto yy312;
			}
		}
	} else {
		if (yych <= 'c') {
			if (yych <= 'T') {
				if (yych == 'Q') goto yy313;
				if (yych <= 'S') goto yy54;
				goto yy314;
			} else {
				if (yych <= 'Z') goto yy54;
				if (yych <= '`') goto yy178;
				if (yych <= 'b') goto yy54;
				goto yy311;
			}
		} else {
			if (yych <= 'q') {
				if (yych == 'o') goto yy312;
				if (yych <= 'p') goto yy54;
				goto yy313;
			} else {
				if (yych == 't') goto yy314;
				if (yych <= 'z') goto yy54;
			}
		}
	}
yy178:
#line 390 "tokenizer.re"
	{ KW(IN) }
#line 1895 "tokenizer.cpp"
yy179:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 399 "tokenizer.re"
	{ KW(IS) }
#line 1904 "tokenizer.cpp"
yy181:
	yych = *++cur;
	if (yych == 'N') goto yy315;
	if (yych == 'n') goto yy315;
	goto yy55;
yy182:
	yych = *++cur;
	if (yych == 'N') goto yy316;
	if (yych == 'n') goto yy316;
	goto yy55;
yy183:
	yych = *++cur;
	if (yych <= 'G') {
		if (yych == 'C') goto yy318;
		if (yych <= 'F') goto yy55;
		goto yy319;
	} else {
		if (yych <= 'c') {
			if (yych <= 'b') goto yy55;
			goto yy318;
		} else {
			if (yych == 'g') goto yy319;
			goto yy55;
		}
	}
yy184:
	yych = *++cur;
	if (yych == 'M') goto yy320;
	if (yych == 'm') goto yy320;
	goto yy55;
yy185:
	yych = *++cur;
	if (yych <= 'L') {
		if (yych == 'D') goto yy321;
		if (yych <= 'K') goto yy55;
		goto yy322;
	} else {
		if (yych <= 'd') {
			if (yych <= 'c') goto yy55;
			goto yy321;
		} else {
			if (yych == 'l') goto yy322;
			goto yy55;
		}
	}
yy186:
	yych = *++cur;
	if (yych == 'M') goto yy323;
	if (yych == 'm') goto yy323;
	goto yy55;
yy187:
	yych = *++cur;
	if (yych == 'W') goto yy324;
	if (yych == 'w') goto yy324;
	goto yy55;
yy188:
	yych = *++cur;
	if (yych <= 'P') {
		if (yych == 'N') goto yy325;
		if (yych <= 'O') goto yy55;
		goto yy326;
	} else {
		if (yych <= 'n') {
			if (yych <= 'm') goto yy55;
			goto yy325;
		} else {
			if (yych == 'p') goto yy326;
			goto yy55;
		}
	}
yy189:
	yych = *++cur;
	if (yych == 'L') goto yy327;
	if (yych == 'l') goto yy327;
	goto yy55;
yy190:
	yych = *++cur;
	if (yybm[0+yych] & 64) {
		goto yy328;
	}
	goto yy79;
yy191:
	yych = *++cur;
	if (yych <= '/') goto yy79;
	if (yych <= '7') goto yy330;
	goto yy79;
yy192:
	yych = *++cur;
	if (yych == 'L') goto yy332;
	if (yych == 'l') goto yy332;
	goto yy55;
yy193:
	yych = *++cur;
	if (yych <= 'T') {
		if (yych == 'E') goto yy333;
		if (yych <= 'S') goto yy55;
		goto yy334;
	} else {
		if (yych <= 'e') {
			if (yych <= 'd') goto yy55;
			goto yy333;
		} else {
			if (yych == 't') goto yy334;
			goto yy55;
		}
	}
yy194:
	yych = *++cur;
	if (yych == 'T') goto yy335;
	if (yych == 't') goto yy335;
	goto yy55;
yy195:
	yych = *++cur;
	if (yych <= 'S') {
		if (yych <= 'Q') goto yy55;
		if (yych <= 'R') goto yy337;
		goto yy338;
	} else {
		if (yych <= 'q') goto yy55;
		if (yych <= 'r') goto yy337;
		if (yych <= 's') goto yy338;
		goto yy55;
	}
yy196:
	yych = *++cur;
	if (yych <= 'S') {
		if (yych == 'I') goto yy339;
		if (yych <= 'R') goto yy55;
		goto yy340;
	} else {
		if (yych <= 'i') {
			if (yych <= 'h') goto yy55;
			goto yy339;
		} else {
			if (yych == 's') goto yy340;
			goto yy55;
		}
	}
yy197:
	yych = *++cur;
	if (yych <= 'O') {
		if (yych <= 'H') {
			if (yych == 'E') goto yy341;
			goto yy55;
		} else {
			if (yych <= 'I') goto yy342;
			if (yych <= 'N') goto yy55;
			goto yy343;
		}
	} else {
		if (yych <= 'h') {
			if (yych == 'e') goto yy341;
			goto yy55;
		} else {
			if (yych <= 'i') goto yy342;
			if (yych == 'o') goto yy343;
			goto yy55;
		}
	}
yy198:
	yych = *++cur;
	if (yych <= 'R') {
		if (yych == 'B') goto yy344;
		if (yych <= 'Q') goto yy55;
		goto yy345;
	} else {
		if (yych <= 'b') {
			if (yych <= 'a') goto yy55;
			goto yy344;
		} else {
			if (yych == 'r') goto yy345;
			goto yy55;
		}
	}
yy199:
	yych = *++cur;
	if (yych == 'I') goto yy346;
	if (yych == 'i') goto yy346;
	goto yy55;
yy200:
	yych = *++cur;
	if (yych == 'N') goto yy347;
	if (yych == 'n') goto yy347;
	goto yy55;
yy201:
	yych = *++cur;
	switch (yych) {
	case 'A':
	case 'a':	goto yy348;
	case 'C':
	case 'c':	goto yy349;
	case 'D':
	case 'd':	goto yy350;
	case 'S':
	case 's':	goto yy351;
	case 'T':
	case 't':	goto yy352;
	case 'W':
	case 'w':	goto yy353;
	default:	goto yy55;
	}
yy202:
	yych = *++cur;
	if (yych == 'V') goto yy354;
	if (yych == 'v') goto yy354;
	goto yy55;
yy203:
	yych = *++cur;
	if (yych <= 'Q') {
		if (yych == 'L') goto yy355;
		if (yych <= 'P') goto yy55;
		goto yy356;
	} else {
		if (yych <= 'l') {
			if (yych <= 'k') goto yy55;
			goto yy355;
		} else {
			if (yych == 'q') goto yy356;
			goto yy55;
		}
	}
yy204:
	yych = *++cur;
	if (yych == 'A') goto yy357;
	if (yych == 'a') goto yy357;
	goto yy55;
yy205:
	yych = *++cur;
	if (yych == 'U') goto yy358;
	if (yych == 'u') goto yy358;
	goto yy55;
yy206:
	yych = *++cur;
	if (yych <= 'O') {
		if (yych == 'A') goto yy359;
		if (yych <= 'N') goto yy55;
		goto yy360;
	} else {
		if (yych <= 'a') {
			if (yych <= '`') goto yy55;
			goto yy359;
		} else {
			if (yych == 'o') goto yy360;
			goto yy55;
		}
	}
yy207:
	yych = *++cur;
	if (yych == 'B') goto yy361;
	if (yych == 'b') goto yy361;
	goto yy55;
yy208:
	yych = *++cur;
	if (yych == 'N') goto yy362;
	if (yych == 'n') goto yy362;
	goto yy55;
yy209:
	yych = *++cur;
	if (yych == 'R') goto yy363;
	if (yych == 'r') goto yy363;
	goto yy55;
yy210:
	yych = *++cur;
	if (yych == 'A') goto yy364;
	if (yych == 'a') goto yy364;
	goto yy55;
yy211:
	yych = *++cur;
	if (yych == 'E') goto yy365;
	if (yych == 'e') goto yy365;
	goto yy55;
yy212:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 464 "tokenizer.re"
	{ KW(TO) }
#line 2184 "tokenizer.cpp"
yy214:
	yych = *++cur;
	if (yych == 'P') goto yy366;
	if (yych == 'p') goto yy366;
	goto yy55;
yy215:
	yych = *++cur;
	if (yych == 'F') goto yy367;
	if (yych == 'f') goto yy367;
	goto yy55;
yy216:
	yych = *++cur;
	if (yych == 'E') goto yy368;
	if (yych == 'e') goto yy368;
	goto yy55;
yy217:
	yych = *++cur;
	if (yych == 'L') goto yy370;
	if (yych == 'l') goto yy370;
	goto yy55;
yy218:
	yych = *++cur;
	if (yych == 'L') goto yy371;
	if (yych == 'l') goto yy371;
	goto yy55;
yy219:
	yych = *++cur;
	if (yych == 'I') goto yy372;
	if (yych == 'i') goto yy372;
	goto yy55;
yy220:
	yych = *++cur;
	if (yych <= 'I') {
		if (yych == 'E') goto yy373;
		if (yych <= 'H') goto yy55;
		goto yy374;
	} else {
		if (yych <= 'e') {
			if (yych <= 'd') goto yy55;
			goto yy373;
		} else {
			if (yych == 'i') goto yy374;
			goto yy55;
		}
	}
yy221:
	yych = *++cur;
	if (yych == 'I') goto yy375;
	if (yych == 'i') goto yy375;
	goto yy55;
yy222:
	yych = *++cur;
	if (yych == '"') goto yy79;
	goto yy377;
yy223:
	yych = *++cur;
	if (yych == '\'') goto yy79;
	goto yy379;
yy224:
	++cur;
	goto yy94;
yy225:
	yych = *++cur;
	if (yych <= '\f') {
		if (yych <= '\t') {
			if (yych <= 0x08) goto yy79;
			goto yy225;
		} else {
			if (yych == '\v') goto yy225;
			goto yy79;
		}
	} else {
		if (yych <= ' ') {
			if (yych <= '\r') goto yy225;
			if (yych <= 0x1F) goto yy79;
			goto yy225;
		} else {
			if (yych == ')') goto yy380;
			goto yy79;
		}
	}
yy227:
	++cur;
	cur -= 2;
#line 493 "tokenizer.re"
	{ RET(TK_LPAREN) }
#line 2271 "tokenizer.cpp"
yy229:
	yych = *++cur;
	if (yych == ')') goto yy384;
	goto yy383;
yy230:
	++cur;
	cur -= 2;
#line 492 "tokenizer.re"
	{ RET(TK_LPAREN) }
#line 2281 "tokenizer.cpp"
yy232:
	yych = *++cur;
	if (yych <= 'Z') {
		if (yych <= '/') goto yy79;
		if (yych <= '9') goto yy386;
		if (yych <= '@') goto yy79;
		goto yy388;
	} else {
		if (yych <= '_') {
			if (yych <= '^') goto yy79;
			goto yy388;
		} else {
			if (yych <= '`') goto yy79;
			if (yych <= 'z') goto yy388;
			goto yy79;
		}
	}
yy233:
	++cur;
#line 624 "tokenizer.re"
	{ token(yylval.string); RET(TK_DEF_OP) }
#line 2303 "tokenizer.cpp"
yy235:
	yych = *++cur;
	if (yych == 'D') goto yy390;
	if (yych == 'd') goto yy390;
	goto yy111;
yy236:
	yych = *++cur;
	if (yych <= 'U') {
		if (yych == '.') goto yy134;
		goto yy111;
	} else {
		if (yych <= 'V') goto yy391;
		if (yych == 'v') goto yy391;
		goto yy111;
	}
yy237:
	yych = *++cur;
	if (yych == 'L') goto yy392;
	if (yych == 'l') goto yy392;
	goto yy111;
yy238:
	yych = *++cur;
	if (yych == '.') goto yy138;
	goto yy111;
yy239:
	yych = *++cur;
	if (yych == '.') goto yy393;
	goto yy111;
yy240:
	yych = *++cur;
	if (yych == '.') goto yy132;
	goto yy111;
yy241:
	yych = *++cur;
	if (yych == '.') goto yy394;
	goto yy111;
yy242:
	yych = *++cur;
	if (yych <= 'P') {
		if (yych == '.') goto yy123;
		goto yy111;
	} else {
		if (yych <= 'Q') goto yy395;
		if (yych == 'q') goto yy395;
		goto yy111;
	}
yy243:
	yych = *++cur;
	if (yych == 'T') goto yy396;
	if (yych == 't') goto yy396;
	goto yy111;
yy244:
	yych = *++cur;
	if (yych == '.') goto yy397;
	goto yy111;
yy245:
	yych = *++cur;
	if (yych == 'U') goto yy399;
	if (yych == 'u') goto yy399;
	goto yy111;
yy246:
	yych = *++cur;
	if (yybm[0+yych] & 16) {
		goto yy246;
	}
	cur = ctxmar;
#line 555 "tokenizer.re"
	{
                if (last_token == yytokentype::TK_NEWLINE) {
                    uint64_t u;
                    if (lex_int(tok, cur, u, yylval.int_suffix.int_kind)) {
                            yylval.n = u;
                            if (enddo_label_stack[enddo_label_stack.size()-1] == u) {
                                while (enddo_label_stack[enddo_label_stack.size()-1] == u) {
                                    enddo_label_stack.pop_back();
                                    enddo_insert_count++;
                                }
                                enddo_newline_process = true;
                            } else {
                                enddo_newline_process = false;
                            }
                            RET(TK_LABEL)
                    } else {
                        token_loc(loc);
                        std::string t = token();
                        throw LFortran::TokenizerError("Integer too large",
                            loc, t);
                    }
                } else {
                    lex_int_large(al, tok, cur,
                        yylval.int_suffix.int_n,
                        yylval.int_suffix.int_kind);
                    RET(TK_INTEGER)
                }
            }
#line 2399 "tokenizer.cpp"
yy249:
	yych = *++cur;
yy250:
	if (yych <= '@') {
		if (yych == '.') goto yy400;
		goto yy79;
	} else {
		if (yych <= 'Z') goto yy249;
		if (yych <= '`') goto yy79;
		if (yych <= 'z') goto yy249;
		goto yy79;
	}
yy251:
	yych = *++cur;
	if (yych <= ',') {
		if (yych != '+') goto yy250;
	} else {
		if (yych <= '-') goto yy252;
		if (yych <= '/') goto yy250;
		if (yych <= '9') goto yy253;
		goto yy250;
	}
yy252:
	yych = *++cur;
	if (yych <= '/') goto yy79;
	if (yych >= ':') goto yy79;
yy253:
	yyaccept = 7;
	yych = *(mar = ++cur);
	if (yych <= '/') goto yy108;
	if (yych <= '9') goto yy253;
	if (yych == '_') goto yy232;
	goto yy108;
yy255:
	yyaccept = 1;
	yych = *(mar = ++cur);
	if (yych <= '\r') {
		if (yych <= '\n') {
			if (yych == '\t') {
				ctxmar = cur;
				goto yy125;
			}
			goto yy35;
		} else {
			if (yych == '\f') goto yy35;
			ctxmar = cur;
			goto yy125;
		}
	} else {
		if (yych <= '-') {
			if (yych == ' ') {
				ctxmar = cur;
				goto yy125;
			}
			goto yy35;
		} else {
			if (yych <= '.') {
				ctxmar = cur;
				goto yy402;
			}
			if (yych <= '/') goto yy35;
			if (yych <= '9') goto yy255;
			goto yy35;
		}
	}
yy257:
	yyaccept = 1;
	yych = *(mar = ++cur);
	if (yych <= '-') {
		if (yych <= '\v') {
			if (yych == '\t') {
				ctxmar = cur;
				goto yy125;
			}
			if (yych <= '\n') goto yy35;
			ctxmar = cur;
			goto yy125;
		} else {
			if (yych <= '\r') {
				if (yych <= '\f') goto yy35;
				ctxmar = cur;
				goto yy125;
			} else {
				if (yych == ' ') {
					ctxmar = cur;
					goto yy125;
				}
				goto yy35;
			}
		}
	} else {
		if (yych <= 'Z') {
			if (yych <= '/') {
				if (yych <= '.') {
					ctxmar = cur;
					goto yy402;
				}
				goto yy35;
			} else {
				if (yych <= '9') goto yy257;
				if (yych <= '@') goto yy35;
				goto yy257;
			}
		} else {
			if (yych <= '_') {
				if (yych <= '^') goto yy35;
				goto yy257;
			} else {
				if (yych <= '`') goto yy35;
				if (yych <= 'z') goto yy257;
				goto yy35;
			}
		}
	}
yy259:
	yych = *++cur;
	if (yych == 'T') goto yy403;
	if (yych == 't') goto yy403;
	goto yy55;
yy260:
	yych = *++cur;
	if (yybm[0+yych] & 8) {
		goto yy143;
	}
	if (yych <= 'O') {
		if (yych <= '9') {
			if (yych >= '0') goto yy54;
		} else {
			if (yych <= '@') goto yy261;
			if (yych <= 'N') goto yy54;
			goto yy404;
		}
	} else {
		if (yych <= 'n') {
			if (yych <= 'Z') goto yy54;
			if (yych >= 'a') goto yy54;
		} else {
			if (yych <= 'o') goto yy404;
			if (yych <= 'z') goto yy54;
		}
	}
yy261:
#line 229 "tokenizer.re"
	{ KW(ALL) }
#line 2544 "tokenizer.cpp"
yy262:
	yych = *++cur;
	if (yych <= 'O') {
		if (yych == 'I') goto yy405;
		if (yych <= 'N') goto yy55;
		goto yy406;
	} else {
		if (yych <= 'i') {
			if (yych <= 'h') goto yy55;
			goto yy405;
		} else {
			if (yych == 'o') goto yy406;
			goto yy55;
		}
	}
yy263:
	yych = *++cur;
	if (yych == 'N') goto yy407;
	if (yych == 'n') goto yy407;
	goto yy55;
yy264:
	yych = *++cur;
	if (yybm[0+yych] & 32) {
		goto yy264;
	}
	if (yych == '"') goto yy408;
	goto yy79;
yy266:
	yych = *++cur;
	if (yych == '\'') goto yy410;
	if (yych <= '/') goto yy79;
	if (yych <= '1') goto yy266;
	goto yy79;
yy268:
	yych = *++cur;
	if (yych == 'K') goto yy412;
	if (yych == 'k') goto yy412;
	goto yy55;
yy269:
	yych = *++cur;
	if (yych == 'D') goto yy413;
	if (yych == 'd') goto yy413;
	goto yy55;
yy270:
	yych = *++cur;
	if (yych == 'C') goto yy415;
	if (yych == 'c') goto yy415;
	goto yy55;
yy271:
	yych = *++cur;
	if (yych == 'L') goto yy416;
	if (yych == 'l') goto yy416;
	goto yy55;
yy272:
	yych = *++cur;
	if (yych == 'E') goto yy418;
	if (yych == 'e') goto yy418;
	goto yy55;
yy273:
	yych = *++cur;
	if (yych <= 'R') {
		if (yych == 'N') goto yy420;
		if (yych <= 'Q') goto yy55;
		goto yy421;
	} else {
		if (yych <= 'n') {
			if (yych <= 'm') goto yy55;
			goto yy420;
		} else {
			if (yych == 'r') goto yy421;
			goto yy55;
		}
	}
yy274:
	yych = *++cur;
	if (yych == 'S') goto yy422;
	if (yych == 's') goto yy422;
	goto yy55;
yy275:
	yych = *++cur;
	if (yych == 'S') goto yy423;
	if (yych == 's') goto yy423;
	goto yy55;
yy276:
	yych = *++cur;
	if (yych == 'I') goto yy424;
	if (yych == 'i') goto yy424;
	goto yy55;
yy277:
	yych = *++cur;
	if (yych <= 'P') {
		if (yych == 'M') goto yy425;
		if (yych <= 'O') goto yy55;
		goto yy426;
	} else {
		if (yych <= 'm') {
			if (yych <= 'l') goto yy55;
			goto yy425;
		} else {
			if (yych == 'p') goto yy426;
			goto yy55;
		}
	}
yy278:
	yych = *++cur;
	if (yych <= 'T') {
		if (yych == 'C') goto yy427;
		if (yych <= 'S') goto yy55;
		goto yy428;
	} else {
		if (yych <= 'c') {
			if (yych <= 'b') goto yy55;
			goto yy427;
		} else {
			if (yych == 't') goto yy428;
			goto yy55;
		}
	}
yy279:
	yych = *++cur;
	if (yych == 'T') goto yy429;
	if (yych == 't') goto yy429;
	goto yy55;
yy280:
	yych = *++cur;
	if (yych == 'L') goto yy430;
	if (yych == 'l') goto yy430;
	goto yy55;
yy281:
	yych = *++cur;
	if (yych == 'A') goto yy431;
	if (yych == 'a') goto yy431;
	goto yy55;
yy282:
	yych = *++cur;
	if (yych == 'L') goto yy433;
	if (yych == 'l') goto yy433;
	goto yy55;
yy283:
	yych = *++cur;
	if (yych <= 'E') {
		if (yych == 'A') goto yy434;
		if (yych <= 'D') goto yy55;
		goto yy435;
	} else {
		if (yych <= 'a') {
			if (yych <= '`') goto yy55;
			goto yy434;
		} else {
			if (yych == 'e') goto yy435;
			goto yy55;
		}
	}
yy284:
	yych = *++cur;
	if (yych == 'E') goto yy436;
	if (yych == 'e') goto yy436;
	goto yy55;
yy285:
	yych = *++cur;
	if (yych <= '\f') {
		if (yych <= '\t') {
			if (yych <= 0x08) goto yy79;
			goto yy285;
		} else {
			if (yych == '\v') goto yy285;
			goto yy79;
		}
	} else {
		if (yych <= ' ') {
			if (yych <= '\r') goto yy285;
			if (yych <= 0x1F) goto yy79;
			goto yy285;
		} else {
			if (yych <= '/') goto yy79;
			if (yych <= '9') goto yy437;
			goto yy79;
		}
	}
yy287:
	yych = *++cur;
	if (yych == 'B') goto yy440;
	if (yych == 'b') goto yy440;
	goto yy55;
yy288:
	yych = *++cur;
	if (yych == 'H') goto yy441;
	if (yych == 'h') goto yy441;
	goto yy55;
yy289:
	yych = *++cur;
	if (yych == 'M') goto yy442;
	if (yych == 'm') goto yy442;
	goto yy55;
yy290:
	yych = *++cur;
	if (yych == 'E') goto yy443;
	if (yych == 'e') goto yy443;
	goto yy55;
yy291:
	yyaccept = 10;
	yych = *(mar = ++cur);
	if (yybm[0+yych] & 8) {
		goto yy143;
	}
	switch (yych) {
	case '\t':
	case '\v':
	case '\r':	goto yy445;
	case ' ':	goto yy447;
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'G':
	case 'H':
	case 'J':
	case 'K':
	case 'L':
	case 'N':
	case 'O':
	case 'Q':
	case 'R':
	case 'U':
	case 'V':
	case 'X':
	case 'Y':
	case 'Z':
	case 'g':
	case 'h':
	case 'j':
	case 'k':
	case 'l':
	case 'n':
	case 'o':
	case 'q':
	case 'r':
	case 'u':
	case 'v':
	case 'x':
	case 'y':
	case 'z':	goto yy54;
	case 'A':
	case 'a':	goto yy448;
	case 'B':
	case 'b':	goto yy449;
	case 'C':
	case 'c':	goto yy450;
	case 'D':
	case 'd':	goto yy451;
	case 'E':
	case 'e':	goto yy452;
	case 'F':
	case 'f':	goto yy453;
	case 'I':
	case 'i':	goto yy454;
	case 'M':
	case 'm':	goto yy455;
	case 'P':
	case 'p':	goto yy456;
	case 'S':
	case 's':	goto yy457;
	case 'T':
	case 't':	goto yy458;
	case 'W':
	case 'w':	goto yy459;
	default:	goto yy292;
	}
yy292:
#line 276 "tokenizer.re"
	{ KW(END) }
#line 2822 "tokenizer.cpp"
yy293:
	yych = *++cur;
	if (yych == 'R') goto yy460;
	if (yych == 'r') goto yy460;
	goto yy55;
yy294:
	yych = *++cur;
	if (yych == 'M') goto yy461;
	if (yych == 'm') goto yy461;
	goto yy55;
yy295:
	yych = *++cur;
	if (yych == 'I') goto yy463;
	if (yych == 'i') goto yy463;
	goto yy55;
yy296:
	yych = *++cur;
	if (yych <= 'O') {
		if (yych == 'M') goto yy464;
		if (yych <= 'N') goto yy55;
		goto yy465;
	} else {
		if (yych <= 'm') {
			if (yych <= 'l') goto yy55;
			goto yy464;
		} else {
			if (yych == 'o') goto yy465;
			goto yy55;
		}
	}
yy297:
	yych = *++cur;
	if (yych == 'N') goto yy466;
	if (yych == 'n') goto yy466;
	goto yy55;
yy298:
	yych = *++cur;
	if (yych == 'T') goto yy467;
	if (yych == 't') goto yy467;
	goto yy55;
yy299:
	yych = *++cur;
	if (yych == 'E') goto yy469;
	if (yych == 'e') goto yy469;
	goto yy55;
yy300:
	yych = *++cur;
	if (yych == 'E') goto yy470;
	if (yych == 'e') goto yy470;
	goto yy55;
yy301:
	yych = *++cur;
	if (yych == 'A') goto yy472;
	if (yych == 'a') goto yy472;
	goto yy55;
yy302:
	yych = *++cur;
	if (yych == 'S') goto yy473;
	if (yych == 's') goto yy473;
	goto yy55;
yy303:
	yych = *++cur;
	if (yych <= 'M') {
		if (yych == 'A') goto yy474;
		if (yych <= 'L') goto yy55;
		goto yy475;
	} else {
		if (yych <= 'a') {
			if (yych <= '`') goto yy55;
			goto yy474;
		} else {
			if (yych == 'm') goto yy475;
			goto yy55;
		}
	}
yy304:
	yych = *++cur;
	if (yych == 'C') goto yy477;
	if (yych == 'c') goto yy477;
	goto yy55;
yy305:
	yych = *++cur;
	if (yych == 'E') goto yy478;
	if (yych == 'e') goto yy478;
	goto yy55;
yy306:
	yych = *++cur;
	if (yych == 'O') goto yy479;
	if (yych == 'o') goto yy479;
	goto yy55;
yy307:
	yych = *++cur;
	if (yych == 'G') goto yy481;
	if (yych == 'g') goto yy481;
	goto yy55;
yy308:
	yych = *++cur;
	if (yych <= 'U') {
		if (yych <= 'N') {
			if (yych == 'L') goto yy482;
			goto yy55;
		} else {
			if (yych <= 'O') goto yy483;
			if (yych <= 'T') goto yy55;
			goto yy484;
		}
	} else {
		if (yych <= 'n') {
			if (yych == 'l') goto yy482;
			goto yy55;
		} else {
			if (yych <= 'o') goto yy483;
			if (yych == 'u') goto yy484;
			goto yy55;
		}
	}
yy309:
	yych = *++cur;
	if (yych <= '\r') {
		if (yych <= '\n') {
			if (yych == '\t') goto yy309;
			goto yy79;
		} else {
			if (yych == '\f') goto yy79;
			goto yy309;
		}
	} else {
		if (yych <= 'N') {
			if (yych == ' ') goto yy309;
			goto yy79;
		} else {
			if (yych <= 'O') goto yy485;
			if (yych == 'o') goto yy485;
			goto yy79;
		}
	}
yy311:
	yych = *++cur;
	if (yych == 'L') goto yy486;
	if (yych == 'l') goto yy486;
	goto yy55;
yy312:
	yych = *++cur;
	if (yych == 'U') goto yy487;
	if (yych == 'u') goto yy487;
	goto yy55;
yy313:
	yych = *++cur;
	if (yych == 'U') goto yy488;
	if (yych == 'u') goto yy488;
	goto yy55;
yy314:
	yych = *++cur;
	if (yych <= 'R') {
		if (yych == 'E') goto yy489;
		if (yych <= 'Q') goto yy55;
		goto yy490;
	} else {
		if (yych <= 'e') {
			if (yych <= 'd') goto yy55;
			goto yy489;
		} else {
			if (yych == 'r') goto yy490;
			goto yy55;
		}
	}
yy315:
	yych = *++cur;
	if (yych == 'D') goto yy491;
	if (yych == 'd') goto yy491;
	goto yy55;
yy316:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 401 "tokenizer.re"
	{ KW(LEN) }
#line 3002 "tokenizer.cpp"
yy318:
	yych = *++cur;
	if (yych == 'A') goto yy493;
	if (yych == 'a') goto yy493;
	goto yy55;
yy319:
	yych = *++cur;
	if (yych == 'I') goto yy494;
	if (yych == 'i') goto yy494;
	goto yy55;
yy320:
	yych = *++cur;
	if (yych == 'O') goto yy495;
	if (yych == 'o') goto yy495;
	goto yy55;
yy321:
	yych = *++cur;
	if (yych == 'U') goto yy496;
	if (yych == 'u') goto yy496;
	goto yy55;
yy322:
	yych = *++cur;
	if (yych == 'D') goto yy497;
	if (yych == 'd') goto yy497;
	goto yy55;
yy323:
	yych = *++cur;
	if (yych == 'E') goto yy499;
	if (yych == 'e') goto yy499;
	goto yy55;
yy324:
	yych = *++cur;
	if (yych == '_') goto yy501;
	goto yy55;
yy325:
	yych = *++cur;
	if (yych <= '^') {
		if (yych == 'E') goto yy502;
		goto yy55;
	} else {
		if (yych <= '_') goto yy504;
		if (yych == 'e') goto yy502;
		goto yy55;
	}
yy326:
	yych = *++cur;
	if (yych == 'A') goto yy505;
	if (yych == 'a') goto yy505;
	goto yy55;
yy327:
	yych = *++cur;
	if (yych == 'L') goto yy506;
	if (yych == 'l') goto yy506;
	goto yy55;
yy328:
	yych = *++cur;
	if (yybm[0+yych] & 64) {
		goto yy328;
	}
	if (yych == '"') goto yy507;
	goto yy79;
yy330:
	yych = *++cur;
	if (yych == '\'') goto yy509;
	if (yych <= '/') goto yy79;
	if (yych <= '7') goto yy330;
	goto yy79;
yy332:
	yych = *++cur;
	if (yych == 'Y') goto yy511;
	if (yych == 'y') goto yy511;
	goto yy55;
yy333:
	yych = *++cur;
	if (yych <= 'R') {
		if (yych == 'N') goto yy513;
		if (yych <= 'Q') goto yy55;
		goto yy515;
	} else {
		if (yych <= 'n') {
			if (yych <= 'm') goto yy55;
			goto yy513;
		} else {
			if (yych == 'r') goto yy515;
			goto yy55;
		}
	}
yy334:
	yych = *++cur;
	if (yych == 'I') goto yy516;
	if (yych == 'i') goto yy516;
	goto yy55;
yy335:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 421 "tokenizer.re"
	{ KW(OUT) }
#line 3103 "tokenizer.cpp"
yy337:
	yych = *++cur;
	if (yych == 'A') goto yy517;
	if (yych == 'a') goto yy517;
	goto yy55;
yy338:
	yych = *++cur;
	if (yych == 'S') goto yy518;
	if (yych == 's') goto yy518;
	goto yy55;
yy339:
	yych = *++cur;
	if (yych == 'N') goto yy520;
	if (yych == 'n') goto yy520;
	goto yy55;
yy340:
	yych = *++cur;
	if (yych == 'T') goto yy521;
	if (yych == 't') goto yy521;
	goto yy55;
yy341:
	yych = *++cur;
	if (yych == 'C') goto yy523;
	if (yych == 'c') goto yy523;
	goto yy55;
yy342:
	yych = *++cur;
	if (yych <= 'V') {
		if (yych == 'N') goto yy524;
		if (yych <= 'U') goto yy55;
		goto yy525;
	} else {
		if (yych <= 'n') {
			if (yych <= 'm') goto yy55;
			goto yy524;
		} else {
			if (yych == 'v') goto yy525;
			goto yy55;
		}
	}
yy343:
	yych = *++cur;
	if (yych <= 'T') {
		if (yych <= 'F') {
			if (yych == 'C') goto yy526;
			goto yy55;
		} else {
			if (yych <= 'G') goto yy527;
			if (yych <= 'S') goto yy55;
			goto yy528;
		}
	} else {
		if (yych <= 'f') {
			if (yych == 'c') goto yy526;
			goto yy55;
		} else {
			if (yych <= 'g') goto yy527;
			if (yych == 't') goto yy528;
			goto yy55;
		}
	}
yy344:
	yych = *++cur;
	if (yych == 'L') goto yy529;
	if (yych == 'l') goto yy529;
	goto yy55;
yy345:
	yych = *++cur;
	if (yych == 'E') goto yy530;
	if (yych == 'e') goto yy530;
	goto yy55;
yy346:
	yych = *++cur;
	if (yych == 'E') goto yy532;
	if (yych == 'e') goto yy532;
	goto yy55;
yy347:
	yych = *++cur;
	if (yych == 'K') goto yy533;
	if (yych == 'k') goto yy533;
	goto yy55;
yy348:
	yych = *++cur;
	if (yych <= 'L') {
		if (yych == 'D') goto yy535;
		if (yych <= 'K') goto yy55;
		goto yy537;
	} else {
		if (yych <= 'd') {
			if (yych <= 'c') goto yy55;
			goto yy535;
		} else {
			if (yych == 'l') goto yy537;
			goto yy55;
		}
	}
yy349:
	yych = *++cur;
	if (yych == 'U') goto yy539;
	if (yych == 'u') goto yy539;
	goto yy55;
yy350:
	yych = *++cur;
	if (yych == 'U') goto yy540;
	if (yych == 'u') goto yy540;
	goto yy55;
yy351:
	yych = *++cur;
	if (yych == 'U') goto yy541;
	if (yych == 'u') goto yy541;
	goto yy55;
yy352:
	yych = *++cur;
	if (yych == 'U') goto yy542;
	if (yych == 'u') goto yy542;
	goto yy55;
yy353:
	yych = *++cur;
	if (yych == 'I') goto yy543;
	if (yych == 'i') goto yy543;
	goto yy55;
yy354:
	yych = *++cur;
	if (yych == 'E') goto yy544;
	if (yych == 'e') goto yy544;
	goto yy55;
yy355:
	yych = *++cur;
	if (yych == 'E') goto yy546;
	if (yych == 'e') goto yy546;
	goto yy55;
yy356:
	yych = *++cur;
	if (yych == 'U') goto yy547;
	if (yych == 'u') goto yy547;
	goto yy55;
yy357:
	yych = *++cur;
	if (yych == 'R') goto yy548;
	if (yych == 'r') goto yy548;
	goto yy55;
yy358:
	yych = *++cur;
	if (yych == 'R') goto yy549;
	if (yych == 'r') goto yy549;
	goto yy55;
yy359:
	yych = *++cur;
	if (yych == 'T') goto yy550;
	if (yych == 't') goto yy550;
	goto yy55;
yy360:
	yych = *++cur;
	if (yych == 'P') goto yy552;
	if (yych == 'p') goto yy552;
	goto yy55;
yy361:
	yych = *++cur;
	if (yych <= 'R') {
		if (yych == 'M') goto yy554;
		if (yych <= 'Q') goto yy55;
		goto yy555;
	} else {
		if (yych <= 'm') {
			if (yych <= 'l') goto yy55;
			goto yy554;
		} else {
			if (yych == 'r') goto yy555;
			goto yy55;
		}
	}
yy362:
	yych = *++cur;
	if (yych == 'C') goto yy556;
	if (yych == 'c') goto yy556;
	goto yy55;
yy363:
	yych = *++cur;
	if (yych == 'G') goto yy558;
	if (yych == 'g') goto yy558;
	goto yy55;
yy364:
	yych = *++cur;
	if (yych == 'M') goto yy559;
	if (yych == 'm') goto yy559;
	goto yy55;
yy365:
	yych = *++cur;
	if (yych == 'N') goto yy561;
	if (yych == 'n') goto yy561;
	goto yy55;
yy366:
	yych = *++cur;
	if (yych == 'E') goto yy563;
	if (yych == 'e') goto yy563;
	goto yy55;
yy367:
	yych = *++cur;
	if (yych == 'O') goto yy565;
	if (yych == 'o') goto yy565;
	goto yy55;
yy368:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 467 "tokenizer.re"
	{ KW(USE) }
#line 3313 "tokenizer.cpp"
yy370:
	yych = *++cur;
	if (yych == 'U') goto yy566;
	if (yych == 'u') goto yy566;
	goto yy55;
yy371:
	yych = *++cur;
	if (yych == 'A') goto yy567;
	if (yych == 'a') goto yy567;
	goto yy55;
yy372:
	yych = *++cur;
	if (yych == 'T') goto yy568;
	if (yych == 't') goto yy568;
	goto yy55;
yy373:
	yych = *++cur;
	if (yych == 'R') goto yy570;
	if (yych == 'r') goto yy570;
	goto yy55;
yy374:
	yych = *++cur;
	if (yych == 'L') goto yy571;
	if (yych == 'l') goto yy571;
	goto yy55;
yy375:
	yych = *++cur;
	if (yych == 'T') goto yy572;
	if (yych == 't') goto yy572;
	goto yy55;
yy376:
	yych = *++cur;
yy377:
	if (yybm[0+yych] & 128) {
		goto yy376;
	}
	if (yych == '"') goto yy573;
	goto yy79;
yy378:
	yych = *++cur;
yy379:
	if (yych <= '9') {
		if (yych == '\'') goto yy575;
		if (yych <= '/') goto yy79;
		goto yy378;
	} else {
		if (yych <= 'F') {
			if (yych <= '@') goto yy79;
			goto yy378;
		} else {
			if (yych <= '`') goto yy79;
			if (yych <= 'f') goto yy378;
			goto yy79;
		}
	}
yy380:
	++cur;
	cur = ctxmar;
#line 495 "tokenizer.re"
	{ RET(TK_LPAREN) }
#line 3374 "tokenizer.cpp"
yy382:
	yych = *++cur;
yy383:
	if (yych <= '\f') {
		if (yych <= '\t') {
			if (yych <= 0x08) goto yy79;
			goto yy382;
		} else {
			if (yych == '\v') goto yy382;
			goto yy79;
		}
	} else {
		if (yych <= ' ') {
			if (yych <= '\r') goto yy382;
			if (yych <= 0x1F) goto yy79;
			goto yy382;
		} else {
			if (yych == ')') goto yy577;
			goto yy79;
		}
	}
yy384:
	++cur;
	cur -= 3;
#line 498 "tokenizer.re"
	{ RET(TK_LPAREN) }
#line 3401 "tokenizer.cpp"
yy386:
	yych = *++cur;
	if (yych <= '/') goto yy108;
	if (yych <= '9') goto yy386;
	goto yy108;
yy388:
	yych = *++cur;
	if (yych <= 'Z') {
		if (yych <= '/') goto yy108;
		if (yych <= '9') goto yy388;
		if (yych <= '@') goto yy108;
		goto yy388;
	} else {
		if (yych <= '_') {
			if (yych <= '^') goto yy108;
			goto yy388;
		} else {
			if (yych <= '`') goto yy108;
			if (yych <= 'z') goto yy388;
			goto yy108;
		}
	}
yy390:
	yych = *++cur;
	if (yych == '.') goto yy579;
	goto yy111;
yy391:
	yych = *++cur;
	if (yych == '.') goto yy581;
	goto yy111;
yy392:
	yych = *++cur;
	if (yych == 'S') goto yy583;
	if (yych == 's') goto yy583;
	goto yy111;
yy393:
	++cur;
	goto yy45;
yy394:
	++cur;
	goto yy41;
yy395:
	yych = *++cur;
	if (yych == 'V') goto yy584;
	if (yych == 'v') goto yy584;
	goto yy111;
yy396:
	yych = *++cur;
	if (yych == '.') goto yy585;
	goto yy111;
yy397:
	++cur;
#line 532 "tokenizer.re"
	{ RET(TK_OR) }
#line 3456 "tokenizer.cpp"
yy399:
	yych = *++cur;
	if (yych == 'E') goto yy587;
	if (yych == 'e') goto yy587;
	goto yy111;
yy400:
	++cur;
	cur = ctxmar;
#line 546 "tokenizer.re"
	{
                lex_int_large(al, tok, cur,
                    yylval.int_suffix.int_n,
                    yylval.int_suffix.int_kind);
                RET(TK_INTEGER)
            }
#line 3472 "tokenizer.cpp"
yy402:
	yych = *++cur;
	if (yych == '.') goto yy79;
	goto yy250;
yy403:
	yych = *++cur;
	if (yych == 'R') goto yy588;
	if (yych == 'r') goto yy588;
	goto yy55;
yy404:
	yych = *++cur;
	if (yych == 'C') goto yy589;
	if (yych == 'c') goto yy589;
	goto yy55;
yy405:
	yych = *++cur;
	if (yych == 'G') goto yy590;
	if (yych == 'g') goto yy590;
	goto yy55;
yy406:
	yych = *++cur;
	if (yych == 'C') goto yy591;
	if (yych == 'c') goto yy591;
	goto yy55;
yy407:
	yych = *++cur;
	if (yych == 'C') goto yy592;
	if (yych == 'c') goto yy592;
	goto yy55;
yy408:
	++cur;
#line 590 "tokenizer.re"
	{ token(yylval.string); RET(TK_BOZ_CONSTANT) }
#line 3506 "tokenizer.cpp"
yy410:
	++cur;
#line 591 "tokenizer.re"
	{ token(yylval.string); RET(TK_BOZ_CONSTANT) }
#line 3511 "tokenizer.cpp"
yy412:
	yych = *++cur;
	if (yych == 'S') goto yy593;
	if (yych == 's') goto yy593;
	goto yy55;
yy413:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 237 "tokenizer.re"
	{ KW(BIND) }
#line 3525 "tokenizer.cpp"
yy415:
	yych = *++cur;
	if (yych == 'K') goto yy594;
	if (yych == 'k') goto yy594;
	goto yy55;
yy416:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 239 "tokenizer.re"
	{ KW(CALL) }
#line 3539 "tokenizer.cpp"
yy418:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 240 "tokenizer.re"
	{ KW(CASE) }
#line 3548 "tokenizer.cpp"
yy420:
	yych = *++cur;
	if (yych == 'G') goto yy596;
	if (yych == 'g') goto yy596;
	goto yy55;
yy421:
	yych = *++cur;
	if (yych == 'A') goto yy597;
	if (yych == 'a') goto yy597;
	goto yy55;
yy422:
	yych = *++cur;
	if (yych == 'S') goto yy598;
	if (yych == 's') goto yy598;
	goto yy55;
yy423:
	yych = *++cur;
	if (yych == 'E') goto yy600;
	if (yych == 'e') goto yy600;
	goto yy55;
yy424:
	yych = *++cur;
	if (yych == 'M') goto yy602;
	if (yych == 'm') goto yy602;
	goto yy55;
yy425:
	yych = *++cur;
	if (yych == 'O') goto yy603;
	if (yych == 'o') goto yy603;
	goto yy55;
yy426:
	yych = *++cur;
	if (yych == 'L') goto yy604;
	if (yych == 'l') goto yy604;
	goto yy55;
yy427:
	yych = *++cur;
	if (yych == 'U') goto yy605;
	if (yych == 'u') goto yy605;
	goto yy55;
yy428:
	yych = *++cur;
	if (yych <= 'I') {
		if (yych == 'A') goto yy606;
		if (yych <= 'H') goto yy55;
		goto yy607;
	} else {
		if (yych <= 'a') {
			if (yych <= '`') goto yy55;
			goto yy606;
		} else {
			if (yych == 'i') goto yy607;
			goto yy55;
		}
	}
yy429:
	yych = *++cur;
	if (yych == 'I') goto yy608;
	if (yych == 'i') goto yy608;
	goto yy55;
yy430:
	yych = *++cur;
	if (yych == 'E') goto yy609;
	if (yych == 'e') goto yy609;
	goto yy55;
yy431:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 255 "tokenizer.re"
	{ KW(DATA) }
#line 3622 "tokenizer.cpp"
yy433:
	yych = *++cur;
	if (yych == 'L') goto yy611;
	if (yych == 'l') goto yy611;
	goto yy55;
yy434:
	yych = *++cur;
	if (yych == 'U') goto yy612;
	if (yych == 'u') goto yy612;
	goto yy55;
yy435:
	yych = *++cur;
	if (yych == 'R') goto yy613;
	if (yych == 'r') goto yy613;
	goto yy55;
yy436:
	yych = *++cur;
	if (yych == 'N') goto yy614;
	if (yych == 'n') goto yy614;
	goto yy55;
yy437:
	yych = *++cur;
	if (yych <= '/') goto yy439;
	if (yych <= '9') goto yy437;
yy439:
	cur = ctxmar;
#line 260 "tokenizer.re"
	{
                // This is a label do statement, we have to match the
                // corresponding continue base "end do".
                uint64_t n = parse_int(cur);
                enddo_label_stack.push_back(n);
                KW(DO);
            }
#line 3657 "tokenizer.cpp"
yy440:
	yych = *++cur;
	if (yych == 'L') goto yy615;
	if (yych == 'l') goto yy615;
	goto yy55;
yy441:
	yych = *++cur;
	if (yych == 'I') goto yy616;
	if (yych == 'i') goto yy616;
	goto yy55;
yy442:
	yych = *++cur;
	if (yych == 'E') goto yy617;
	if (yych == 'e') goto yy617;
	goto yy55;
yy443:
	yych = *++cur;
	if (yybm[0+yych] & 8) {
		goto yy143;
	}
	if (yych <= 'W') {
		if (yych <= '@') {
			if (yych <= '/') goto yy444;
			if (yych <= '9') goto yy54;
		} else {
			if (yych == 'I') goto yy618;
			if (yych <= 'V') goto yy54;
			goto yy619;
		}
	} else {
		if (yych <= 'i') {
			if (yych <= 'Z') goto yy54;
			if (yych <= '`') goto yy444;
			if (yych <= 'h') goto yy54;
			goto yy618;
		} else {
			if (yych == 'w') goto yy619;
			if (yych <= 'z') goto yy54;
		}
	}
yy444:
#line 272 "tokenizer.re"
	{ KW(ELSE) }
#line 3701 "tokenizer.cpp"
yy445:
	yych = *++cur;
yy446:
	switch (yych) {
	case '\t':
	case '\v':
	case '\r':
	case ' ':	goto yy445;
	case 'A':
	case 'a':	goto yy620;
	case 'B':
	case 'b':	goto yy621;
	case 'C':
	case 'c':	goto yy622;
	case 'D':
	case 'd':	goto yy623;
	case 'E':
	case 'e':	goto yy624;
	case 'F':
	case 'f':	goto yy625;
	case 'I':
	case 'i':	goto yy626;
	case 'M':
	case 'm':	goto yy627;
	case 'P':
	case 'p':	goto yy628;
	case 'S':
	case 's':	goto yy629;
	case 'T':
	case 't':	goto yy630;
	case 'W':
	case 'w':	goto yy631;
	default:	goto yy79;
	}
yy447:
	yych = *++cur;
	if (yych == 'F') goto yy632;
	if (yych == 'f') goto yy632;
	goto yy446;
yy448:
	yych = *++cur;
	if (yych == 'S') goto yy633;
	if (yych == 's') goto yy633;
	goto yy55;
yy449:
	yych = *++cur;
	if (yych == 'L') goto yy634;
	if (yych == 'l') goto yy634;
	goto yy55;
yy450:
	yych = *++cur;
	if (yych == 'R') goto yy635;
	if (yych == 'r') goto yy635;
	goto yy55;
yy451:
	yych = *++cur;
	if (yych == 'O') goto yy636;
	if (yych == 'o') goto yy636;
	goto yy55;
yy452:
	yych = *++cur;
	if (yych == 'N') goto yy638;
	if (yych == 'n') goto yy638;
	goto yy55;
yy453:
	yych = *++cur;
	if (yych <= 'U') {
		if (yych <= 'N') {
			if (yych == 'I') goto yy639;
			goto yy55;
		} else {
			if (yych <= 'O') goto yy640;
			if (yych <= 'T') goto yy55;
			goto yy641;
		}
	} else {
		if (yych <= 'n') {
			if (yych == 'i') goto yy639;
			goto yy55;
		} else {
			if (yych <= 'o') goto yy640;
			if (yych == 'u') goto yy641;
			goto yy55;
		}
	}
yy454:
	yych = *++cur;
	if (yych <= 'N') {
		if (yych == 'F') goto yy642;
		if (yych <= 'M') goto yy55;
		goto yy644;
	} else {
		if (yych <= 'f') {
			if (yych <= 'e') goto yy55;
			goto yy642;
		} else {
			if (yych == 'n') goto yy644;
			goto yy55;
		}
	}
yy455:
	yych = *++cur;
	if (yych == 'O') goto yy645;
	if (yych == 'o') goto yy645;
	goto yy55;
yy456:
	yych = *++cur;
	if (yych == 'R') goto yy646;
	if (yych == 'r') goto yy646;
	goto yy55;
yy457:
	yych = *++cur;
	if (yych <= 'U') {
		if (yych == 'E') goto yy647;
		if (yych <= 'T') goto yy55;
		goto yy648;
	} else {
		if (yych <= 'e') {
			if (yych <= 'd') goto yy55;
			goto yy647;
		} else {
			if (yych == 'u') goto yy648;
			goto yy55;
		}
	}
yy458:
	yych = *++cur;
	if (yych <= 'Y') {
		if (yych == 'E') goto yy649;
		if (yych <= 'X') goto yy55;
		goto yy650;
	} else {
		if (yych <= 'e') {
			if (yych <= 'd') goto yy55;
			goto yy649;
		} else {
			if (yych == 'y') goto yy650;
			goto yy55;
		}
	}
yy459:
	yych = *++cur;
	if (yych == 'H') goto yy651;
	if (yych == 'h') goto yy651;
	goto yy55;
yy460:
	yych = *++cur;
	if (yych == 'Y') goto yy652;
	if (yych == 'y') goto yy652;
	goto yy55;
yy461:
	yych = *++cur;
	if (yybm[0+yych] & 8) {
		goto yy143;
	}
	if (yych <= 'E') {
		if (yych <= '9') {
			if (yych >= '0') goto yy54;
		} else {
			if (yych <= '@') goto yy462;
			if (yych <= 'D') goto yy54;
			goto yy654;
		}
	} else {
		if (yych <= 'd') {
			if (yych <= 'Z') goto yy54;
			if (yych >= 'a') goto yy54;
		} else {
			if (yych <= 'e') goto yy654;
			if (yych <= 'z') goto yy54;
		}
	}
yy462:
#line 353 "tokenizer.re"
	{ KW(ENUM) }
#line 3877 "tokenizer.cpp"
yy463:
	yych = *++cur;
	if (yych == 'V') goto yy655;
	if (yych == 'v') goto yy655;
	goto yy55;
yy464:
	yych = *++cur;
	if (yych == 'S') goto yy656;
	if (yych == 's') goto yy656;
	goto yy55;
yy465:
	yych = *++cur;
	if (yych == 'R') goto yy657;
	if (yych == 'r') goto yy657;
	goto yy55;
yy466:
	yych = *++cur;
	if (yych == 'T') goto yy659;
	if (yych == 't') goto yy659;
	goto yy55;
yy467:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 359 "tokenizer.re"
	{ KW(EXIT) }
#line 3906 "tokenizer.cpp"
yy469:
	yych = *++cur;
	if (yych <= 'R') {
		if (yych == 'N') goto yy661;
		if (yych <= 'Q') goto yy55;
		goto yy662;
	} else {
		if (yych <= 'n') {
			if (yych <= 'm') goto yy55;
			goto yy661;
		} else {
			if (yych == 'r') goto yy662;
			goto yy55;
		}
	}
yy470:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 362 "tokenizer.re"
	{ KW(FILE) }
#line 3930 "tokenizer.cpp"
yy472:
	yych = *++cur;
	if (yych == 'L') goto yy663;
	if (yych == 'l') goto yy663;
	goto yy55;
yy473:
	yych = *++cur;
	if (yych == 'H') goto yy665;
	if (yych == 'h') goto yy665;
	goto yy55;
yy474:
	yych = *++cur;
	if (yych == 'L') goto yy667;
	if (yych == 'l') goto yy667;
	goto yy55;
yy475:
	yych = *++cur;
	if (yybm[0+yych] & 8) {
		goto yy143;
	}
	if (yych <= 'T') {
		if (yych <= '@') {
			if (yych <= '/') goto yy476;
			if (yych <= '9') goto yy54;
		} else {
			if (yych <= 'A') goto yy668;
			if (yych <= 'S') goto yy54;
			goto yy669;
		}
	} else {
		if (yych <= 'a') {
			if (yych <= 'Z') goto yy54;
			if (yych >= 'a') goto yy668;
		} else {
			if (yych == 't') goto yy669;
			if (yych <= 'z') goto yy54;
		}
	}
yy476:
#line 379 "tokenizer.re"
	{ KW(FORM) }
#line 3972 "tokenizer.cpp"
yy477:
	yych = *++cur;
	if (yych == 'T') goto yy670;
	if (yych == 't') goto yy670;
	goto yy55;
yy478:
	yych = *++cur;
	if (yych == 'R') goto yy671;
	if (yych == 'r') goto yy671;
	goto yy55;
yy479:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 384 "tokenizer.re"
	{ KW(GOTO) }
#line 3991 "tokenizer.cpp"
yy481:
	yych = *++cur;
	if (yych == 'E') goto yy672;
	if (yych == 'e') goto yy672;
	goto yy55;
yy482:
	yych = *++cur;
	if (yych == 'I') goto yy673;
	if (yych == 'i') goto yy673;
	goto yy55;
yy483:
	yych = *++cur;
	if (yych == 'R') goto yy674;
	if (yych == 'r') goto yy674;
	goto yy55;
yy484:
	yych = *++cur;
	if (yych == 'R') goto yy675;
	if (yych == 'r') goto yy675;
	goto yy55;
yy485:
	yych = *++cur;
	if (yych == 'U') goto yy676;
	if (yych == 'u') goto yy676;
	goto yy79;
yy486:
	yych = *++cur;
	if (yych == 'U') goto yy677;
	if (yych == 'u') goto yy677;
	goto yy55;
yy487:
	yych = *++cur;
	if (yych == 'T') goto yy678;
	if (yych == 't') goto yy678;
	goto yy55;
yy488:
	yych = *++cur;
	if (yych == 'I') goto yy680;
	if (yych == 'i') goto yy680;
	goto yy55;
yy489:
	yych = *++cur;
	if (yych <= 'R') {
		if (yych <= 'M') {
			if (yych == 'G') goto yy681;
			goto yy55;
		} else {
			if (yych <= 'N') goto yy682;
			if (yych <= 'Q') goto yy55;
			goto yy683;
		}
	} else {
		if (yych <= 'm') {
			if (yych == 'g') goto yy681;
			goto yy55;
		} else {
			if (yych <= 'n') goto yy682;
			if (yych == 'r') goto yy683;
			goto yy55;
		}
	}
yy490:
	yych = *++cur;
	if (yych == 'I') goto yy684;
	if (yych == 'i') goto yy684;
	goto yy55;
yy491:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 400 "tokenizer.re"
	{ KW(KIND) }
#line 4066 "tokenizer.cpp"
yy493:
	yych = *++cur;
	if (yych == 'L') goto yy685;
	if (yych == 'l') goto yy685;
	goto yy55;
yy494:
	yych = *++cur;
	if (yych == 'C') goto yy687;
	if (yych == 'c') goto yy687;
	goto yy55;
yy495:
	yych = *++cur;
	if (yych == 'R') goto yy688;
	if (yych == 'r') goto yy688;
	goto yy55;
yy496:
	yych = *++cur;
	if (yych == 'L') goto yy689;
	if (yych == 'l') goto yy689;
	goto yy55;
yy497:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 407 "tokenizer.re"
	{ KW(MOLD) }
#line 4095 "tokenizer.cpp"
yy499:
	yych = *++cur;
	if (yybm[0+yych] & 8) {
		goto yy143;
	}
	if (yych <= 'L') {
		if (yych <= '9') {
			if (yych >= '0') goto yy54;
		} else {
			if (yych <= '@') goto yy500;
			if (yych <= 'K') goto yy54;
			goto yy690;
		}
	} else {
		if (yych <= 'k') {
			if (yych <= 'Z') goto yy54;
			if (yych >= 'a') goto yy54;
		} else {
			if (yych <= 'l') goto yy690;
			if (yych <= 'z') goto yy54;
		}
	}
yy500:
#line 408 "tokenizer.re"
	{ KW(NAME) }
#line 4121 "tokenizer.cpp"
yy501:
	yyaccept = 2;
	yych = *(mar = ++cur);
	if (yych <= '\'') {
		if (yych == '"') goto yy82;
		if (yych <= '&') goto yy55;
		goto yy97;
	} else {
		if (yych <= 'I') {
			if (yych <= 'H') goto yy55;
			goto yy691;
		} else {
			if (yych == 'i') goto yy691;
			goto yy55;
		}
	}
yy502:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 415 "tokenizer.re"
	{ KW(NONE) }
#line 4146 "tokenizer.cpp"
yy504:
	yyaccept = 2;
	yych = *(mar = ++cur);
	if (yych <= 'O') {
		if (yych <= '\'') {
			if (yych == '"') goto yy82;
			if (yych <= '&') goto yy55;
			goto yy97;
		} else {
			if (yych == 'I') goto yy692;
			if (yych <= 'N') goto yy55;
			goto yy693;
		}
	} else {
		if (yych <= 'i') {
			if (yych == 'R') goto yy694;
			if (yych <= 'h') goto yy55;
			goto yy692;
		} else {
			if (yych <= 'o') {
				if (yych <= 'n') goto yy55;
				goto yy693;
			} else {
				if (yych == 'r') goto yy694;
				goto yy55;
			}
		}
	}
yy505:
	yych = *++cur;
	if (yych == 'S') goto yy695;
	if (yych == 's') goto yy695;
	goto yy55;
yy506:
	yych = *++cur;
	if (yych == 'I') goto yy696;
	if (yych == 'i') goto yy696;
	goto yy55;
yy507:
	++cur;
#line 592 "tokenizer.re"
	{ token(yylval.string); RET(TK_BOZ_CONSTANT) }
#line 4189 "tokenizer.cpp"
yy509:
	++cur;
#line 593 "tokenizer.re"
	{ token(yylval.string); RET(TK_BOZ_CONSTANT) }
#line 4194 "tokenizer.cpp"
yy511:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 417 "tokenizer.re"
	{ KW(ONLY) }
#line 4203 "tokenizer.cpp"
yy513:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 418 "tokenizer.re"
	{ KW(OPEN) }
#line 4212 "tokenizer.cpp"
yy515:
	yych = *++cur;
	if (yych == 'A') goto yy697;
	if (yych == 'a') goto yy697;
	goto yy55;
yy516:
	yych = *++cur;
	if (yych == 'O') goto yy698;
	if (yych == 'o') goto yy698;
	goto yy55;
yy517:
	yych = *++cur;
	if (yych == 'M') goto yy699;
	if (yych == 'm') goto yy699;
	goto yy55;
yy518:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 423 "tokenizer.re"
	{ KW(PASS) }
#line 4236 "tokenizer.cpp"
yy520:
	yych = *++cur;
	if (yych == 'T') goto yy700;
	if (yych == 't') goto yy700;
	goto yy55;
yy521:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 425 "tokenizer.re"
	{ KW(POST) }
#line 4250 "tokenizer.cpp"
yy523:
	yych = *++cur;
	if (yych == 'I') goto yy701;
	if (yych == 'i') goto yy701;
	goto yy55;
yy524:
	yych = *++cur;
	if (yych == 'T') goto yy702;
	if (yych == 't') goto yy702;
	goto yy55;
yy525:
	yych = *++cur;
	if (yych == 'A') goto yy704;
	if (yych == 'a') goto yy704;
	goto yy55;
yy526:
	yych = *++cur;
	if (yych == 'E') goto yy705;
	if (yych == 'e') goto yy705;
	goto yy55;
yy527:
	yych = *++cur;
	if (yych == 'R') goto yy706;
	if (yych == 'r') goto yy706;
	goto yy55;
yy528:
	yych = *++cur;
	if (yych == 'E') goto yy707;
	if (yych == 'e') goto yy707;
	goto yy55;
yy529:
	yych = *++cur;
	if (yych == 'I') goto yy708;
	if (yych == 'i') goto yy708;
	goto yy55;
yy530:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 433 "tokenizer.re"
	{ KW(PURE) }
#line 4294 "tokenizer.cpp"
yy532:
	yych = *++cur;
	if (yych == 'T') goto yy709;
	if (yych == 't') goto yy709;
	goto yy55;
yy533:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 435 "tokenizer.re"
	{ KW(RANK) }
#line 4308 "tokenizer.cpp"
yy535:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 436 "tokenizer.re"
	{ KW(READ) }
#line 4317 "tokenizer.cpp"
yy537:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 437 "tokenizer.re"
	{KW(REAL) }
#line 4326 "tokenizer.cpp"
yy539:
	yych = *++cur;
	if (yych == 'R') goto yy711;
	if (yych == 'r') goto yy711;
	goto yy55;
yy540:
	yych = *++cur;
	if (yych == 'C') goto yy712;
	if (yych == 'c') goto yy712;
	goto yy55;
yy541:
	yych = *++cur;
	if (yych == 'L') goto yy713;
	if (yych == 'l') goto yy713;
	goto yy55;
yy542:
	yych = *++cur;
	if (yych == 'R') goto yy714;
	if (yych == 'r') goto yy714;
	goto yy55;
yy543:
	yych = *++cur;
	if (yych == 'N') goto yy715;
	if (yych == 'n') goto yy715;
	goto yy55;
yy544:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 443 "tokenizer.re"
	{ KW(SAVE) }
#line 4360 "tokenizer.cpp"
yy546:
	yych = *++cur;
	if (yych == 'C') goto yy716;
	if (yych == 'c') goto yy716;
	goto yy55;
yy547:
	yych = *++cur;
	if (yych == 'E') goto yy717;
	if (yych == 'e') goto yy717;
	goto yy55;
yy548:
	yych = *++cur;
	if (yych == 'E') goto yy718;
	if (yych == 'e') goto yy718;
	goto yy55;
yy549:
	yych = *++cur;
	if (yych == 'C') goto yy719;
	if (yych == 'c') goto yy719;
	goto yy55;
yy550:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 451 "tokenizer.re"
	{ KW(STAT) }
#line 4389 "tokenizer.cpp"
yy552:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 452 "tokenizer.re"
	{ KW(STOP) }
#line 4398 "tokenizer.cpp"
yy554:
	yych = *++cur;
	if (yych == 'O') goto yy720;
	if (yych == 'o') goto yy720;
	goto yy55;
yy555:
	yych = *++cur;
	if (yych == 'O') goto yy721;
	if (yych == 'o') goto yy721;
	goto yy55;
yy556:
	yych = *++cur;
	if (yybm[0+yych] & 8) {
		goto yy143;
	}
	if (yych <= 'T') {
		if (yych <= 'H') {
			if (yych <= '9') {
				if (yych >= '0') goto yy54;
			} else {
				if (yych <= '@') goto yy557;
				if (yych <= 'A') goto yy722;
				goto yy54;
			}
		} else {
			if (yych <= 'L') {
				if (yych <= 'I') goto yy723;
				goto yy54;
			} else {
				if (yych <= 'M') goto yy724;
				if (yych <= 'S') goto yy54;
				goto yy725;
			}
		}
	} else {
		if (yych <= 'i') {
			if (yych <= '`') {
				if (yych <= 'Z') goto yy54;
			} else {
				if (yych <= 'a') goto yy722;
				if (yych <= 'h') goto yy54;
				goto yy723;
			}
		} else {
			if (yych <= 's') {
				if (yych == 'm') goto yy724;
				goto yy54;
			} else {
				if (yych <= 't') goto yy725;
				if (yych <= 'z') goto yy54;
			}
		}
	}
yy557:
#line 455 "tokenizer.re"
	{ KW(SYNC) }
#line 4455 "tokenizer.cpp"
yy558:
	yych = *++cur;
	if (yych == 'E') goto yy726;
	if (yych == 'e') goto yy726;
	goto yy55;
yy559:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy727;
#line 461 "tokenizer.re"
	{ KW(TEAM) }
#line 4469 "tokenizer.cpp"
yy561:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 463 "tokenizer.re"
	{ KW(THEN) }
#line 4478 "tokenizer.cpp"
yy563:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 465 "tokenizer.re"
	{ KW(TYPE) }
#line 4487 "tokenizer.cpp"
yy565:
	yych = *++cur;
	if (yych == 'R') goto yy728;
	if (yych == 'r') goto yy728;
	goto yy55;
yy566:
	yych = *++cur;
	if (yych == 'E') goto yy729;
	if (yych == 'e') goto yy729;
	goto yy55;
yy567:
	yych = *++cur;
	if (yych == 'T') goto yy731;
	if (yych == 't') goto yy731;
	goto yy55;
yy568:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 470 "tokenizer.re"
	{ KW(WAIT) }
#line 4511 "tokenizer.cpp"
yy570:
	yych = *++cur;
	if (yych == 'E') goto yy732;
	if (yych == 'e') goto yy732;
	goto yy55;
yy571:
	yych = *++cur;
	if (yych == 'E') goto yy734;
	if (yych == 'e') goto yy734;
	goto yy55;
yy572:
	yych = *++cur;
	if (yych == 'E') goto yy736;
	if (yych == 'e') goto yy736;
	goto yy55;
yy573:
	++cur;
#line 594 "tokenizer.re"
	{ token(yylval.string); RET(TK_BOZ_CONSTANT) }
#line 4531 "tokenizer.cpp"
yy575:
	++cur;
#line 595 "tokenizer.re"
	{ token(yylval.string); RET(TK_BOZ_CONSTANT) }
#line 4536 "tokenizer.cpp"
yy577:
	++cur;
	cur = ctxmar;
#line 497 "tokenizer.re"
	{ RET(TK_LPAREN) }
#line 4542 "tokenizer.cpp"
yy579:
	++cur;
#line 531 "tokenizer.re"
	{ RET(TK_AND) }
#line 4547 "tokenizer.cpp"
yy581:
	++cur;
#line 533 "tokenizer.re"
	{ RET(TK_EQV) }
#line 4552 "tokenizer.cpp"
yy583:
	yych = *++cur;
	if (yych == 'E') goto yy738;
	if (yych == 'e') goto yy738;
	goto yy111;
yy584:
	yych = *++cur;
	if (yych == '.') goto yy739;
	goto yy111;
yy585:
	++cur;
#line 530 "tokenizer.re"
	{ RET(TK_NOT) }
#line 4566 "tokenizer.cpp"
yy587:
	yych = *++cur;
	if (yych == '.') goto yy741;
	goto yy111;
yy588:
	yych = *++cur;
	if (yych == 'A') goto yy743;
	if (yych == 'a') goto yy743;
	goto yy55;
yy589:
	yych = *++cur;
	if (yych == 'A') goto yy744;
	if (yych == 'a') goto yy744;
	goto yy55;
yy590:
	yych = *++cur;
	if (yych == 'N') goto yy745;
	if (yych == 'n') goto yy745;
	goto yy55;
yy591:
	yych = *++cur;
	if (yych == 'I') goto yy747;
	if (yych == 'i') goto yy747;
	goto yy55;
yy592:
	yych = *++cur;
	if (yych == 'H') goto yy748;
	if (yych == 'h') goto yy748;
	goto yy55;
yy593:
	yych = *++cur;
	if (yych == 'P') goto yy749;
	if (yych == 'p') goto yy749;
	goto yy55;
yy594:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 238 "tokenizer.re"
	{ KW(BLOCK) }
#line 4609 "tokenizer.cpp"
yy596:
	yych = *++cur;
	if (yych == 'E') goto yy750;
	if (yych == 'e') goto yy750;
	goto yy55;
yy597:
	yych = *++cur;
	if (yych == 'C') goto yy752;
	if (yych == 'c') goto yy752;
	goto yy55;
yy598:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 244 "tokenizer.re"
	{ KW(CLASS) }
#line 4628 "tokenizer.cpp"
yy600:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 245 "tokenizer.re"
	{ KW(CLOSE) }
#line 4637 "tokenizer.cpp"
yy602:
	yych = *++cur;
	if (yych == 'E') goto yy753;
	if (yych == 'e') goto yy753;
	goto yy55;
yy603:
	yych = *++cur;
	if (yych == 'N') goto yy754;
	if (yych == 'n') goto yy754;
	goto yy55;
yy604:
	yych = *++cur;
	if (yych == 'E') goto yy756;
	if (yych == 'e') goto yy756;
	goto yy55;
yy605:
	yych = *++cur;
	if (yych == 'R') goto yy757;
	if (yych == 'r') goto yy757;
	goto yy55;
yy606:
	yych = *++cur;
	if (yych == 'I') goto yy758;
	if (yych == 'i') goto yy758;
	goto yy55;
yy607:
	yych = *++cur;
	if (yych <= 'N') {
		if (yych == 'G') goto yy759;
		if (yych <= 'M') goto yy55;
		goto yy760;
	} else {
		if (yych <= 'g') {
			if (yych <= 'f') goto yy55;
			goto yy759;
		} else {
			if (yych == 'n') goto yy760;
			goto yy55;
		}
	}
yy608:
	yych = *++cur;
	if (yych == 'C') goto yy761;
	if (yych == 'c') goto yy761;
	goto yy55;
yy609:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 254 "tokenizer.re"
	{ KW(CYCLE) }
#line 4691 "tokenizer.cpp"
yy611:
	yych = *++cur;
	if (yych == 'O') goto yy762;
	if (yych == 'o') goto yy762;
	goto yy55;
yy612:
	yych = *++cur;
	if (yych == 'L') goto yy763;
	if (yych == 'l') goto yy763;
	goto yy55;
yy613:
	yych = *++cur;
	if (yych == 'R') goto yy764;
	if (yych == 'r') goto yy764;
	goto yy55;
yy614:
	yych = *++cur;
	if (yych == 'S') goto yy765;
	if (yych == 's') goto yy765;
	goto yy55;
yy615:
	yych = *++cur;
	if (yych == 'E') goto yy766;
	if (yych == 'e') goto yy766;
	goto yy55;
yy616:
	yych = *++cur;
	if (yych == 'L') goto yy768;
	if (yych == 'l') goto yy768;
	goto yy55;
yy617:
	yych = *++cur;
	if (yych == 'N') goto yy769;
	if (yych == 'n') goto yy769;
	goto yy55;
yy618:
	yych = *++cur;
	if (yych == 'F') goto yy770;
	if (yych == 'f') goto yy770;
	goto yy55;
yy619:
	yych = *++cur;
	if (yych == 'H') goto yy772;
	if (yych == 'h') goto yy772;
	goto yy55;
yy620:
	yych = *++cur;
	if (yych == 'S') goto yy773;
	if (yych == 's') goto yy773;
	goto yy79;
yy621:
	yych = *++cur;
	if (yych == 'L') goto yy774;
	if (yych == 'l') goto yy774;
	goto yy79;
yy622:
	yych = *++cur;
	if (yych == 'R') goto yy775;
	if (yych == 'r') goto yy775;
	goto yy79;
yy623:
	yych = *++cur;
	if (yych == 'O') goto yy776;
	if (yych == 'o') goto yy776;
	goto yy79;
yy624:
	yych = *++cur;
	if (yych == 'N') goto yy778;
	if (yych == 'n') goto yy778;
	goto yy79;
yy625:
	yych = *++cur;
	if (yych <= 'U') {
		if (yych == 'O') goto yy779;
		if (yych <= 'T') goto yy79;
		goto yy780;
	} else {
		if (yych <= 'o') {
			if (yych <= 'n') goto yy79;
			goto yy779;
		} else {
			if (yych == 'u') goto yy780;
			goto yy79;
		}
	}
yy626:
	yych = *++cur;
	if (yych <= 'N') {
		if (yych == 'F') goto yy781;
		if (yych <= 'M') goto yy79;
		goto yy783;
	} else {
		if (yych <= 'f') {
			if (yych <= 'e') goto yy79;
			goto yy781;
		} else {
			if (yych == 'n') goto yy783;
			goto yy79;
		}
	}
yy627:
	yych = *++cur;
	if (yych == 'O') goto yy784;
	if (yych == 'o') goto yy784;
	goto yy79;
yy628:
	yych = *++cur;
	if (yych == 'R') goto yy785;
	if (yych == 'r') goto yy785;
	goto yy79;
yy629:
	yych = *++cur;
	if (yych <= 'U') {
		if (yych == 'E') goto yy786;
		if (yych <= 'T') goto yy79;
		goto yy787;
	} else {
		if (yych <= 'e') {
			if (yych <= 'd') goto yy79;
			goto yy786;
		} else {
			if (yych == 'u') goto yy787;
			goto yy79;
		}
	}
yy630:
	yych = *++cur;
	if (yych <= 'Y') {
		if (yych == 'E') goto yy788;
		if (yych <= 'X') goto yy79;
		goto yy789;
	} else {
		if (yych <= 'e') {
			if (yych <= 'd') goto yy79;
			goto yy788;
		} else {
			if (yych == 'y') goto yy789;
			goto yy79;
		}
	}
yy631:
	yych = *++cur;
	if (yych == 'H') goto yy790;
	if (yych == 'h') goto yy790;
	goto yy79;
yy632:
	yych = *++cur;
	if (yych <= 'U') {
		if (yych <= 'N') {
			if (yych == 'I') goto yy791;
			goto yy79;
		} else {
			if (yych <= 'O') goto yy779;
			if (yych <= 'T') goto yy79;
			goto yy780;
		}
	} else {
		if (yych <= 'n') {
			if (yych == 'i') goto yy791;
			goto yy79;
		} else {
			if (yych <= 'o') goto yy779;
			if (yych == 'u') goto yy780;
			goto yy79;
		}
	}
yy633:
	yych = *++cur;
	if (yych == 'S') goto yy792;
	if (yych == 's') goto yy792;
	goto yy55;
yy634:
	yych = *++cur;
	if (yych == 'O') goto yy793;
	if (yych == 'o') goto yy793;
	goto yy55;
yy635:
	yych = *++cur;
	if (yych == 'I') goto yy794;
	if (yych == 'i') goto yy794;
	goto yy55;
yy636:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 338 "tokenizer.re"
	{
                if (enddo_newline_process) {
                    KW(CONTINUE)
                } else {
                    KW(ENDDO)
                }
            }
#line 4887 "tokenizer.cpp"
yy638:
	yych = *++cur;
	if (yych == 'U') goto yy795;
	if (yych == 'u') goto yy795;
	goto yy55;
yy639:
	yych = *++cur;
	if (yych == 'L') goto yy796;
	if (yych == 'l') goto yy796;
	goto yy55;
yy640:
	yych = *++cur;
	if (yych == 'R') goto yy797;
	if (yych == 'r') goto yy797;
	goto yy55;
yy641:
	yych = *++cur;
	if (yych == 'N') goto yy798;
	if (yych == 'n') goto yy798;
	goto yy55;
yy642:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 323 "tokenizer.re"
	{ KW(ENDIF) }
#line 4916 "tokenizer.cpp"
yy644:
	yych = *++cur;
	if (yych == 'T') goto yy799;
	if (yych == 't') goto yy799;
	goto yy55;
yy645:
	yych = *++cur;
	if (yych == 'D') goto yy800;
	if (yych == 'd') goto yy800;
	goto yy55;
yy646:
	yych = *++cur;
	if (yych == 'O') goto yy801;
	if (yych == 'o') goto yy801;
	goto yy55;
yy647:
	yych = *++cur;
	if (yych == 'L') goto yy802;
	if (yych == 'l') goto yy802;
	goto yy55;
yy648:
	yych = *++cur;
	if (yych == 'B') goto yy803;
	if (yych == 'b') goto yy803;
	goto yy55;
yy649:
	yych = *++cur;
	if (yych == 'A') goto yy804;
	if (yych == 'a') goto yy804;
	goto yy55;
yy650:
	yych = *++cur;
	if (yych == 'P') goto yy805;
	if (yych == 'p') goto yy805;
	goto yy55;
yy651:
	yych = *++cur;
	if (yych == 'E') goto yy806;
	if (yych == 'e') goto yy806;
	goto yy55;
yy652:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 352 "tokenizer.re"
	{ KW(ENTRY) }
#line 4965 "tokenizer.cpp"
yy654:
	yych = *++cur;
	if (yych == 'R') goto yy807;
	if (yych == 'r') goto yy807;
	goto yy55;
yy655:
	yych = *++cur;
	if (yych == 'A') goto yy808;
	if (yych == 'a') goto yy808;
	goto yy55;
yy656:
	yych = *++cur;
	if (yych == 'G') goto yy809;
	if (yych == 'g') goto yy809;
	goto yy55;
yy657:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 357 "tokenizer.re"
	{ KW(ERROR) }
#line 4989 "tokenizer.cpp"
yy659:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 358 "tokenizer.re"
	{ KW(EVENT) }
#line 4998 "tokenizer.cpp"
yy661:
	yych = *++cur;
	if (yych == 'D') goto yy811;
	if (yych == 'd') goto yy811;
	goto yy55;
yy662:
	yych = *++cur;
	if (yych == 'N') goto yy812;
	if (yych == 'n') goto yy812;
	goto yy55;
yy663:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 363 "tokenizer.re"
	{ KW(FINAL) }
#line 5017 "tokenizer.cpp"
yy665:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 364 "tokenizer.re"
	{ KW(FLUSH) }
#line 5026 "tokenizer.cpp"
yy667:
	yych = *++cur;
	if (yych == 'L') goto yy813;
	if (yych == 'l') goto yy813;
	goto yy55;
yy668:
	yych = *++cur;
	if (yych == 'T') goto yy815;
	if (yych == 't') goto yy815;
	goto yy55;
yy669:
	yych = *++cur;
	if (yych == 'E') goto yy817;
	if (yych == 'e') goto yy817;
	goto yy55;
yy670:
	yych = *++cur;
	if (yych == 'I') goto yy818;
	if (yych == 'i') goto yy818;
	goto yy55;
yy671:
	yych = *++cur;
	if (yych == 'I') goto yy819;
	if (yych == 'i') goto yy819;
	goto yy55;
yy672:
	yych = *++cur;
	if (yych == 'S') goto yy820;
	if (yych == 's') goto yy820;
	goto yy55;
yy673:
	yych = *++cur;
	if (yych == 'C') goto yy822;
	if (yych == 'c') goto yy822;
	goto yy55;
yy674:
	yych = *++cur;
	if (yych == 'T') goto yy823;
	if (yych == 't') goto yy823;
	goto yy55;
yy675:
	yych = *++cur;
	if (yych == 'E') goto yy825;
	if (yych == 'e') goto yy825;
	goto yy55;
yy676:
	yych = *++cur;
	if (yych == 'T') goto yy827;
	if (yych == 't') goto yy827;
	goto yy79;
yy677:
	yych = *++cur;
	if (yych == 'D') goto yy829;
	if (yych == 'd') goto yy829;
	goto yy55;
yy678:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 392 "tokenizer.re"
	{ KW(INOUT) }
#line 5090 "tokenizer.cpp"
yy680:
	yych = *++cur;
	if (yych == 'R') goto yy830;
	if (yych == 'r') goto yy830;
	goto yy55;
yy681:
	yych = *++cur;
	if (yych == 'E') goto yy831;
	if (yych == 'e') goto yy831;
	goto yy55;
yy682:
	yych = *++cur;
	if (yych == 'T') goto yy832;
	if (yych == 't') goto yy832;
	goto yy55;
yy683:
	yych = *++cur;
	if (yych == 'F') goto yy834;
	if (yych == 'f') goto yy834;
	goto yy55;
yy684:
	yych = *++cur;
	if (yych == 'N') goto yy835;
	if (yych == 'n') goto yy835;
	goto yy55;
yy685:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy836;
#line 402 "tokenizer.re"
	{ KW(LOCAL) }
#line 5124 "tokenizer.cpp"
yy687:
	yych = *++cur;
	if (yych == 'A') goto yy837;
	if (yych == 'a') goto yy837;
	goto yy55;
yy688:
	yych = *++cur;
	if (yych == 'Y') goto yy838;
	if (yych == 'y') goto yy838;
	goto yy55;
yy689:
	yych = *++cur;
	if (yych == 'E') goto yy840;
	if (yych == 'e') goto yy840;
	goto yy55;
yy690:
	yych = *++cur;
	if (yych == 'I') goto yy842;
	if (yych == 'i') goto yy842;
	goto yy55;
yy691:
	yych = *++cur;
	if (yych == 'N') goto yy843;
	if (yych == 'n') goto yy843;
	goto yy55;
yy692:
	yych = *++cur;
	if (yych == 'N') goto yy844;
	if (yych == 'n') goto yy844;
	goto yy55;
yy693:
	yych = *++cur;
	if (yych == 'V') goto yy845;
	if (yych == 'v') goto yy845;
	goto yy55;
yy694:
	yych = *++cur;
	if (yych == 'E') goto yy846;
	if (yych == 'e') goto yy846;
	goto yy55;
yy695:
	yych = *++cur;
	if (yych == 'S') goto yy847;
	if (yych == 's') goto yy847;
	goto yy55;
yy696:
	yych = *++cur;
	if (yych == 'F') goto yy849;
	if (yych == 'f') goto yy849;
	goto yy55;
yy697:
	yych = *++cur;
	if (yych == 'T') goto yy850;
	if (yych == 't') goto yy850;
	goto yy55;
yy698:
	yych = *++cur;
	if (yych == 'N') goto yy851;
	if (yych == 'n') goto yy851;
	goto yy55;
yy699:
	yych = *++cur;
	if (yych == 'E') goto yy852;
	if (yych == 'e') goto yy852;
	goto yy55;
yy700:
	yych = *++cur;
	if (yych == 'E') goto yy853;
	if (yych == 'e') goto yy853;
	goto yy55;
yy701:
	yych = *++cur;
	if (yych == 'S') goto yy854;
	if (yych == 's') goto yy854;
	goto yy55;
yy702:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 427 "tokenizer.re"
	{ KW(PRINT) }
#line 5208 "tokenizer.cpp"
yy704:
	yych = *++cur;
	if (yych == 'T') goto yy855;
	if (yych == 't') goto yy855;
	goto yy55;
yy705:
	yych = *++cur;
	if (yych == 'D') goto yy856;
	if (yych == 'd') goto yy856;
	goto yy55;
yy706:
	yych = *++cur;
	if (yych == 'A') goto yy857;
	if (yych == 'a') goto yy857;
	goto yy55;
yy707:
	yych = *++cur;
	if (yych == 'C') goto yy858;
	if (yych == 'c') goto yy858;
	goto yy55;
yy708:
	yych = *++cur;
	if (yych == 'C') goto yy859;
	if (yych == 'c') goto yy859;
	goto yy55;
yy709:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 434 "tokenizer.re"
	{ KW(QUIET) }
#line 5242 "tokenizer.cpp"
yy711:
	yych = *++cur;
	if (yych == 'S') goto yy861;
	if (yych == 's') goto yy861;
	goto yy55;
yy712:
	yych = *++cur;
	if (yych == 'E') goto yy862;
	if (yych == 'e') goto yy862;
	goto yy55;
yy713:
	yych = *++cur;
	if (yych == 'T') goto yy864;
	if (yych == 't') goto yy864;
	goto yy55;
yy714:
	yych = *++cur;
	if (yych == 'N') goto yy866;
	if (yych == 'n') goto yy866;
	goto yy55;
yy715:
	yych = *++cur;
	if (yych == 'D') goto yy868;
	if (yych == 'd') goto yy868;
	goto yy55;
yy716:
	yych = *++cur;
	if (yych == 'T') goto yy870;
	if (yych == 't') goto yy870;
	goto yy55;
yy717:
	yych = *++cur;
	if (yych == 'N') goto yy872;
	if (yych == 'n') goto yy872;
	goto yy55;
yy718:
	yych = *++cur;
	if (yych == 'D') goto yy873;
	if (yych == 'd') goto yy873;
	goto yy55;
yy719:
	yych = *++cur;
	if (yych == 'E') goto yy875;
	if (yych == 'e') goto yy875;
	goto yy55;
yy720:
	yych = *++cur;
	if (yych == 'D') goto yy877;
	if (yych == 'd') goto yy877;
	goto yy55;
yy721:
	yych = *++cur;
	if (yych == 'U') goto yy878;
	if (yych == 'u') goto yy878;
	goto yy55;
yy722:
	yych = *++cur;
	if (yych == 'L') goto yy879;
	if (yych == 'l') goto yy879;
	goto yy55;
yy723:
	yych = *++cur;
	if (yych == 'M') goto yy880;
	if (yych == 'm') goto yy880;
	goto yy55;
yy724:
	yych = *++cur;
	if (yych == 'E') goto yy881;
	if (yych == 'e') goto yy881;
	goto yy55;
yy725:
	yych = *++cur;
	if (yych == 'E') goto yy882;
	if (yych == 'e') goto yy882;
	goto yy55;
yy726:
	yych = *++cur;
	if (yych == 'T') goto yy883;
	if (yych == 't') goto yy883;
	goto yy55;
yy727:
	yyaccept = 2;
	yych = *(mar = ++cur);
	if (yych <= '\'') {
		if (yych == '"') goto yy82;
		if (yych <= '&') goto yy55;
		goto yy97;
	} else {
		if (yych <= 'N') {
			if (yych <= 'M') goto yy55;
			goto yy885;
		} else {
			if (yych == 'n') goto yy885;
			goto yy55;
		}
	}
yy728:
	yych = *++cur;
	if (yych == 'M') goto yy886;
	if (yych == 'm') goto yy886;
	goto yy55;
yy729:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 468 "tokenizer.re"
	{ KW(VALUE) }
#line 5352 "tokenizer.cpp"
yy731:
	yych = *++cur;
	if (yych == 'I') goto yy887;
	if (yych == 'i') goto yy887;
	goto yy55;
yy732:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 471 "tokenizer.re"
	{ KW(WHERE) }
#line 5366 "tokenizer.cpp"
yy734:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 472 "tokenizer.re"
	{ KW(WHILE) }
#line 5375 "tokenizer.cpp"
yy736:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 473 "tokenizer.re"
	{ KW(WRITE) }
#line 5384 "tokenizer.cpp"
yy738:
	yych = *++cur;
	if (yych == '.') goto yy888;
	goto yy111;
yy739:
	++cur;
#line 534 "tokenizer.re"
	{ RET(TK_NEQV) }
#line 5393 "tokenizer.cpp"
yy741:
	yyaccept = 11;
	yych = *(mar = ++cur);
	if (yych == '_') goto yy890;
yy742:
#line 538 "tokenizer.re"
	{ RET(TK_TRUE) }
#line 5401 "tokenizer.cpp"
yy743:
	yych = *++cur;
	if (yych == 'C') goto yy891;
	if (yych == 'c') goto yy891;
	goto yy55;
yy744:
	yych = *++cur;
	if (yych == 'T') goto yy892;
	if (yych == 't') goto yy892;
	goto yy55;
yy745:
	yych = *++cur;
	if (yybm[0+yych] & 8) {
		goto yy143;
	}
	if (yych <= 'M') {
		if (yych <= '9') {
			if (yych >= '0') goto yy54;
		} else {
			if (yych <= '@') goto yy746;
			if (yych <= 'L') goto yy54;
			goto yy893;
		}
	} else {
		if (yych <= 'l') {
			if (yych <= 'Z') goto yy54;
			if (yych >= 'a') goto yy54;
		} else {
			if (yych <= 'm') goto yy893;
			if (yych <= 'z') goto yy54;
		}
	}
yy746:
#line 232 "tokenizer.re"
	{ KW(ASSIGN) }
#line 5437 "tokenizer.cpp"
yy747:
	yych = *++cur;
	if (yych == 'A') goto yy894;
	if (yych == 'a') goto yy894;
	goto yy55;
yy748:
	yych = *++cur;
	if (yych == 'R') goto yy895;
	if (yych == 'r') goto yy895;
	goto yy55;
yy749:
	yych = *++cur;
	if (yych == 'A') goto yy896;
	if (yych == 'a') goto yy896;
	goto yy55;
yy750:
	yych = *++cur;
	if (yybm[0+yych] & 8) {
		goto yy143;
	}
	if (yych <= 'T') {
		if (yych <= '9') {
			if (yych >= '0') goto yy54;
		} else {
			if (yych <= '@') goto yy751;
			if (yych <= 'S') goto yy54;
			goto yy897;
		}
	} else {
		if (yych <= 's') {
			if (yych <= 'Z') goto yy54;
			if (yych >= 'a') goto yy54;
		} else {
			if (yych <= 't') goto yy897;
			if (yych <= 'z') goto yy54;
		}
	}
yy751:
#line 241 "tokenizer.re"
	{ KW(CHANGE) }
#line 5478 "tokenizer.cpp"
yy752:
	yych = *++cur;
	if (yych == 'T') goto yy898;
	if (yych == 't') goto yy898;
	goto yy55;
yy753:
	yych = *++cur;
	if (yych == 'N') goto yy899;
	if (yych == 'n') goto yy899;
	goto yy55;
yy754:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 247 "tokenizer.re"
	{ KW(COMMON) }
#line 5497 "tokenizer.cpp"
yy756:
	yych = *++cur;
	if (yych == 'X') goto yy900;
	if (yych == 'x') goto yy900;
	goto yy55;
yy757:
	yych = *++cur;
	if (yych == 'R') goto yy902;
	if (yych == 'r') goto yy902;
	goto yy55;
yy758:
	yych = *++cur;
	if (yych == 'N') goto yy903;
	if (yych == 'n') goto yy903;
	goto yy55;
yy759:
	yych = *++cur;
	if (yych == 'U') goto yy904;
	if (yych == 'u') goto yy904;
	goto yy55;
yy760:
	yych = *++cur;
	if (yych == 'U') goto yy905;
	if (yych == 'u') goto yy905;
	goto yy55;
yy761:
	yych = *++cur;
	if (yych == 'A') goto yy906;
	if (yych == 'a') goto yy906;
	goto yy55;
yy762:
	yych = *++cur;
	if (yych == 'C') goto yy907;
	if (yych == 'c') goto yy907;
	goto yy55;
yy763:
	yych = *++cur;
	if (yych == 'T') goto yy908;
	if (yych == 't') goto yy908;
	goto yy55;
yy764:
	yych = *++cur;
	if (yych == 'E') goto yy910;
	if (yych == 'e') goto yy910;
	goto yy55;
yy765:
	yych = *++cur;
	if (yych == 'I') goto yy911;
	if (yych == 'i') goto yy911;
	goto yy55;
yy766:
	yych = *++cur;
	if (yybm[0+yych] & 8) {
		goto yy143;
	}
	if (yych <= 'P') {
		if (yych <= '9') {
			if (yych >= '0') goto yy54;
		} else {
			if (yych <= '@') goto yy767;
			if (yych <= 'O') goto yy54;
			goto yy912;
		}
	} else {
		if (yych <= 'o') {
			if (yych <= 'Z') goto yy54;
			if (yych >= 'a') goto yy54;
		} else {
			if (yych <= 'p') goto yy912;
			if (yych <= 'z') goto yy54;
		}
	}
yy767:
#line 269 "tokenizer.re"
	{ KW(DOUBLE) }
#line 5573 "tokenizer.cpp"
yy768:
	yych = *++cur;
	if (yych == 'E') goto yy913;
	if (yych == 'e') goto yy913;
	goto yy55;
yy769:
	yych = *++cur;
	if (yych == 'T') goto yy915;
	if (yych == 't') goto yy915;
	goto yy55;
yy770:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 273 "tokenizer.re"
	{ KW(ELSEIF) }
#line 5592 "tokenizer.cpp"
yy772:
	yych = *++cur;
	if (yych == 'E') goto yy916;
	if (yych == 'e') goto yy916;
	goto yy55;
yy773:
	yych = *++cur;
	if (yych == 'S') goto yy917;
	if (yych == 's') goto yy917;
	goto yy79;
yy774:
	yych = *++cur;
	if (yych == 'O') goto yy918;
	if (yych == 'o') goto yy918;
	goto yy79;
yy775:
	yych = *++cur;
	if (yych == 'I') goto yy919;
	if (yych == 'i') goto yy919;
	goto yy79;
yy776:
	++cur;
#line 331 "tokenizer.re"
	{
                if (enddo_newline_process) {
                    KW(CONTINUE)
                } else {
                    KW(END_DO)
                }
            }
#line 5623 "tokenizer.cpp"
yy778:
	yych = *++cur;
	if (yych == 'U') goto yy920;
	if (yych == 'u') goto yy920;
	goto yy79;
yy779:
	yych = *++cur;
	if (yych == 'R') goto yy921;
	if (yych == 'r') goto yy921;
	goto yy79;
yy780:
	yych = *++cur;
	if (yych == 'N') goto yy922;
	if (yych == 'n') goto yy922;
	goto yy79;
yy781:
	++cur;
#line 322 "tokenizer.re"
	{ KW(END_IF) }
#line 5643 "tokenizer.cpp"
yy783:
	yych = *++cur;
	if (yych == 'T') goto yy923;
	if (yych == 't') goto yy923;
	goto yy79;
yy784:
	yych = *++cur;
	if (yych == 'D') goto yy924;
	if (yych == 'd') goto yy924;
	goto yy79;
yy785:
	yych = *++cur;
	if (yych == 'O') goto yy925;
	if (yych == 'o') goto yy925;
	goto yy79;
yy786:
	yych = *++cur;
	if (yych == 'L') goto yy926;
	if (yych == 'l') goto yy926;
	goto yy79;
yy787:
	yych = *++cur;
	if (yych == 'B') goto yy927;
	if (yych == 'b') goto yy927;
	goto yy79;
yy788:
	yych = *++cur;
	if (yych == 'A') goto yy928;
	if (yych == 'a') goto yy928;
	goto yy79;
yy789:
	yych = *++cur;
	if (yych == 'P') goto yy929;
	if (yych == 'p') goto yy929;
	goto yy79;
yy790:
	yych = *++cur;
	if (yych == 'E') goto yy930;
	if (yych == 'e') goto yy930;
	goto yy79;
yy791:
	yych = *++cur;
	if (yych == 'L') goto yy931;
	if (yych == 'l') goto yy931;
	goto yy79;
yy792:
	yych = *++cur;
	if (yych == 'O') goto yy932;
	if (yych == 'o') goto yy932;
	goto yy55;
yy793:
	yych = *++cur;
	if (yych == 'C') goto yy933;
	if (yych == 'c') goto yy933;
	goto yy55;
yy794:
	yych = *++cur;
	if (yych == 'T') goto yy934;
	if (yych == 't') goto yy934;
	goto yy55;
yy795:
	yych = *++cur;
	if (yych == 'M') goto yy935;
	if (yych == 'm') goto yy935;
	goto yy55;
yy796:
	yych = *++cur;
	if (yych == 'E') goto yy937;
	if (yych == 'e') goto yy937;
	goto yy55;
yy797:
	yych = *++cur;
	if (yych == 'A') goto yy939;
	if (yych == 'a') goto yy939;
	goto yy55;
yy798:
	yych = *++cur;
	if (yych == 'C') goto yy940;
	if (yych == 'c') goto yy940;
	goto yy55;
yy799:
	yych = *++cur;
	if (yych == 'E') goto yy941;
	if (yych == 'e') goto yy941;
	goto yy55;
yy800:
	yych = *++cur;
	if (yych == 'U') goto yy942;
	if (yych == 'u') goto yy942;
	goto yy55;
yy801:
	yych = *++cur;
	if (yych <= 'G') {
		if (yych == 'C') goto yy943;
		if (yych <= 'F') goto yy55;
		goto yy944;
	} else {
		if (yych <= 'c') {
			if (yych <= 'b') goto yy55;
			goto yy943;
		} else {
			if (yych == 'g') goto yy944;
			goto yy55;
		}
	}
yy802:
	yych = *++cur;
	if (yych == 'E') goto yy945;
	if (yych == 'e') goto yy945;
	goto yy55;
yy803:
	yych = *++cur;
	if (yych <= 'R') {
		if (yych == 'M') goto yy946;
		if (yych <= 'Q') goto yy55;
		goto yy947;
	} else {
		if (yych <= 'm') {
			if (yych <= 'l') goto yy55;
			goto yy946;
		} else {
			if (yych == 'r') goto yy947;
			goto yy55;
		}
	}
yy804:
	yych = *++cur;
	if (yych == 'M') goto yy948;
	if (yych == 'm') goto yy948;
	goto yy55;
yy805:
	yych = *++cur;
	if (yych == 'E') goto yy950;
	if (yych == 'e') goto yy950;
	goto yy55;
yy806:
	yych = *++cur;
	if (yych == 'R') goto yy952;
	if (yych == 'r') goto yy952;
	goto yy55;
yy807:
	yych = *++cur;
	if (yych == 'A') goto yy953;
	if (yych == 'a') goto yy953;
	goto yy55;
yy808:
	yych = *++cur;
	if (yych == 'L') goto yy954;
	if (yych == 'l') goto yy954;
	goto yy55;
yy809:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 356 "tokenizer.re"
	{ KW(ERRMSG) }
#line 5802 "tokenizer.cpp"
yy811:
	yych = *++cur;
	if (yych == 'S') goto yy955;
	if (yych == 's') goto yy955;
	goto yy55;
yy812:
	yych = *++cur;
	if (yych == 'A') goto yy957;
	if (yych == 'a') goto yy957;
	goto yy55;
yy813:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 365 "tokenizer.re"
	{ KW(FORALL) }
#line 5821 "tokenizer.cpp"
yy815:
	yych = *++cur;
	if (yybm[0+yych] & 8) {
		goto yy143;
	}
	if (yych <= 'T') {
		if (yych <= '9') {
			if (yych >= '0') goto yy54;
		} else {
			if (yych <= '@') goto yy816;
			if (yych <= 'S') goto yy54;
			goto yy958;
		}
	} else {
		if (yych <= 's') {
			if (yych <= 'Z') goto yy54;
			if (yych >= 'a') goto yy54;
		} else {
			if (yych <= 't') goto yy958;
			if (yych <= 'z') goto yy54;
		}
	}
yy816:
#line 366 "tokenizer.re"
	{
                if (last_token == yytokentype::TK_LABEL) {
                    unsigned char *start;
                    lex_format(cur, loc, start);
                    yylval.string.p = (char*) start;
                    yylval.string.n = cur-start-1;
                    RET(TK_FORMAT)
                } else {
                    token(yylval.string);
                    RET(TK_NAME)
                }
            }
#line 5858 "tokenizer.cpp"
yy817:
	yych = *++cur;
	if (yych == 'A') goto yy959;
	if (yych == 'a') goto yy959;
	goto yy55;
yy818:
	yych = *++cur;
	if (yych == 'O') goto yy960;
	if (yych == 'o') goto yy960;
	goto yy55;
yy819:
	yych = *++cur;
	if (yych == 'C') goto yy961;
	if (yych == 'c') goto yy961;
	goto yy55;
yy820:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 386 "tokenizer.re"
	{ KW(IMAGES) }
#line 5882 "tokenizer.cpp"
yy822:
	yych = *++cur;
	if (yych == 'I') goto yy963;
	if (yych == 'i') goto yy963;
	goto yy55;
yy823:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 388 "tokenizer.re"
	{ KW(IMPORT) }
#line 5896 "tokenizer.cpp"
yy825:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 389 "tokenizer.re"
	{ KW(IMPURE) }
#line 5905 "tokenizer.cpp"
yy827:
	++cur;
#line 393 "tokenizer.re"
	{ KW(IN_OUT) }
#line 5910 "tokenizer.cpp"
yy829:
	yych = *++cur;
	if (yych == 'E') goto yy964;
	if (yych == 'e') goto yy964;
	goto yy55;
yy830:
	yych = *++cur;
	if (yych == 'E') goto yy966;
	if (yych == 'e') goto yy966;
	goto yy55;
yy831:
	yych = *++cur;
	if (yych == 'R') goto yy968;
	if (yych == 'r') goto yy968;
	goto yy55;
yy832:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 396 "tokenizer.re"
	{ KW(INTENT) }
#line 5934 "tokenizer.cpp"
yy834:
	yych = *++cur;
	if (yych == 'A') goto yy970;
	if (yych == 'a') goto yy970;
	goto yy55;
yy835:
	yych = *++cur;
	if (yych == 'S') goto yy971;
	if (yych == 's') goto yy971;
	goto yy55;
yy836:
	yyaccept = 2;
	yych = *(mar = ++cur);
	if (yych <= '\'') {
		if (yych == '"') goto yy82;
		if (yych <= '&') goto yy55;
		goto yy97;
	} else {
		if (yych <= 'I') {
			if (yych <= 'H') goto yy55;
			goto yy972;
		} else {
			if (yych == 'i') goto yy972;
			goto yy55;
		}
	}
yy837:
	yych = *++cur;
	if (yych == 'L') goto yy973;
	if (yych == 'l') goto yy973;
	goto yy55;
yy838:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 405 "tokenizer.re"
	{ KW(MEMORY) }
#line 5974 "tokenizer.cpp"
yy840:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 406 "tokenizer.re"
	{ KW(MODULE) }
#line 5983 "tokenizer.cpp"
yy842:
	yych = *++cur;
	if (yych == 'S') goto yy975;
	if (yych == 's') goto yy975;
	goto yy55;
yy843:
	yych = *++cur;
	if (yych == 'D') goto yy976;
	if (yych == 'd') goto yy976;
	goto yy55;
yy844:
	yych = *++cur;
	if (yych == 'T') goto yy977;
	if (yych == 't') goto yy977;
	goto yy55;
yy845:
	yych = *++cur;
	if (yych == 'E') goto yy978;
	if (yych == 'e') goto yy978;
	goto yy55;
yy846:
	yych = *++cur;
	if (yych == 'C') goto yy979;
	if (yych == 'c') goto yy979;
	goto yy55;
yy847:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 411 "tokenizer.re"
	{ KW(NOPASS) }
#line 6017 "tokenizer.cpp"
yy849:
	yych = *++cur;
	if (yych == 'Y') goto yy980;
	if (yych == 'y') goto yy980;
	goto yy55;
yy850:
	yych = *++cur;
	if (yych == 'O') goto yy982;
	if (yych == 'o') goto yy982;
	goto yy55;
yy851:
	yych = *++cur;
	if (yych == 'A') goto yy983;
	if (yych == 'a') goto yy983;
	goto yy55;
yy852:
	yych = *++cur;
	if (yych == 'T') goto yy984;
	if (yych == 't') goto yy984;
	goto yy55;
yy853:
	yych = *++cur;
	if (yych == 'R') goto yy985;
	if (yych == 'r') goto yy985;
	goto yy55;
yy854:
	yych = *++cur;
	if (yych == 'I') goto yy987;
	if (yych == 'i') goto yy987;
	goto yy55;
yy855:
	yych = *++cur;
	if (yych == 'E') goto yy988;
	if (yych == 'e') goto yy988;
	goto yy55;
yy856:
	yych = *++cur;
	if (yych == 'U') goto yy990;
	if (yych == 'u') goto yy990;
	goto yy55;
yy857:
	yych = *++cur;
	if (yych == 'M') goto yy991;
	if (yych == 'm') goto yy991;
	goto yy55;
yy858:
	yych = *++cur;
	if (yych == 'T') goto yy993;
	if (yych == 't') goto yy993;
	goto yy55;
yy859:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 432 "tokenizer.re"
	{ KW(PUBLIC) }
#line 6076 "tokenizer.cpp"
yy861:
	yych = *++cur;
	if (yych == 'I') goto yy994;
	if (yych == 'i') goto yy994;
	goto yy55;
yy862:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 439 "tokenizer.re"
	{ KW(REDUCE) }
#line 6090 "tokenizer.cpp"
yy864:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 440 "tokenizer.re"
	{ KW(RESULT) }
#line 6099 "tokenizer.cpp"
yy866:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 441 "tokenizer.re"
	{ KW(RETURN) }
#line 6108 "tokenizer.cpp"
yy868:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 442 "tokenizer.re"
	{ KW(REWIND) }
#line 6117 "tokenizer.cpp"
yy870:
	yych = *++cur;
	if (yybm[0+yych] & 8) {
		goto yy143;
	}
	if (yych <= 'T') {
		if (yych <= 'B') {
			if (yych <= '/') goto yy871;
			if (yych <= '9') goto yy54;
			if (yych >= 'A') goto yy54;
		} else {
			if (yych <= 'Q') {
				if (yych <= 'C') goto yy995;
				goto yy54;
			} else {
				if (yych <= 'R') goto yy996;
				if (yych <= 'S') goto yy54;
				goto yy997;
			}
		}
	} else {
		if (yych <= 'q') {
			if (yych <= '`') {
				if (yych <= 'Z') goto yy54;
			} else {
				if (yych == 'c') goto yy995;
				goto yy54;
			}
		} else {
			if (yych <= 's') {
				if (yych <= 'r') goto yy996;
				goto yy54;
			} else {
				if (yych <= 't') goto yy997;
				if (yych <= 'z') goto yy54;
			}
		}
	}
yy871:
#line 444 "tokenizer.re"
	{ KW(SELECT) }
#line 6159 "tokenizer.cpp"
yy872:
	yych = *++cur;
	if (yych == 'C') goto yy998;
	if (yych == 'c') goto yy998;
	goto yy55;
yy873:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 449 "tokenizer.re"
	{ KW(SHARED) }
#line 6173 "tokenizer.cpp"
yy875:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 450 "tokenizer.re"
	{ KW(SOURCE) }
#line 6182 "tokenizer.cpp"
yy877:
	yych = *++cur;
	if (yych == 'U') goto yy999;
	if (yych == 'u') goto yy999;
	goto yy55;
yy878:
	yych = *++cur;
	if (yych == 'T') goto yy1000;
	if (yych == 't') goto yy1000;
	goto yy55;
yy879:
	yych = *++cur;
	if (yych == 'L') goto yy1001;
	if (yych == 'l') goto yy1001;
	goto yy55;
yy880:
	yych = *++cur;
	if (yych == 'A') goto yy1003;
	if (yych == 'a') goto yy1003;
	goto yy55;
yy881:
	yych = *++cur;
	if (yych == 'M') goto yy1004;
	if (yych == 'm') goto yy1004;
	goto yy55;
yy882:
	yych = *++cur;
	if (yych == 'A') goto yy1005;
	if (yych == 'a') goto yy1005;
	goto yy55;
yy883:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 460 "tokenizer.re"
	{ KW(TARGET) }
#line 6221 "tokenizer.cpp"
yy885:
	yych = *++cur;
	if (yych == 'U') goto yy1006;
	if (yych == 'u') goto yy1006;
	goto yy55;
yy886:
	yych = *++cur;
	if (yych == 'A') goto yy1007;
	if (yych == 'a') goto yy1007;
	goto yy55;
yy887:
	yych = *++cur;
	if (yych == 'L') goto yy1008;
	if (yych == 'l') goto yy1008;
	goto yy55;
yy888:
	yyaccept = 12;
	yych = *(mar = ++cur);
	if (yych == '_') goto yy1009;
yy889:
#line 539 "tokenizer.re"
	{ RET(TK_FALSE) }
#line 6244 "tokenizer.cpp"
yy890:
	yych = *++cur;
	if (yych <= 'Z') {
		if (yych <= '/') goto yy79;
		if (yych <= '9') goto yy1010;
		if (yych <= '@') goto yy79;
		goto yy1012;
	} else {
		if (yych <= '_') {
			if (yych <= '^') goto yy79;
			goto yy1012;
		} else {
			if (yych <= '`') goto yy79;
			if (yych <= 'z') goto yy1012;
			goto yy79;
		}
	}
yy891:
	yych = *++cur;
	if (yych == 'T') goto yy1014;
	if (yych == 't') goto yy1014;
	goto yy55;
yy892:
	yych = *++cur;
	if (yych <= 'E') {
		if (yych == 'A') goto yy1016;
		if (yych <= 'D') goto yy55;
		goto yy1017;
	} else {
		if (yych <= 'a') {
			if (yych <= '`') goto yy55;
			goto yy1016;
		} else {
			if (yych == 'e') goto yy1017;
			goto yy55;
		}
	}
yy893:
	yych = *++cur;
	if (yych == 'E') goto yy1019;
	if (yych == 'e') goto yy1019;
	goto yy55;
yy894:
	yych = *++cur;
	if (yych == 'T') goto yy1020;
	if (yych == 't') goto yy1020;
	goto yy55;
yy895:
	yych = *++cur;
	if (yych == 'O') goto yy1021;
	if (yych == 'o') goto yy1021;
	goto yy55;
yy896:
	yych = *++cur;
	if (yych == 'C') goto yy1022;
	if (yych == 'c') goto yy1022;
	goto yy55;
yy897:
	yych = *++cur;
	if (yych == 'E') goto yy1023;
	if (yych == 'e') goto yy1023;
	goto yy55;
yy898:
	yych = *++cur;
	if (yych == 'E') goto yy1024;
	if (yych == 'e') goto yy1024;
	goto yy55;
yy899:
	yych = *++cur;
	if (yych == 'S') goto yy1025;
	if (yych == 's') goto yy1025;
	goto yy55;
yy900:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 248 "tokenizer.re"
	{ KW(COMPLEX) }
#line 6325 "tokenizer.cpp"
yy902:
	yych = *++cur;
	if (yych == 'E') goto yy1026;
	if (yych == 'e') goto yy1026;
	goto yy55;
yy903:
	yych = *++cur;
	if (yych == 'S') goto yy1027;
	if (yych == 's') goto yy1027;
	goto yy55;
yy904:
	yych = *++cur;
	if (yych == 'O') goto yy1029;
	if (yych == 'o') goto yy1029;
	goto yy55;
yy905:
	yych = *++cur;
	if (yych == 'E') goto yy1030;
	if (yych == 'e') goto yy1030;
	goto yy55;
yy906:
	yych = *++cur;
	if (yych == 'L') goto yy1032;
	if (yych == 'l') goto yy1032;
	goto yy55;
yy907:
	yych = *++cur;
	if (yych == 'A') goto yy1034;
	if (yych == 'a') goto yy1034;
	goto yy55;
yy908:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 257 "tokenizer.re"
	{ KW(DEFAULT) }
#line 6364 "tokenizer.cpp"
yy910:
	yych = *++cur;
	if (yych == 'D') goto yy1035;
	if (yych == 'd') goto yy1035;
	goto yy55;
yy911:
	yych = *++cur;
	if (yych == 'O') goto yy1037;
	if (yych == 'o') goto yy1037;
	goto yy55;
yy912:
	yych = *++cur;
	if (yych == 'R') goto yy1038;
	if (yych == 'r') goto yy1038;
	goto yy55;
yy913:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 268 "tokenizer.re"
	{ KW(DOWHILE) }
#line 6388 "tokenizer.cpp"
yy915:
	yych = *++cur;
	if (yych == 'A') goto yy1039;
	if (yych == 'a') goto yy1039;
	goto yy55;
yy916:
	yych = *++cur;
	if (yych == 'R') goto yy1040;
	if (yych == 'r') goto yy1040;
	goto yy55;
yy917:
	yych = *++cur;
	if (yych == 'O') goto yy1041;
	if (yych == 'o') goto yy1041;
	goto yy79;
yy918:
	yych = *++cur;
	if (yych == 'C') goto yy1042;
	if (yych == 'c') goto yy1042;
	goto yy79;
yy919:
	yych = *++cur;
	if (yych == 'T') goto yy1043;
	if (yych == 't') goto yy1043;
	goto yy79;
yy920:
	yych = *++cur;
	if (yych == 'M') goto yy1044;
	if (yych == 'm') goto yy1044;
	goto yy79;
yy921:
	yych = *++cur;
	if (yych == 'A') goto yy1046;
	if (yych == 'a') goto yy1046;
	goto yy79;
yy922:
	yych = *++cur;
	if (yych == 'C') goto yy1047;
	if (yych == 'c') goto yy1047;
	goto yy79;
yy923:
	yych = *++cur;
	if (yych == 'E') goto yy1048;
	if (yych == 'e') goto yy1048;
	goto yy79;
yy924:
	yych = *++cur;
	if (yych == 'U') goto yy1049;
	if (yych == 'u') goto yy1049;
	goto yy79;
yy925:
	yych = *++cur;
	if (yych <= 'G') {
		if (yych == 'C') goto yy1050;
		if (yych <= 'F') goto yy79;
		goto yy1051;
	} else {
		if (yych <= 'c') {
			if (yych <= 'b') goto yy79;
			goto yy1050;
		} else {
			if (yych == 'g') goto yy1051;
			goto yy79;
		}
	}
yy926:
	yych = *++cur;
	if (yych == 'E') goto yy1052;
	if (yych == 'e') goto yy1052;
	goto yy79;
yy927:
	yych = *++cur;
	if (yych <= 'R') {
		if (yych == 'M') goto yy1053;
		if (yych <= 'Q') goto yy79;
		goto yy1054;
	} else {
		if (yych <= 'm') {
			if (yych <= 'l') goto yy79;
			goto yy1053;
		} else {
			if (yych == 'r') goto yy1054;
			goto yy79;
		}
	}
yy928:
	yych = *++cur;
	if (yych == 'M') goto yy1055;
	if (yych == 'm') goto yy1055;
	goto yy79;
yy929:
	yych = *++cur;
	if (yych == 'E') goto yy1057;
	if (yych == 'e') goto yy1057;
	goto yy79;
yy930:
	yych = *++cur;
	if (yych == 'R') goto yy1059;
	if (yych == 'r') goto yy1059;
	goto yy79;
yy931:
	yych = *++cur;
	if (yych == 'E') goto yy1060;
	if (yych == 'e') goto yy1060;
	goto yy79;
yy932:
	yych = *++cur;
	if (yych == 'C') goto yy1062;
	if (yych == 'c') goto yy1062;
	goto yy55;
yy933:
	yych = *++cur;
	if (yych == 'K') goto yy1063;
	if (yych == 'k') goto yy1063;
	goto yy55;
yy934:
	yych = *++cur;
	if (yych == 'I') goto yy1065;
	if (yych == 'i') goto yy1065;
	goto yy55;
yy935:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 305 "tokenizer.re"
	{ KW(ENDENUM) }
#line 6517 "tokenizer.cpp"
yy937:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 350 "tokenizer.re"
	{ KW(ENDFILE) }
#line 6526 "tokenizer.cpp"
yy939:
	yych = *++cur;
	if (yych == 'L') goto yy1066;
	if (yych == 'l') goto yy1066;
	goto yy55;
yy940:
	yych = *++cur;
	if (yych == 'T') goto yy1067;
	if (yych == 't') goto yy1067;
	goto yy55;
yy941:
	yych = *++cur;
	if (yych == 'R') goto yy1068;
	if (yych == 'r') goto yy1068;
	goto yy55;
yy942:
	yych = *++cur;
	if (yych == 'L') goto yy1069;
	if (yych == 'l') goto yy1069;
	goto yy55;
yy943:
	yych = *++cur;
	if (yych == 'E') goto yy1070;
	if (yych == 'e') goto yy1070;
	goto yy55;
yy944:
	yych = *++cur;
	if (yych == 'R') goto yy1071;
	if (yych == 'r') goto yy1071;
	goto yy55;
yy945:
	yych = *++cur;
	if (yych == 'C') goto yy1072;
	if (yych == 'c') goto yy1072;
	goto yy55;
yy946:
	yych = *++cur;
	if (yych == 'O') goto yy1073;
	if (yych == 'o') goto yy1073;
	goto yy55;
yy947:
	yych = *++cur;
	if (yych == 'O') goto yy1074;
	if (yych == 'o') goto yy1074;
	goto yy55;
yy948:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 317 "tokenizer.re"
	{ KW(ENDTEAM) }
#line 6580 "tokenizer.cpp"
yy950:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 329 "tokenizer.re"
	{ KW(ENDTYPE) }
#line 6589 "tokenizer.cpp"
yy952:
	yych = *++cur;
	if (yych == 'E') goto yy1075;
	if (yych == 'e') goto yy1075;
	goto yy55;
yy953:
	yych = *++cur;
	if (yych == 'T') goto yy1077;
	if (yych == 't') goto yy1077;
	goto yy55;
yy954:
	yych = *++cur;
	if (yych == 'E') goto yy1078;
	if (yych == 'e') goto yy1078;
	goto yy55;
yy955:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 360 "tokenizer.re"
	{ KW(EXTENDS) }
#line 6613 "tokenizer.cpp"
yy957:
	yych = *++cur;
	if (yych == 'L') goto yy1079;
	if (yych == 'l') goto yy1079;
	goto yy55;
yy958:
	yych = *++cur;
	if (yych == 'E') goto yy1081;
	if (yych == 'e') goto yy1081;
	goto yy55;
yy959:
	yych = *++cur;
	if (yych == 'M') goto yy1082;
	if (yych == 'm') goto yy1082;
	goto yy55;
yy960:
	yych = *++cur;
	if (yych == 'N') goto yy1084;
	if (yych == 'n') goto yy1084;
	goto yy55;
yy961:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 382 "tokenizer.re"
	{ KW(GENERIC) }
#line 6642 "tokenizer.cpp"
yy963:
	yych = *++cur;
	if (yych == 'T') goto yy1086;
	if (yych == 't') goto yy1086;
	goto yy55;
yy964:
	yyaccept = 13;
	yych = *(mar = ++cur);
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych <= '\f') {
		if (yych <= '\t') {
			if (yych >= '\t') goto yy1088;
		} else {
			if (yych == '\v') goto yy1088;
		}
	} else {
		if (yych <= ' ') {
			if (yych <= '\r') goto yy1088;
			if (yych >= ' ') goto yy1088;
		} else {
			if (yych == '_') goto yy143;
		}
	}
yy965:
#line 391 "tokenizer.re"
	{ KW(INCLUDE) }
#line 6671 "tokenizer.cpp"
yy966:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 394 "tokenizer.re"
	{ KW(INQUIRE) }
#line 6680 "tokenizer.cpp"
yy968:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 395 "tokenizer.re"
	{ KW(INTEGER) }
#line 6689 "tokenizer.cpp"
yy970:
	yych = *++cur;
	if (yych == 'C') goto yy1090;
	if (yych == 'c') goto yy1090;
	goto yy55;
yy971:
	yych = *++cur;
	if (yych == 'I') goto yy1091;
	if (yych == 'i') goto yy1091;
	goto yy55;
yy972:
	yych = *++cur;
	if (yych == 'N') goto yy1092;
	if (yych == 'n') goto yy1092;
	goto yy55;
yy973:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 404 "tokenizer.re"
	{ KW(LOGICAL) }
#line 6713 "tokenizer.cpp"
yy975:
	yych = *++cur;
	if (yych == 'T') goto yy1093;
	if (yych == 't') goto yy1093;
	goto yy55;
yy976:
	yych = *++cur;
	if (yych == 'E') goto yy1095;
	if (yych == 'e') goto yy1095;
	goto yy55;
yy977:
	yych = *++cur;
	if (yych == 'R') goto yy1096;
	if (yych == 'r') goto yy1096;
	goto yy55;
yy978:
	yych = *++cur;
	if (yych == 'R') goto yy1097;
	if (yych == 'r') goto yy1097;
	goto yy55;
yy979:
	yych = *++cur;
	if (yych == 'U') goto yy1098;
	if (yych == 'u') goto yy1098;
	goto yy55;
yy980:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 416 "tokenizer.re"
	{ KW(NULLIFY) }
#line 6747 "tokenizer.cpp"
yy982:
	yych = *++cur;
	if (yych == 'R') goto yy1099;
	if (yych == 'r') goto yy1099;
	goto yy55;
yy983:
	yych = *++cur;
	if (yych == 'L') goto yy1101;
	if (yych == 'l') goto yy1101;
	goto yy55;
yy984:
	yych = *++cur;
	if (yych == 'E') goto yy1103;
	if (yych == 'e') goto yy1103;
	goto yy55;
yy985:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 424 "tokenizer.re"
	{ KW(POINTER) }
#line 6771 "tokenizer.cpp"
yy987:
	yych = *++cur;
	if (yych == 'O') goto yy1104;
	if (yych == 'o') goto yy1104;
	goto yy55;
yy988:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 428 "tokenizer.re"
	{ KW(PRIVATE) }
#line 6785 "tokenizer.cpp"
yy990:
	yych = *++cur;
	if (yych == 'R') goto yy1105;
	if (yych == 'r') goto yy1105;
	goto yy55;
yy991:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 430 "tokenizer.re"
	{ KW(PROGRAM) }
#line 6799 "tokenizer.cpp"
yy993:
	yych = *++cur;
	if (yych == 'E') goto yy1106;
	if (yych == 'e') goto yy1106;
	goto yy55;
yy994:
	yych = *++cur;
	if (yych == 'V') goto yy1107;
	if (yych == 'v') goto yy1107;
	goto yy55;
yy995:
	yych = *++cur;
	if (yych == 'A') goto yy1108;
	if (yych == 'a') goto yy1108;
	goto yy55;
yy996:
	yych = *++cur;
	if (yych == 'A') goto yy1109;
	if (yych == 'a') goto yy1109;
	goto yy55;
yy997:
	yych = *++cur;
	if (yych == 'Y') goto yy1110;
	if (yych == 'y') goto yy1110;
	goto yy55;
yy998:
	yych = *++cur;
	if (yych == 'E') goto yy1111;
	if (yych == 'e') goto yy1111;
	goto yy55;
yy999:
	yych = *++cur;
	if (yych == 'L') goto yy1113;
	if (yych == 'l') goto yy1113;
	goto yy55;
yy1000:
	yych = *++cur;
	if (yych == 'I') goto yy1114;
	if (yych == 'i') goto yy1114;
	goto yy55;
yy1001:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 456 "tokenizer.re"
	{ KW(SYNC_ALL) }
#line 6848 "tokenizer.cpp"
yy1003:
	yych = *++cur;
	if (yych == 'G') goto yy1115;
	if (yych == 'g') goto yy1115;
	goto yy55;
yy1004:
	yych = *++cur;
	if (yych == 'O') goto yy1116;
	if (yych == 'o') goto yy1116;
	goto yy55;
yy1005:
	yych = *++cur;
	if (yych == 'M') goto yy1117;
	if (yych == 'm') goto yy1117;
	goto yy55;
yy1006:
	yych = *++cur;
	if (yych == 'M') goto yy1119;
	if (yych == 'm') goto yy1119;
	goto yy55;
yy1007:
	yych = *++cur;
	if (yych == 'T') goto yy1120;
	if (yych == 't') goto yy1120;
	goto yy55;
yy1008:
	yych = *++cur;
	if (yych == 'E') goto yy1121;
	if (yych == 'e') goto yy1121;
	goto yy55;
yy1009:
	yych = *++cur;
	if (yych <= 'Z') {
		if (yych <= '/') goto yy79;
		if (yych <= '9') goto yy1123;
		if (yych <= '@') goto yy79;
		goto yy1125;
	} else {
		if (yych <= '_') {
			if (yych <= '^') goto yy79;
			goto yy1125;
		} else {
			if (yych <= '`') goto yy79;
			if (yych <= 'z') goto yy1125;
			goto yy79;
		}
	}
yy1010:
	yych = *++cur;
	if (yych <= '/') goto yy742;
	if (yych <= '9') goto yy1010;
	goto yy742;
yy1012:
	yych = *++cur;
	if (yych <= 'Z') {
		if (yych <= '/') goto yy742;
		if (yych <= '9') goto yy1012;
		if (yych <= '@') goto yy742;
		goto yy1012;
	} else {
		if (yych <= '_') {
			if (yych <= '^') goto yy742;
			goto yy1012;
		} else {
			if (yych <= '`') goto yy742;
			if (yych <= 'z') goto yy1012;
			goto yy742;
		}
	}
yy1014:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 228 "tokenizer.re"
	{ KW(ABSTRACT) }
#line 6926 "tokenizer.cpp"
yy1016:
	yych = *++cur;
	if (yych == 'B') goto yy1127;
	if (yych == 'b') goto yy1127;
	goto yy55;
yy1017:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 231 "tokenizer.re"
	{ KW(ALLOCATE) }
#line 6940 "tokenizer.cpp"
yy1019:
	yych = *++cur;
	if (yych == 'N') goto yy1128;
	if (yych == 'n') goto yy1128;
	goto yy55;
yy1020:
	yych = *++cur;
	if (yych == 'E') goto yy1129;
	if (yych == 'e') goto yy1129;
	goto yy55;
yy1021:
	yych = *++cur;
	if (yych == 'N') goto yy1131;
	if (yych == 'n') goto yy1131;
	goto yy55;
yy1022:
	yych = *++cur;
	if (yych == 'E') goto yy1132;
	if (yych == 'e') goto yy1132;
	goto yy55;
yy1023:
	yych = *++cur;
	if (yych == 'A') goto yy1134;
	if (yych == 'a') goto yy1134;
	goto yy55;
yy1024:
	yych = *++cur;
	if (yych == 'R') goto yy1135;
	if (yych == 'r') goto yy1135;
	goto yy55;
yy1025:
	yych = *++cur;
	if (yych == 'I') goto yy1137;
	if (yych == 'i') goto yy1137;
	goto yy55;
yy1026:
	yych = *++cur;
	if (yych == 'N') goto yy1138;
	if (yych == 'n') goto yy1138;
	goto yy55;
yy1027:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 250 "tokenizer.re"
	{ KW(CONTAINS) }
#line 6989 "tokenizer.cpp"
yy1029:
	yych = *++cur;
	if (yych == 'U') goto yy1139;
	if (yych == 'u') goto yy1139;
	goto yy55;
yy1030:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 252 "tokenizer.re"
	{ KW(CONTINUE) }
#line 7003 "tokenizer.cpp"
yy1032:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 253 "tokenizer.re"
	{ KW(CRITICAL) }
#line 7012 "tokenizer.cpp"
yy1034:
	yych = *++cur;
	if (yych == 'T') goto yy1140;
	if (yych == 't') goto yy1140;
	goto yy55;
yy1035:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 258 "tokenizer.re"
	{ KW(DEFERRED) }
#line 7026 "tokenizer.cpp"
yy1037:
	yych = *++cur;
	if (yych == 'N') goto yy1141;
	if (yych == 'n') goto yy1141;
	goto yy55;
yy1038:
	yych = *++cur;
	if (yych == 'E') goto yy1143;
	if (yych == 'e') goto yy1143;
	goto yy55;
yy1039:
	yych = *++cur;
	if (yych == 'L') goto yy1144;
	if (yych == 'l') goto yy1144;
	goto yy55;
yy1040:
	yych = *++cur;
	if (yych == 'E') goto yy1146;
	if (yych == 'e') goto yy1146;
	goto yy55;
yy1041:
	yych = *++cur;
	if (yych == 'C') goto yy1148;
	if (yych == 'c') goto yy1148;
	goto yy79;
yy1042:
	yych = *++cur;
	if (yych == 'K') goto yy1149;
	if (yych == 'k') goto yy1149;
	goto yy79;
yy1043:
	yych = *++cur;
	if (yych == 'I') goto yy1151;
	if (yych == 'i') goto yy1151;
	goto yy79;
yy1044:
	++cur;
#line 304 "tokenizer.re"
	{ KW(END_ENUM) }
#line 7066 "tokenizer.cpp"
yy1046:
	yych = *++cur;
	if (yych == 'L') goto yy1152;
	if (yych == 'l') goto yy1152;
	goto yy79;
yy1047:
	yych = *++cur;
	if (yych == 'T') goto yy1153;
	if (yych == 't') goto yy1153;
	goto yy79;
yy1048:
	yych = *++cur;
	if (yych == 'R') goto yy1154;
	if (yych == 'r') goto yy1154;
	goto yy79;
yy1049:
	yych = *++cur;
	if (yych == 'L') goto yy1155;
	if (yych == 'l') goto yy1155;
	goto yy79;
yy1050:
	yych = *++cur;
	if (yych == 'E') goto yy1156;
	if (yych == 'e') goto yy1156;
	goto yy79;
yy1051:
	yych = *++cur;
	if (yych == 'R') goto yy1157;
	if (yych == 'r') goto yy1157;
	goto yy79;
yy1052:
	yych = *++cur;
	if (yych == 'C') goto yy1158;
	if (yych == 'c') goto yy1158;
	goto yy79;
yy1053:
	yych = *++cur;
	if (yych == 'O') goto yy1159;
	if (yych == 'o') goto yy1159;
	goto yy79;
yy1054:
	yych = *++cur;
	if (yych == 'O') goto yy1160;
	if (yych == 'o') goto yy1160;
	goto yy79;
yy1055:
	++cur;
#line 316 "tokenizer.re"
	{ KW(END_TEAM) }
#line 7116 "tokenizer.cpp"
yy1057:
	++cur;
#line 328 "tokenizer.re"
	{ KW(END_TYPE) }
#line 7121 "tokenizer.cpp"
yy1059:
	yych = *++cur;
	if (yych == 'E') goto yy1161;
	if (yych == 'e') goto yy1161;
	goto yy79;
yy1060:
	++cur;
#line 349 "tokenizer.re"
	{ KW(END_FILE) }
#line 7131 "tokenizer.cpp"
yy1062:
	yych = *++cur;
	if (yych == 'I') goto yy1163;
	if (yych == 'i') goto yy1163;
	goto yy55;
yy1063:
	yyaccept = 14;
	yych = *(mar = ++cur);
	if (yybm[0+yych] & 8) {
		goto yy143;
	}
	if (yych <= '/') {
		if (yych <= '\v') {
			if (yych == '\t') goto yy1164;
			if (yych >= '\v') goto yy1164;
		} else {
			if (yych <= '\r') {
				if (yych >= '\r') goto yy1164;
			} else {
				if (yych == ' ') goto yy1164;
			}
		}
	} else {
		if (yych <= 'Z') {
			if (yych <= '@') {
				if (yych <= '9') goto yy54;
			} else {
				if (yych == 'D') goto yy1166;
				goto yy54;
			}
		} else {
			if (yych <= 'c') {
				if (yych >= 'a') goto yy54;
			} else {
				if (yych <= 'd') goto yy1166;
				if (yych <= 'z') goto yy54;
			}
		}
	}
yy1064:
#line 288 "tokenizer.re"
	{ KW(ENDBLOCK) }
#line 7174 "tokenizer.cpp"
yy1065:
	yych = *++cur;
	if (yych == 'C') goto yy1167;
	if (yych == 'c') goto yy1167;
	goto yy55;
yy1066:
	yych = *++cur;
	if (yych == 'L') goto yy1168;
	if (yych == 'l') goto yy1168;
	goto yy55;
yy1067:
	yych = *++cur;
	if (yych == 'I') goto yy1170;
	if (yych == 'i') goto yy1170;
	goto yy55;
yy1068:
	yych = *++cur;
	if (yych == 'F') goto yy1171;
	if (yych == 'f') goto yy1171;
	goto yy55;
yy1069:
	yych = *++cur;
	if (yych == 'E') goto yy1172;
	if (yych == 'e') goto yy1172;
	goto yy55;
yy1070:
	yych = *++cur;
	if (yych == 'D') goto yy1174;
	if (yych == 'd') goto yy1174;
	goto yy55;
yy1071:
	yych = *++cur;
	if (yych == 'A') goto yy1175;
	if (yych == 'a') goto yy1175;
	goto yy55;
yy1072:
	yych = *++cur;
	if (yych == 'T') goto yy1176;
	if (yych == 't') goto yy1176;
	goto yy55;
yy1073:
	yych = *++cur;
	if (yych == 'D') goto yy1178;
	if (yych == 'd') goto yy1178;
	goto yy55;
yy1074:
	yych = *++cur;
	if (yych == 'U') goto yy1179;
	if (yych == 'u') goto yy1179;
	goto yy55;
yy1075:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 347 "tokenizer.re"
	{ KW(ENDWHERE) }
#line 7233 "tokenizer.cpp"
yy1077:
	yych = *++cur;
	if (yych == 'O') goto yy1180;
	if (yych == 'o') goto yy1180;
	goto yy55;
yy1078:
	yych = *++cur;
	if (yych == 'N') goto yy1181;
	if (yych == 'n') goto yy1181;
	goto yy55;
yy1079:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 361 "tokenizer.re"
	{ KW(EXTERNAL) }
#line 7252 "tokenizer.cpp"
yy1081:
	yych = *++cur;
	if (yych == 'D') goto yy1182;
	if (yych == 'd') goto yy1182;
	goto yy55;
yy1082:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 380 "tokenizer.re"
	{ KW(FORM_TEAM) }
#line 7266 "tokenizer.cpp"
yy1084:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 381 "tokenizer.re"
	{ KW(FUNCTION) }
#line 7275 "tokenizer.cpp"
yy1086:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 387 "tokenizer.re"
	{ KW(IMPLICIT) }
#line 7284 "tokenizer.cpp"
yy1088:
	yych = *++cur;
	if (yych <= '"') {
		if (yych <= '\f') {
			if (yych <= '\t') {
				if (yych <= 0x08) goto yy79;
				goto yy1088;
			} else {
				if (yych == '\v') goto yy1088;
				goto yy79;
			}
		} else {
			if (yych <= 0x1F) {
				if (yych <= '\r') goto yy1088;
				goto yy79;
			} else {
				if (yych <= ' ') goto yy1088;
				if (yych <= '!') goto yy79;
				goto yy1184;
			}
		}
	} else {
		if (yych <= '@') {
			if (yych <= '\'') {
				if (yych <= '&') goto yy79;
				goto yy1186;
			} else {
				if (yych <= '/') goto yy79;
				if (yych <= '9') goto yy1188;
				goto yy79;
			}
		} else {
			if (yych <= '_') {
				if (yych <= 'Z') goto yy1190;
				if (yych <= '^') goto yy79;
				goto yy1190;
			} else {
				if (yych <= '`') goto yy79;
				if (yych <= 'z') goto yy1190;
				goto yy79;
			}
		}
	}
yy1090:
	yych = *++cur;
	if (yych == 'E') goto yy1192;
	if (yych == 'e') goto yy1192;
	goto yy55;
yy1091:
	yych = *++cur;
	if (yych == 'C') goto yy1194;
	if (yych == 'c') goto yy1194;
	goto yy55;
yy1092:
	yych = *++cur;
	if (yych == 'I') goto yy1196;
	if (yych == 'i') goto yy1196;
	goto yy55;
yy1093:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 409 "tokenizer.re"
	{ KW(NAMELIST) }
#line 7351 "tokenizer.cpp"
yy1095:
	yych = *++cur;
	if (yych == 'X') goto yy1197;
	if (yych == 'x') goto yy1197;
	goto yy55;
yy1096:
	yych = *++cur;
	if (yych == 'I') goto yy1199;
	if (yych == 'i') goto yy1199;
	goto yy55;
yy1097:
	yych = *++cur;
	if (yych == 'R') goto yy1200;
	if (yych == 'r') goto yy1200;
	goto yy55;
yy1098:
	yych = *++cur;
	if (yych == 'R') goto yy1201;
	if (yych == 'r') goto yy1201;
	goto yy55;
yy1099:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 419 "tokenizer.re"
	{ KW(OPERATOR) }
#line 7380 "tokenizer.cpp"
yy1101:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 420 "tokenizer.re"
	{ KW(OPTIONAL) }
#line 7389 "tokenizer.cpp"
yy1103:
	yych = *++cur;
	if (yych == 'R') goto yy1202;
	if (yych == 'r') goto yy1202;
	goto yy55;
yy1104:
	yych = *++cur;
	if (yych == 'N') goto yy1204;
	if (yych == 'n') goto yy1204;
	goto yy55;
yy1105:
	yych = *++cur;
	if (yych == 'E') goto yy1206;
	if (yych == 'e') goto yy1206;
	goto yy55;
yy1106:
	yych = *++cur;
	if (yych == 'D') goto yy1208;
	if (yych == 'd') goto yy1208;
	goto yy55;
yy1107:
	yych = *++cur;
	if (yych == 'E') goto yy1210;
	if (yych == 'e') goto yy1210;
	goto yy55;
yy1108:
	yych = *++cur;
	if (yych == 'S') goto yy1212;
	if (yych == 's') goto yy1212;
	goto yy55;
yy1109:
	yych = *++cur;
	if (yych == 'N') goto yy1213;
	if (yych == 'n') goto yy1213;
	goto yy55;
yy1110:
	yych = *++cur;
	if (yych == 'P') goto yy1214;
	if (yych == 'p') goto yy1214;
	goto yy55;
yy1111:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 448 "tokenizer.re"
	{ KW(SEQUENCE) }
#line 7438 "tokenizer.cpp"
yy1113:
	yych = *++cur;
	if (yych == 'E') goto yy1215;
	if (yych == 'e') goto yy1215;
	goto yy55;
yy1114:
	yych = *++cur;
	if (yych == 'N') goto yy1217;
	if (yych == 'n') goto yy1217;
	goto yy55;
yy1115:
	yych = *++cur;
	if (yych == 'E') goto yy1218;
	if (yych == 'e') goto yy1218;
	goto yy55;
yy1116:
	yych = *++cur;
	if (yych == 'R') goto yy1219;
	if (yych == 'r') goto yy1219;
	goto yy55;
yy1117:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 459 "tokenizer.re"
	{ KW(SYNC_TEAM) }
#line 7467 "tokenizer.cpp"
yy1119:
	yych = *++cur;
	if (yych == 'B') goto yy1220;
	if (yych == 'b') goto yy1220;
	goto yy55;
yy1120:
	yych = *++cur;
	if (yych == 'T') goto yy1221;
	if (yych == 't') goto yy1221;
	goto yy55;
yy1121:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 469 "tokenizer.re"
	{ KW(VOLATILE) }
#line 7486 "tokenizer.cpp"
yy1123:
	yych = *++cur;
	if (yych <= '/') goto yy889;
	if (yych <= '9') goto yy1123;
	goto yy889;
yy1125:
	yych = *++cur;
	if (yych <= 'Z') {
		if (yych <= '/') goto yy889;
		if (yych <= '9') goto yy1125;
		if (yych <= '@') goto yy889;
		goto yy1125;
	} else {
		if (yych <= '_') {
			if (yych <= '^') goto yy889;
			goto yy1125;
		} else {
			if (yych <= '`') goto yy889;
			if (yych <= 'z') goto yy1125;
			goto yy889;
		}
	}
yy1127:
	yych = *++cur;
	if (yych == 'L') goto yy1222;
	if (yych == 'l') goto yy1222;
	goto yy55;
yy1128:
	yych = *++cur;
	if (yych == 'T') goto yy1223;
	if (yych == 't') goto yy1223;
	goto yy55;
yy1129:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 234 "tokenizer.re"
	{ KW(ASSOCIATE) }
#line 7527 "tokenizer.cpp"
yy1131:
	yych = *++cur;
	if (yych == 'O') goto yy1225;
	if (yych == 'o') goto yy1225;
	goto yy55;
yy1132:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 236 "tokenizer.re"
	{ KW(BACKSPACE) }
#line 7541 "tokenizer.cpp"
yy1134:
	yych = *++cur;
	if (yych == 'M') goto yy1226;
	if (yych == 'm') goto yy1226;
	goto yy55;
yy1135:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 243 "tokenizer.re"
	{ KW(CHARACTER) }
#line 7555 "tokenizer.cpp"
yy1137:
	yych = *++cur;
	if (yych == 'O') goto yy1228;
	if (yych == 'o') goto yy1228;
	goto yy55;
yy1138:
	yych = *++cur;
	if (yych == 'T') goto yy1229;
	if (yych == 't') goto yy1229;
	goto yy55;
yy1139:
	yych = *++cur;
	if (yych == 'S') goto yy1231;
	if (yych == 's') goto yy1231;
	goto yy55;
yy1140:
	yych = *++cur;
	if (yych == 'E') goto yy1233;
	if (yych == 'e') goto yy1233;
	goto yy55;
yy1141:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 259 "tokenizer.re"
	{ KW(DIMENSION) }
#line 7584 "tokenizer.cpp"
yy1143:
	yych = *++cur;
	if (yych == 'C') goto yy1235;
	if (yych == 'c') goto yy1235;
	goto yy55;
yy1144:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 271 "tokenizer.re"
	{ KW(ELEMENTAL) }
#line 7598 "tokenizer.cpp"
yy1146:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 274 "tokenizer.re"
	{ KW(ELSEWHERE) }
#line 7607 "tokenizer.cpp"
yy1148:
	yych = *++cur;
	if (yych == 'I') goto yy1236;
	if (yych == 'i') goto yy1236;
	goto yy79;
yy1149:
	yyaccept = 15;
	yych = *(mar = ++cur);
	if (yych <= '\r') {
		if (yych <= '\n') {
			if (yych == '\t') goto yy1237;
		} else {
			if (yych != '\f') goto yy1237;
		}
	} else {
		if (yych <= 'C') {
			if (yych == ' ') goto yy1237;
		} else {
			if (yych <= 'D') goto yy1239;
			if (yych == 'd') goto yy1239;
		}
	}
yy1150:
#line 287 "tokenizer.re"
	{ KW(END_BLOCK) }
#line 7633 "tokenizer.cpp"
yy1151:
	yych = *++cur;
	if (yych == 'C') goto yy1240;
	if (yych == 'c') goto yy1240;
	goto yy79;
yy1152:
	yych = *++cur;
	if (yych == 'L') goto yy1241;
	if (yych == 'l') goto yy1241;
	goto yy79;
yy1153:
	yych = *++cur;
	if (yych == 'I') goto yy1243;
	if (yych == 'i') goto yy1243;
	goto yy79;
yy1154:
	yych = *++cur;
	if (yych == 'F') goto yy1244;
	if (yych == 'f') goto yy1244;
	goto yy79;
yy1155:
	yych = *++cur;
	if (yych == 'E') goto yy1245;
	if (yych == 'e') goto yy1245;
	goto yy79;
yy1156:
	yych = *++cur;
	if (yych == 'D') goto yy1247;
	if (yych == 'd') goto yy1247;
	goto yy79;
yy1157:
	yych = *++cur;
	if (yych == 'A') goto yy1248;
	if (yych == 'a') goto yy1248;
	goto yy79;
yy1158:
	yych = *++cur;
	if (yych == 'T') goto yy1249;
	if (yych == 't') goto yy1249;
	goto yy79;
yy1159:
	yych = *++cur;
	if (yych == 'D') goto yy1251;
	if (yych == 'd') goto yy1251;
	goto yy79;
yy1160:
	yych = *++cur;
	if (yych == 'U') goto yy1252;
	if (yych == 'u') goto yy1252;
	goto yy79;
yy1161:
	++cur;
#line 346 "tokenizer.re"
	{ KW(END_WHERE) }
#line 7688 "tokenizer.cpp"
yy1163:
	yych = *++cur;
	if (yych == 'A') goto yy1253;
	if (yych == 'a') goto yy1253;
	goto yy55;
yy1164:
	yych = *++cur;
	if (yych <= '\r') {
		if (yych <= '\n') {
			if (yych == '\t') goto yy1164;
			goto yy79;
		} else {
			if (yych == '\f') goto yy79;
			goto yy1164;
		}
	} else {
		if (yych <= 'C') {
			if (yych == ' ') goto yy1164;
			goto yy79;
		} else {
			if (yych <= 'D') goto yy1254;
			if (yych == 'd') goto yy1254;
			goto yy79;
		}
	}
yy1166:
	yych = *++cur;
	if (yych == 'A') goto yy1255;
	if (yych == 'a') goto yy1255;
	goto yy55;
yy1167:
	yych = *++cur;
	if (yych == 'A') goto yy1256;
	if (yych == 'a') goto yy1256;
	goto yy55;
yy1168:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 320 "tokenizer.re"
	{ KW(ENDFORALL) }
#line 7732 "tokenizer.cpp"
yy1170:
	yych = *++cur;
	if (yych == 'O') goto yy1257;
	if (yych == 'o') goto yy1257;
	goto yy55;
yy1171:
	yych = *++cur;
	if (yych == 'A') goto yy1258;
	if (yych == 'a') goto yy1258;
	goto yy55;
yy1172:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 282 "tokenizer.re"
	{ KW(ENDMODULE) }
#line 7751 "tokenizer.cpp"
yy1174:
	yych = *++cur;
	if (yych == 'U') goto yy1259;
	if (yych == 'u') goto yy1259;
	goto yy55;
yy1175:
	yych = *++cur;
	if (yych == 'M') goto yy1260;
	if (yych == 'm') goto yy1260;
	goto yy55;
yy1176:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 308 "tokenizer.re"
	{ KW(ENDSELECT) }
#line 7770 "tokenizer.cpp"
yy1178:
	yych = *++cur;
	if (yych == 'U') goto yy1262;
	if (yych == 'u') goto yy1262;
	goto yy55;
yy1179:
	yych = *++cur;
	if (yych == 'T') goto yy1263;
	if (yych == 't') goto yy1263;
	goto yy55;
yy1180:
	yych = *++cur;
	if (yych == 'R') goto yy1264;
	if (yych == 'r') goto yy1264;
	goto yy55;
yy1181:
	yych = *++cur;
	if (yych == 'C') goto yy1266;
	if (yych == 'c') goto yy1266;
	goto yy55;
yy1182:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 378 "tokenizer.re"
	{ KW(FORMATTED) }
#line 7799 "tokenizer.cpp"
yy1184:
	yych = *++cur;
	if (yych <= 0x00) goto yy79;
	if (yych == '"') goto yy1267;
	goto yy1184;
yy1186:
	yych = *++cur;
	if (yych <= 0x00) goto yy79;
	if (yych == '\'') goto yy1269;
	goto yy1186;
yy1188:
	yych = *++cur;
	if (yych <= '/') goto yy79;
	if (yych <= '9') goto yy1188;
	if (yych == '_') goto yy1271;
	goto yy79;
yy1190:
	yych = *++cur;
	if (yych <= 'Z') {
		if (yych <= '/') goto yy79;
		if (yych <= '9') goto yy1190;
		if (yych <= '@') goto yy79;
		goto yy1190;
	} else {
		if (yych <= '_') {
			if (yych <= '^') goto yy79;
			goto yy1272;
		} else {
			if (yych <= '`') goto yy79;
			if (yych <= 'z') goto yy1190;
			goto yy79;
		}
	}
yy1192:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 397 "tokenizer.re"
	{ KW(INTERFACE) }
#line 7841 "tokenizer.cpp"
yy1194:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 398 "tokenizer.re"
	{ KW(INTRINSIC) }
#line 7850 "tokenizer.cpp"
yy1196:
	yych = *++cur;
	if (yych == 'T') goto yy1274;
	if (yych == 't') goto yy1274;
	goto yy55;
yy1197:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 410 "tokenizer.re"
	{ KW(NEW_INDEX) }
#line 7864 "tokenizer.cpp"
yy1199:
	yych = *++cur;
	if (yych == 'N') goto yy1276;
	if (yych == 'n') goto yy1276;
	goto yy55;
yy1200:
	yych = *++cur;
	if (yych == 'I') goto yy1277;
	if (yych == 'i') goto yy1277;
	goto yy55;
yy1201:
	yych = *++cur;
	if (yych == 'S') goto yy1278;
	if (yych == 's') goto yy1278;
	goto yy55;
yy1202:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 422 "tokenizer.re"
	{ KW(PARAMETER) }
#line 7888 "tokenizer.cpp"
yy1204:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 426 "tokenizer.re"
	{ KW(PRECISION) }
#line 7897 "tokenizer.cpp"
yy1206:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 429 "tokenizer.re"
	{ KW(PROCEDURE) }
#line 7906 "tokenizer.cpp"
yy1208:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 431 "tokenizer.re"
	{ KW(PROTECTED) }
#line 7915 "tokenizer.cpp"
yy1210:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 438 "tokenizer.re"
	{ KW(RECURSIVE) }
#line 7924 "tokenizer.cpp"
yy1212:
	yych = *++cur;
	if (yych == 'E') goto yy1279;
	if (yych == 'e') goto yy1279;
	goto yy55;
yy1213:
	yych = *++cur;
	if (yych == 'K') goto yy1281;
	if (yych == 'k') goto yy1281;
	goto yy55;
yy1214:
	yych = *++cur;
	if (yych == 'E') goto yy1283;
	if (yych == 'e') goto yy1283;
	goto yy55;
yy1215:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 453 "tokenizer.re"
	{ KW(SUBMODULE) }
#line 7948 "tokenizer.cpp"
yy1217:
	yych = *++cur;
	if (yych == 'E') goto yy1285;
	if (yych == 'e') goto yy1285;
	goto yy55;
yy1218:
	yych = *++cur;
	if (yych == 'S') goto yy1287;
	if (yych == 's') goto yy1287;
	goto yy55;
yy1219:
	yych = *++cur;
	if (yych == 'Y') goto yy1289;
	if (yych == 'y') goto yy1289;
	goto yy55;
yy1220:
	yych = *++cur;
	if (yych == 'E') goto yy1291;
	if (yych == 'e') goto yy1291;
	goto yy55;
yy1221:
	yych = *++cur;
	if (yych == 'E') goto yy1292;
	if (yych == 'e') goto yy1292;
	goto yy55;
yy1222:
	yych = *++cur;
	if (yych == 'E') goto yy1293;
	if (yych == 'e') goto yy1293;
	goto yy55;
yy1223:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 233 "tokenizer.re"
	{ KW(ASSIGNMENT) }
#line 7987 "tokenizer.cpp"
yy1225:
	yych = *++cur;
	if (yych == 'U') goto yy1295;
	if (yych == 'u') goto yy1295;
	goto yy55;
yy1226:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 242 "tokenizer.re"
	{ KW(CHANGE_TEAM) }
#line 8001 "tokenizer.cpp"
yy1228:
	yych = *++cur;
	if (yych == 'N') goto yy1296;
	if (yych == 'n') goto yy1296;
	goto yy55;
yy1229:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 249 "tokenizer.re"
	{ KW(CONCURRENT) }
#line 8015 "tokenizer.cpp"
yy1231:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 251 "tokenizer.re"
	{ KW(CONTIGUOUS) }
#line 8024 "tokenizer.cpp"
yy1233:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 256 "tokenizer.re"
	{ KW(DEALLOCATE) }
#line 8033 "tokenizer.cpp"
yy1235:
	yych = *++cur;
	if (yych == 'I') goto yy1298;
	if (yych == 'i') goto yy1298;
	goto yy55;
yy1236:
	yych = *++cur;
	if (yych == 'A') goto yy1299;
	if (yych == 'a') goto yy1299;
	goto yy79;
yy1237:
	yych = *++cur;
	if (yych <= '\r') {
		if (yych <= '\n') {
			if (yych == '\t') goto yy1237;
			goto yy79;
		} else {
			if (yych == '\f') goto yy79;
			goto yy1237;
		}
	} else {
		if (yych <= 'C') {
			if (yych == ' ') goto yy1237;
			goto yy79;
		} else {
			if (yych <= 'D') goto yy1300;
			if (yych == 'd') goto yy1300;
			goto yy79;
		}
	}
yy1239:
	yych = *++cur;
	if (yych == 'A') goto yy1301;
	if (yych == 'a') goto yy1301;
	goto yy79;
yy1240:
	yych = *++cur;
	if (yych == 'A') goto yy1302;
	if (yych == 'a') goto yy1302;
	goto yy79;
yy1241:
	++cur;
#line 319 "tokenizer.re"
	{ KW(END_FORALL) }
#line 8078 "tokenizer.cpp"
yy1243:
	yych = *++cur;
	if (yych == 'O') goto yy1303;
	if (yych == 'o') goto yy1303;
	goto yy79;
yy1244:
	yych = *++cur;
	if (yych == 'A') goto yy1304;
	if (yych == 'a') goto yy1304;
	goto yy79;
yy1245:
	++cur;
#line 281 "tokenizer.re"
	{ KW(END_MODULE) }
#line 8093 "tokenizer.cpp"
yy1247:
	yych = *++cur;
	if (yych == 'U') goto yy1305;
	if (yych == 'u') goto yy1305;
	goto yy79;
yy1248:
	yych = *++cur;
	if (yych == 'M') goto yy1306;
	if (yych == 'm') goto yy1306;
	goto yy79;
yy1249:
	++cur;
#line 307 "tokenizer.re"
	{ KW(END_SELECT) }
#line 8108 "tokenizer.cpp"
yy1251:
	yych = *++cur;
	if (yych == 'U') goto yy1308;
	if (yych == 'u') goto yy1308;
	goto yy79;
yy1252:
	yych = *++cur;
	if (yych == 'T') goto yy1309;
	if (yych == 't') goto yy1309;
	goto yy79;
yy1253:
	yych = *++cur;
	if (yych == 'T') goto yy1310;
	if (yych == 't') goto yy1310;
	goto yy55;
yy1254:
	yych = *++cur;
	if (yych == 'A') goto yy1311;
	if (yych == 'a') goto yy1311;
	goto yy79;
yy1255:
	yych = *++cur;
	if (yych == 'T') goto yy1312;
	if (yych == 't') goto yy1312;
	goto yy55;
yy1256:
	yych = *++cur;
	if (yych == 'L') goto yy1313;
	if (yych == 'l') goto yy1313;
	goto yy55;
yy1257:
	yych = *++cur;
	if (yych == 'N') goto yy1315;
	if (yych == 'n') goto yy1315;
	goto yy55;
yy1258:
	yych = *++cur;
	if (yych == 'C') goto yy1317;
	if (yych == 'c') goto yy1317;
	goto yy55;
yy1259:
	yych = *++cur;
	if (yych == 'R') goto yy1318;
	if (yych == 'r') goto yy1318;
	goto yy55;
yy1260:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 279 "tokenizer.re"
	{ KW(ENDPROGRAM) }
#line 8162 "tokenizer.cpp"
yy1262:
	yych = *++cur;
	if (yych == 'L') goto yy1319;
	if (yych == 'l') goto yy1319;
	goto yy55;
yy1263:
	yych = *++cur;
	if (yych == 'I') goto yy1320;
	if (yych == 'i') goto yy1320;
	goto yy55;
yy1264:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 354 "tokenizer.re"
	{ KW(ENUMERATOR) }
#line 8181 "tokenizer.cpp"
yy1266:
	yych = *++cur;
	if (yych == 'E') goto yy1321;
	if (yych == 'e') goto yy1321;
	goto yy55;
yy1267:
	yyaccept = 16;
	yych = *(mar = ++cur);
	if (yych == '"') goto yy1184;
yy1268:
#line 618 "tokenizer.re"
	{ continue; }
#line 8194 "tokenizer.cpp"
yy1269:
	yyaccept = 17;
	yych = *(mar = ++cur);
	if (yych == '\'') goto yy1186;
yy1270:
#line 619 "tokenizer.re"
	{ continue; }
#line 8202 "tokenizer.cpp"
yy1271:
	yych = *++cur;
	if (yych == '"') goto yy1184;
	if (yych == '\'') goto yy1186;
	goto yy79;
yy1272:
	yych = *++cur;
	if (yych <= '9') {
		if (yych <= '&') {
			if (yych == '"') goto yy1184;
			goto yy79;
		} else {
			if (yych <= '\'') goto yy1186;
			if (yych <= '/') goto yy79;
			goto yy1190;
		}
	} else {
		if (yych <= '^') {
			if (yych <= '@') goto yy79;
			if (yych <= 'Z') goto yy1190;
			goto yy79;
		} else {
			if (yych <= '_') goto yy1272;
			if (yych <= '`') goto yy79;
			if (yych <= 'z') goto yy1190;
			goto yy79;
		}
	}
yy1274:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 403 "tokenizer.re"
	{ KW(LOCAL_INIT) }
#line 8239 "tokenizer.cpp"
yy1276:
	yych = *++cur;
	if (yych == 'S') goto yy1323;
	if (yych == 's') goto yy1323;
	goto yy55;
yy1277:
	yych = *++cur;
	if (yych == 'D') goto yy1324;
	if (yych == 'd') goto yy1324;
	goto yy55;
yy1278:
	yych = *++cur;
	if (yych == 'I') goto yy1325;
	if (yych == 'i') goto yy1325;
	goto yy55;
yy1279:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 445 "tokenizer.re"
	{ KW(SELECT_CASE) }
#line 8263 "tokenizer.cpp"
yy1281:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 446 "tokenizer.re"
	{ KW(SELECT_RANK) }
#line 8272 "tokenizer.cpp"
yy1283:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 447 "tokenizer.re"
	{ KW(SELECT_TYPE) }
#line 8281 "tokenizer.cpp"
yy1285:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 454 "tokenizer.re"
	{ KW(SUBROUTINE) }
#line 8290 "tokenizer.cpp"
yy1287:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 457 "tokenizer.re"
	{ KW(SYNC_IMAGES) }
#line 8299 "tokenizer.cpp"
yy1289:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 458 "tokenizer.re"
	{ KW(SYNC_MEMORY) }
#line 8308 "tokenizer.cpp"
yy1291:
	yych = *++cur;
	if (yych == 'R') goto yy1326;
	if (yych == 'r') goto yy1326;
	goto yy55;
yy1292:
	yych = *++cur;
	if (yych == 'D') goto yy1328;
	if (yych == 'd') goto yy1328;
	goto yy55;
yy1293:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 230 "tokenizer.re"
	{ KW(ALLOCATABLE) }
#line 8327 "tokenizer.cpp"
yy1295:
	yych = *++cur;
	if (yych == 'S') goto yy1330;
	if (yych == 's') goto yy1330;
	goto yy55;
yy1296:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 246 "tokenizer.re"
	{ KW(CODIMENSION) }
#line 8341 "tokenizer.cpp"
yy1298:
	yych = *++cur;
	if (yych == 'S') goto yy1332;
	if (yych == 's') goto yy1332;
	goto yy55;
yy1299:
	yych = *++cur;
	if (yych == 'T') goto yy1333;
	if (yych == 't') goto yy1333;
	goto yy79;
yy1300:
	yych = *++cur;
	if (yych == 'A') goto yy1334;
	if (yych == 'a') goto yy1334;
	goto yy79;
yy1301:
	yych = *++cur;
	if (yych == 'T') goto yy1335;
	if (yych == 't') goto yy1335;
	goto yy79;
yy1302:
	yych = *++cur;
	if (yych == 'L') goto yy1336;
	if (yych == 'l') goto yy1336;
	goto yy79;
yy1303:
	yych = *++cur;
	if (yych == 'N') goto yy1338;
	if (yych == 'n') goto yy1338;
	goto yy79;
yy1304:
	yych = *++cur;
	if (yych == 'C') goto yy1340;
	if (yych == 'c') goto yy1340;
	goto yy79;
yy1305:
	yych = *++cur;
	if (yych == 'R') goto yy1341;
	if (yych == 'r') goto yy1341;
	goto yy79;
yy1306:
	++cur;
#line 278 "tokenizer.re"
	{ KW(END_PROGRAM) }
#line 8386 "tokenizer.cpp"
yy1308:
	yych = *++cur;
	if (yych == 'L') goto yy1342;
	if (yych == 'l') goto yy1342;
	goto yy79;
yy1309:
	yych = *++cur;
	if (yych == 'I') goto yy1343;
	if (yych == 'i') goto yy1343;
	goto yy79;
yy1310:
	yych = *++cur;
	if (yych == 'E') goto yy1344;
	if (yych == 'e') goto yy1344;
	goto yy55;
yy1311:
	yych = *++cur;
	if (yych == 'T') goto yy1346;
	if (yych == 't') goto yy1346;
	goto yy79;
yy1312:
	yych = *++cur;
	if (yych == 'A') goto yy1347;
	if (yych == 'a') goto yy1347;
	goto yy55;
yy1313:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 314 "tokenizer.re"
	{ KW(ENDCRITICAL) }
#line 8420 "tokenizer.cpp"
yy1315:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 299 "tokenizer.re"
	{ KW(ENDFUNCTION) }
#line 8429 "tokenizer.cpp"
yy1317:
	yych = *++cur;
	if (yych == 'E') goto yy1349;
	if (yych == 'e') goto yy1349;
	goto yy55;
yy1318:
	yych = *++cur;
	if (yych == 'E') goto yy1351;
	if (yych == 'e') goto yy1351;
	goto yy55;
yy1319:
	yych = *++cur;
	if (yych == 'E') goto yy1353;
	if (yych == 'e') goto yy1353;
	goto yy55;
yy1320:
	yych = *++cur;
	if (yych == 'N') goto yy1355;
	if (yych == 'n') goto yy1355;
	goto yy55;
yy1321:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 355 "tokenizer.re"
	{ KW(EQUIVALENCE) }
#line 8458 "tokenizer.cpp"
yy1323:
	yych = *++cur;
	if (yych == 'I') goto yy1356;
	if (yych == 'i') goto yy1356;
	goto yy55;
yy1324:
	yych = *++cur;
	if (yych == 'A') goto yy1357;
	if (yych == 'a') goto yy1357;
	goto yy55;
yy1325:
	yych = *++cur;
	if (yych == 'V') goto yy1358;
	if (yych == 'v') goto yy1358;
	goto yy55;
yy1326:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 462 "tokenizer.re"
	{ KW(TEAM_NUMBER) }
#line 8482 "tokenizer.cpp"
yy1328:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 466 "tokenizer.re"
	{ KW(UNFORMATTED) }
#line 8491 "tokenizer.cpp"
yy1330:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 235 "tokenizer.re"
	{ KW(ASYNCHRONOUS) }
#line 8500 "tokenizer.cpp"
yy1332:
	yych = *++cur;
	if (yych == 'I') goto yy1359;
	if (yych == 'i') goto yy1359;
	goto yy55;
yy1333:
	yych = *++cur;
	if (yych == 'E') goto yy1360;
	if (yych == 'e') goto yy1360;
	goto yy79;
yy1334:
	yych = *++cur;
	if (yych == 'T') goto yy1362;
	if (yych == 't') goto yy1362;
	goto yy79;
yy1335:
	yych = *++cur;
	if (yych == 'A') goto yy1363;
	if (yych == 'a') goto yy1363;
	goto yy79;
yy1336:
	++cur;
#line 313 "tokenizer.re"
	{ KW(END_CRITICAL) }
#line 8525 "tokenizer.cpp"
yy1338:
	++cur;
#line 298 "tokenizer.re"
	{ KW(END_FUNCTION) }
#line 8530 "tokenizer.cpp"
yy1340:
	yych = *++cur;
	if (yych == 'E') goto yy1365;
	if (yych == 'e') goto yy1365;
	goto yy79;
yy1341:
	yych = *++cur;
	if (yych == 'E') goto yy1367;
	if (yych == 'e') goto yy1367;
	goto yy79;
yy1342:
	yych = *++cur;
	if (yych == 'E') goto yy1369;
	if (yych == 'e') goto yy1369;
	goto yy79;
yy1343:
	yych = *++cur;
	if (yych == 'N') goto yy1371;
	if (yych == 'n') goto yy1371;
	goto yy79;
yy1344:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 311 "tokenizer.re"
	{ KW(ENDASSOCIATE) }
#line 8559 "tokenizer.cpp"
yy1346:
	yych = *++cur;
	if (yych == 'A') goto yy1372;
	if (yych == 'a') goto yy1372;
	goto yy79;
yy1347:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 293 "tokenizer.re"
	{ KW(ENDBLOCKDATA) }
#line 8573 "tokenizer.cpp"
yy1349:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 326 "tokenizer.re"
	{ KW(ENDINTERFACE) }
#line 8582 "tokenizer.cpp"
yy1351:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 302 "tokenizer.re"
	{ KW(ENDPROCEDURE) }
#line 8591 "tokenizer.cpp"
yy1353:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 285 "tokenizer.re"
	{ KW(ENDSUBMODULE) }
#line 8600 "tokenizer.cpp"
yy1355:
	yych = *++cur;
	if (yych == 'E') goto yy1374;
	if (yych == 'e') goto yy1374;
	goto yy55;
yy1356:
	yych = *++cur;
	if (yych == 'C') goto yy1376;
	if (yych == 'c') goto yy1376;
	goto yy55;
yy1357:
	yych = *++cur;
	if (yych == 'B') goto yy1378;
	if (yych == 'b') goto yy1378;
	goto yy55;
yy1358:
	yych = *++cur;
	if (yych == 'E') goto yy1379;
	if (yych == 'e') goto yy1379;
	goto yy55;
yy1359:
	yych = *++cur;
	if (yych == 'O') goto yy1381;
	if (yych == 'o') goto yy1381;
	goto yy55;
yy1360:
	++cur;
#line 310 "tokenizer.re"
	{ KW(END_ASSOCIATE) }
#line 8630 "tokenizer.cpp"
yy1362:
	yych = *++cur;
	if (yych == 'A') goto yy1382;
	if (yych == 'a') goto yy1382;
	goto yy79;
yy1363:
	++cur;
#line 292 "tokenizer.re"
	{ KW(END_BLOCK_DATA) }
#line 8640 "tokenizer.cpp"
yy1365:
	++cur;
#line 325 "tokenizer.re"
	{ KW(END_INTERFACE) }
#line 8645 "tokenizer.cpp"
yy1367:
	++cur;
#line 301 "tokenizer.re"
	{ KW(END_PROCEDURE) }
#line 8650 "tokenizer.cpp"
yy1369:
	++cur;
#line 284 "tokenizer.re"
	{ KW(END_SUBMODULE) }
#line 8655 "tokenizer.cpp"
yy1371:
	yych = *++cur;
	if (yych == 'E') goto yy1384;
	if (yych == 'e') goto yy1384;
	goto yy79;
yy1372:
	++cur;
#line 291 "tokenizer.re"
	{ KW(END_BLOCK_DATA) }
#line 8665 "tokenizer.cpp"
yy1374:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 296 "tokenizer.re"
	{ KW(ENDSUBROUTINE) }
#line 8674 "tokenizer.cpp"
yy1376:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 412 "tokenizer.re"
	{ KW(NON_INTRINSIC) }
#line 8683 "tokenizer.cpp"
yy1378:
	yych = *++cur;
	if (yych == 'L') goto yy1386;
	if (yych == 'l') goto yy1386;
	goto yy55;
yy1379:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 414 "tokenizer.re"
	{ KW(NON_RECURSIVE) }
#line 8697 "tokenizer.cpp"
yy1381:
	yych = *++cur;
	if (yych == 'N') goto yy1387;
	if (yych == 'n') goto yy1387;
	goto yy55;
yy1382:
	++cur;
#line 290 "tokenizer.re"
	{ KW(END_BLOCK_DATA) }
#line 8707 "tokenizer.cpp"
yy1384:
	++cur;
#line 295 "tokenizer.re"
	{ KW(END_SUBROUTINE) }
#line 8712 "tokenizer.cpp"
yy1386:
	yych = *++cur;
	if (yych == 'E') goto yy1389;
	if (yych == 'e') goto yy1389;
	goto yy55;
yy1387:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 270 "tokenizer.re"
	{ KW(DOUBLE_PRECISION) }
#line 8726 "tokenizer.cpp"
yy1389:
	yych = *++cur;
	if (yybm[256+yych] & 32) {
		goto yy54;
	}
	if (yych == '_') goto yy143;
#line 413 "tokenizer.re"
	{ KW(NON_OVERRIDABLE) }
#line 8735 "tokenizer.cpp"
}
#line 626 "tokenizer.re"

    }
}

std::string token(unsigned char *tok, unsigned char* cur)
{
    return std::string((char *)tok, cur - tok);
}

void token_loc(Location &loc)
{
    loc.first_line = 1;
    loc.last_line = 1;
    loc.first_column = 1;
    loc.last_column = 1;
}

void lex_format(unsigned char *&cur, Location &loc,
        unsigned char *&start) {
    int num_paren = 0;
    for (;;) {
        unsigned char *tok = cur;
        unsigned char *mar;
        
#line 8762 "tokenizer.cpp"
{
	unsigned char yych;
	unsigned int yyaccept = 0;
	static const unsigned char yybm[] = {
		  0, 208, 208, 208, 208, 208, 208, 208, 
		208, 244, 176, 244, 208, 244, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		244, 208, 192, 208, 208, 208, 208,  80, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		216, 216, 216, 216, 216, 216, 216, 216, 
		216, 216, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
		208, 208, 208, 208, 208, 208, 208, 208, 
	};
	yych = *cur;
	if (yybm[0+yych] & 4) {
		goto yy1397;
	}
	switch (yych) {
	case 0x00:	goto yy1393;
	case '"':	goto yy1400;
	case '&':	goto yy1401;
	case '\'':	goto yy1402;
	case '(':	goto yy1403;
	case ')':	goto yy1405;
	case '*':	goto yy1407;
	case ',':	goto yy1408;
	case '/':
	case ':':	goto yy1410;
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':	goto yy1412;
	case 'A':
	case 'a':	goto yy1413;
	case 'B':
	case 'I':
	case 'O':
	case 'Z':
	case 'b':
	case 'i':
	case 'o':
	case 'z':	goto yy1416;
	case 'D':
	case 'F':
	case 'd':
	case 'f':	goto yy1417;
	case 'E':
	case 'e':	goto yy1418;
	case 'G':
	case 'g':	goto yy1419;
	case 'L':
	case 'l':	goto yy1420;
	case 'P':
	case 'p':	goto yy1421;
	case 'T':
	case 't':	goto yy1422;
	case 'X':
	case 'x':	goto yy1423;
	default:	goto yy1395;
	}
yy1393:
	++cur;
#line 721 "tokenizer.re"
	{
                token_loc(loc);
                std::string t = token(tok, cur);
                throw LFortran::TokenizerError(
                    "End of file not expected in `format` statemenet", loc, t);
            }
#line 8862 "tokenizer.cpp"
yy1395:
	++cur;
yy1396:
#line 687 "tokenizer.re"
	{
                token_loc(loc);
                std::string t = token(tok, cur);
                throw LFortran::TokenizerError("Token '" + t
                    + "' is not recognized in `format` statement", loc, t);
            }
#line 8873 "tokenizer.cpp"
yy1397:
	yych = *++cur;
	if (yybm[0+yych] & 4) {
		goto yy1397;
	}
#line 727 "tokenizer.re"
	{ continue; }
#line 8881 "tokenizer.cpp"
yy1400:
	yyaccept = 0;
	yych = *(mar = ++cur);
	if (yych <= 0x00) goto yy1396;
	goto yy1425;
yy1401:
	yyaccept = 0;
	yych = *(mar = ++cur);
	if (yych <= '\f') {
		if (yych <= 0x08) goto yy1396;
		if (yych <= '\v') goto yy1430;
		goto yy1396;
	} else {
		if (yych <= '\r') goto yy1430;
		if (yych <= 0x1F) goto yy1396;
		if (yych <= '!') goto yy1430;
		goto yy1396;
	}
yy1402:
	yyaccept = 0;
	yych = *(mar = ++cur);
	if (yych <= 0x00) goto yy1396;
	goto yy1437;
yy1403:
	++cur;
#line 693 "tokenizer.re"
	{
                if (num_paren == 0) {
                    num_paren++;
                    start = cur;
                    continue;
                } else {
                    cur--;
                    unsigned char *tmp;
                    lex_format(cur, loc, tmp);
                    continue;
                }
            }
#line 8920 "tokenizer.cpp"
yy1405:
	++cur;
#line 717 "tokenizer.re"
	{
                LFORTRAN_ASSERT(num_paren == 1);
                return;
            }
#line 8928 "tokenizer.cpp"
yy1407:
	yyaccept = 0;
	yych = *(mar = ++cur);
	if (yych <= '\f') {
		if (yych <= '\t') {
			if (yych <= 0x08) goto yy1396;
			goto yy1440;
		} else {
			if (yych == '\v') goto yy1440;
			goto yy1396;
		}
	} else {
		if (yych <= ' ') {
			if (yych <= '\r') goto yy1440;
			if (yych <= 0x1F) goto yy1396;
			goto yy1440;
		} else {
			if (yych == '(') goto yy1442;
			goto yy1396;
		}
	}
yy1408:
	++cur;
#line 728 "tokenizer.re"
	{ continue; }
#line 8954 "tokenizer.cpp"
yy1410:
	++cur;
yy1411:
#line 733 "tokenizer.re"
	{ continue; }
#line 8960 "tokenizer.cpp"
yy1412:
	yyaccept = 0;
	yych = *(mar = ++cur);
	switch (yych) {
	case '\t':
	case '\v':
	case '\r':
	case ' ':
	case '(':
	case '/':
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'D':
	case 'E':
	case 'F':
	case 'G':
	case 'I':
	case 'L':
	case 'O':
	case 'P':
	case 'X':
	case 'Z':
	case 'a':
	case 'b':
	case 'd':
	case 'e':
	case 'f':
	case 'g':
	case 'i':
	case 'l':
	case 'o':
	case 'p':
	case 'x':
	case 'z':	goto yy1449;
	default:	goto yy1396;
	}
yy1413:
	yych = *++cur;
	if (yybm[0+yych] & 8) {
		goto yy1413;
	}
yy1415:
#line 732 "tokenizer.re"
	{ continue; }
#line 9015 "tokenizer.cpp"
yy1416:
	yych = *++cur;
	if (yych <= '/') goto yy1396;
	if (yych <= '9') goto yy1455;
	goto yy1396;
yy1417:
	yyaccept = 0;
	yych = *(mar = ++cur);
	if (yych <= '/') goto yy1396;
	if (yych <= '9') goto yy1457;
	goto yy1396;
yy1418:
	yyaccept = 0;
	yych = *(mar = ++cur);
	if (yych <= 'W') {
		if (yych <= 'M') {
			if (yych <= '/') goto yy1396;
			if (yych <= '9') goto yy1459;
			goto yy1396;
		} else {
			if (yych <= 'N') goto yy1461;
			if (yych == 'S') goto yy1461;
			goto yy1396;
		}
	} else {
		if (yych <= 'r') {
			if (yych <= 'X') goto yy1461;
			if (yych == 'n') goto yy1461;
			goto yy1396;
		} else {
			if (yych <= 's') goto yy1461;
			if (yych == 'x') goto yy1461;
			goto yy1396;
		}
	}
yy1419:
	yych = *++cur;
	if (yych <= '/') goto yy1396;
	if (yych <= '9') goto yy1462;
	goto yy1396;
yy1420:
	yych = *++cur;
	if (yybm[0+yych] & 8) {
		goto yy1413;
	}
	goto yy1396;
yy1421:
	yyaccept = 1;
	yych = *(mar = ++cur);
	if (yych <= 'D') goto yy1415;
	if (yych <= 'F') goto yy1451;
	if (yych <= 'd') goto yy1415;
	if (yych <= 'f') goto yy1451;
	goto yy1415;
yy1422:
	yyaccept = 0;
	yych = *(mar = ++cur);
	if (yych <= 'Q') {
		if (yych <= '9') {
			if (yych <= '/') goto yy1396;
			goto yy1464;
		} else {
			if (yych == 'L') goto yy1466;
			goto yy1396;
		}
	} else {
		if (yych <= 'l') {
			if (yych <= 'R') goto yy1466;
			if (yych <= 'k') goto yy1396;
			goto yy1466;
		} else {
			if (yych == 'r') goto yy1466;
			goto yy1396;
		}
	}
yy1423:
	++cur;
	goto yy1415;
yy1424:
	yych = *++cur;
yy1425:
	if (yybm[0+yych] & 16) {
		goto yy1424;
	}
	if (yych >= 0x01) goto yy1427;
yy1426:
	cur = mar;
	if (yyaccept <= 2) {
		if (yyaccept <= 1) {
			if (yyaccept == 0) {
				goto yy1396;
			} else {
				goto yy1415;
			}
		} else {
			goto yy1428;
		}
	} else {
		if (yyaccept == 3) {
			goto yy1433;
		} else {
			goto yy1439;
		}
	}
yy1427:
	yyaccept = 2;
	yych = *(mar = ++cur);
	if (yych == '"') goto yy1424;
yy1428:
#line 730 "tokenizer.re"
	{ continue; }
#line 9127 "tokenizer.cpp"
yy1429:
	yych = *++cur;
yy1430:
	if (yych <= '\f') {
		if (yych <= '\t') {
			if (yych <= 0x08) goto yy1426;
			goto yy1429;
		} else {
			if (yych <= '\n') goto yy1431;
			if (yych <= '\v') goto yy1429;
			goto yy1426;
		}
	} else {
		if (yych <= 0x1F) {
			if (yych <= '\r') goto yy1429;
			goto yy1426;
		} else {
			if (yych <= ' ') goto yy1429;
			if (yych <= '!') goto yy1434;
			goto yy1426;
		}
	}
yy1431:
	yyaccept = 3;
	yych = *(mar = ++cur);
	if (yybm[0+yych] & 32) {
		goto yy1431;
	}
	if (yych <= 0x1F) goto yy1433;
	if (yych <= '!') goto yy1434;
	if (yych == '&') goto yy1467;
yy1433:
#line 729 "tokenizer.re"
	{ continue; }
#line 9162 "tokenizer.cpp"
yy1434:
	yych = *++cur;
	if (yybm[0+yych] & 64) {
		goto yy1434;
	}
	if (yych <= 0x00) goto yy1426;
	goto yy1431;
yy1436:
	yych = *++cur;
yy1437:
	if (yybm[0+yych] & 128) {
		goto yy1436;
	}
	if (yych <= 0x00) goto yy1426;
	yyaccept = 4;
	yych = *(mar = ++cur);
	if (yych == '\'') goto yy1436;
yy1439:
#line 731 "tokenizer.re"
	{ continue; }
#line 9183 "tokenizer.cpp"
yy1440:
	yych = *++cur;
	if (yych <= '\f') {
		if (yych <= '\t') {
			if (yych <= 0x08) goto yy1426;
			goto yy1440;
		} else {
			if (yych == '\v') goto yy1440;
			goto yy1426;
		}
	} else {
		if (yych <= ' ') {
			if (yych <= '\r') goto yy1440;
			if (yych <= 0x1F) goto yy1426;
			goto yy1440;
		} else {
			if (yych != '(') goto yy1426;
		}
	}
yy1442:
	++cur;
#line 711 "tokenizer.re"
	{
                cur--;
                unsigned char *tmp;
                lex_format(cur, loc, tmp);
                continue;
            }
#line 9212 "tokenizer.cpp"
yy1444:
	yych = *++cur;
	if (yych <= '\f') {
		if (yych <= '\t') {
			if (yych <= 0x08) goto yy1426;
			goto yy1444;
		} else {
			if (yych == '\v') goto yy1444;
			goto yy1426;
		}
	} else {
		if (yych <= ' ') {
			if (yych <= '\r') goto yy1444;
			if (yych <= 0x1F) goto yy1426;
			goto yy1444;
		} else {
			if (yych != '(') goto yy1426;
		}
	}
yy1446:
	++cur;
#line 705 "tokenizer.re"
	{
                cur--;
                unsigned char *tmp;
                lex_format(cur, loc, tmp);
                continue;
            }
#line 9241 "tokenizer.cpp"
yy1448:
	yych = *++cur;
yy1449:
	switch (yych) {
	case '\t':
	case '\v':
	case '\r':
	case ' ':	goto yy1444;
	case '(':	goto yy1446;
	case '/':	goto yy1410;
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':	goto yy1448;
	case 'A':
	case 'a':	goto yy1413;
	case 'B':
	case 'I':
	case 'O':
	case 'Z':
	case 'b':
	case 'i':
	case 'o':
	case 'z':	goto yy1450;
	case 'D':
	case 'F':
	case 'd':
	case 'f':	goto yy1451;
	case 'E':
	case 'e':	goto yy1452;
	case 'G':
	case 'g':	goto yy1453;
	case 'L':
	case 'l':	goto yy1454;
	case 'P':
	case 'p':	goto yy1421;
	case 'X':
	case 'x':	goto yy1423;
	default:	goto yy1426;
	}
yy1450:
	yych = *++cur;
	if (yych <= '/') goto yy1426;
	if (yych <= '9') goto yy1455;
	goto yy1426;
yy1451:
	yych = *++cur;
	if (yych <= '/') goto yy1426;
	if (yych <= '9') goto yy1457;
	goto yy1426;
yy1452:
	yych = *++cur;
	if (yych <= 'W') {
		if (yych <= 'M') {
			if (yych <= '/') goto yy1426;
			if (yych <= '9') goto yy1459;
			goto yy1426;
		} else {
			if (yych <= 'N') goto yy1461;
			if (yych == 'S') goto yy1461;
			goto yy1426;
		}
	} else {
		if (yych <= 'r') {
			if (yych <= 'X') goto yy1461;
			if (yych == 'n') goto yy1461;
			goto yy1426;
		} else {
			if (yych <= 's') goto yy1461;
			if (yych == 'x') goto yy1461;
			goto yy1426;
		}
	}
yy1453:
	yych = *++cur;
	if (yych <= '/') goto yy1426;
	if (yych <= '9') goto yy1462;
	goto yy1426;
yy1454:
	yych = *++cur;
	if (yybm[0+yych] & 8) {
		goto yy1413;
	}
	goto yy1426;
yy1455:
	yyaccept = 1;
	yych = *(mar = ++cur);
	if (yych == '.') goto yy1454;
	if (yych <= '/') goto yy1415;
	if (yych <= '9') goto yy1455;
	goto yy1415;
yy1457:
	yych = *++cur;
	if (yych == '.') goto yy1454;
	if (yych <= '/') goto yy1426;
	if (yych <= '9') goto yy1457;
	goto yy1426;
yy1459:
	yych = *++cur;
	if (yych == '.') goto yy1468;
	if (yych <= '/') goto yy1426;
	if (yych <= '9') goto yy1459;
	goto yy1426;
yy1461:
	yych = *++cur;
	if (yych <= '/') goto yy1426;
	if (yych <= '9') goto yy1459;
	goto yy1426;
yy1462:
	yyaccept = 1;
	yych = *(mar = ++cur);
	if (yych == '.') goto yy1468;
	if (yych <= '/') goto yy1415;
	if (yych <= '9') goto yy1462;
	goto yy1415;
yy1464:
	yych = *++cur;
	if (yych <= '/') goto yy1411;
	if (yych <= '9') goto yy1464;
	goto yy1411;
yy1466:
	yych = *++cur;
	if (yych <= '/') goto yy1426;
	if (yych <= '9') goto yy1464;
	goto yy1426;
yy1467:
	++cur;
	goto yy1433;
yy1468:
	yych = *++cur;
	if (yych <= '/') goto yy1426;
	if (yych >= ':') goto yy1426;
yy1469:
	yyaccept = 1;
	yych = *(mar = ++cur);
	if (yych <= 'D') {
		if (yych <= '/') goto yy1415;
		if (yych <= '9') goto yy1469;
		goto yy1415;
	} else {
		if (yych <= 'E') goto yy1454;
		if (yych == 'e') goto yy1454;
		goto yy1415;
	}
}
#line 734 "tokenizer.re"

    }
}

} // namespace LFortran
